/*
 * ----------------------------------------------------------------------------
 * Copyright © 2009 by Mobile-Technologies Limited. All rights reserved. All intellectual property rights in and/or in
 * the computer program and its related documentation and technology are the sole Mobile-Technologies Limited property.
 * This computer program is under Mobile-Technologies Limited copyright and cannot be in whole or in part reproduced,
 * sublicensed, leased, sold or used in any form or by any means, including without limitation graphic, electronic,
 * mechanical, photocopying, recording, taping or information storage and retrieval systems without Mobile-Technologies
 * Limited prior written consent. The downloading, exporting or reexporting of this computer program or any related
 * documentation or technology is subject to any export rules, including US regulations.
 * ----------------------------------------------------------------------------
 */

import 'abstract_bean.dart';
import 'abstract_isl_req_metadata.dart';
import 'isl_req.dart';

abstract class AbstractIslReq extends AbstractBean implements IslReq {
  String trxId;
  int instanceId;
  int idCompany;
  DateTime createdDateTime;
  String locale;

  AbstractIslReq() {
    // nothing to do here
  }

  @override
  String getTrxId() {
    return trxId;
  }

  void setTrxId(String trxId) {
    this.trxId = trxId;
  }

  @override
  int getInstanceId() {
    return instanceId;
  }

  void setInstanceId(int instanceId) {
    this.instanceId = instanceId;
  }

  @override
  int getIdCompany() {
    return idCompany;
  }

  void setIdCompany(int idCompany) {
    this.idCompany = idCompany;
  }

  @override
  DateTime getCreatedDateTime() {
    return createdDateTime;
  }

  void setCreatedDateTime(DateTime createdDateTime) {
    this.createdDateTime = createdDateTime;
  }

  @override
  String getLocale() {
    return locale;
  }

  void setLocale(String locale) {
    this.locale = locale;
  }

  @override
  Set<String> getFields() => AbstractIslReqMetaData.getFields();

  @override
  dynamic getFieldValue(String field) =>
      AbstractIslReqMetaData.getFieldValue(field, this);
}
