/*
 * ----------------------------------------------------------------------------
 * Copyright © 2009 by Mobile-Technologies Limited. All rights reserved. All intellectual property rights in and/or in
 * the computer program and its related documentation and technology are the sole Mobile-Technologies Limited property.
 * This computer program is under Mobile-Technologies Limited copyright and cannot be in whole or in part reproduced,
 * sublicensed, leased, sold or used in any form or by any means, including without limitation graphic, electronic,
 * mechanical, photocopying, recording, taping or information storage and retrieval systems without Mobile-Technologies
 * Limited prior written consent. The downloading, exporting or reexporting of this computer program or any related
 * documentation or technology is subject to any export rules, including US regulations.
 * ----------------------------------------------------------------------------
 */

import '../../formalyze/generator/reader/xml_reader.dart';
import '../../formalyze/validation/converter/c_number.dart';
import 'abstract_isl_resp.dart';
import 'i_reflect.dart';
import 'register/response_message_metadata.dart';

abstract class AbstractIslRespMetaData {
  static const String trxId = "trxId";
  static const String instanceId = "instanceId";
  static const String idCompany = "idCompany";
  static const String respCode = "respCode";
  static const String respDesc = "respDesc";
  static const String customMessage = "customMessage";
  static const String arrayOptions = "arrayOptions";
  static const String data = "data";
  static const String createdDateTime = "createdDateTime";

  static Set<String> getFields() => {
        trxId,
        instanceId,
        idCompany,
        respCode,
        respDesc,
        customMessage,
        arrayOptions,
        data,
        createdDateTime
      };

  static dynamic getFieldValue(String field, AbstractIslResp abstractIslResp) {
    if (trxId == field) return abstractIslResp.getTrxId();
    if (instanceId == field) return abstractIslResp.getInstanceId();
    if (idCompany == field) return abstractIslResp.getIdCompany();
    if (respCode == field) return abstractIslResp.getRespCode();
    if (respDesc == field) return abstractIslResp.getRespDesc();
    if (customMessage == field) return abstractIslResp.getCustomMessage();
    if (arrayOptions == field) return abstractIslResp.getArrayOptions();
    if (data == field) return abstractIslResp.getData();
    if (createdDateTime == field) return abstractIslResp.getCreatedDateTime();

    return null;
  }

  static AbstractIslResp toBean(Map map, AbstractIslResp abstractIslResp) {
    abstractIslResp.trxId = map[trxId];
    abstractIslResp.instanceId = CNumber.parseNoErr(map[instanceId]);
    abstractIslResp.idCompany = CNumber.parseNoErr(map[idCompany]);
    abstractIslResp.respCode = CNumber.parseNoErr(map[respCode]);
    abstractIslResp.respDesc = map[respDesc];
    abstractIslResp.customMessage =
        ResponseMessageMetaData.toBean(map[customMessage]);
    abstractIslResp.arrayOptions = IReflect.transformMap__(map[arrayOptions]);
    abstractIslResp.data = IReflect.transformMap(map[data]);
    abstractIslResp.createdDateTime = XmlReader.toDate(map[createdDateTime]);
    return abstractIslResp;
  }
}
