/*
 * ----------------------------------------------------------------------------
 * Copyright © 2009 by Mobile-Technologies Limited. All rights reserved. All intellectual property rights in and/or in
 * the computer program and its related documentation and technology are the sole Mobile-Technologies Limited property.
 * This computer program is under Mobile-Technologies Limited copyright and cannot be in whole or in part reproduced,
 * sublicensed, leased, sold or used in any form or by any means, including without limitation graphic, electronic,
 * mechanical, photocopying, recording, taping or information storage and retrieval systems without Mobile-Technologies
 * Limited prior written consent. The downloading, exporting or reexporting of this computer program or any related
 * documentation or technology is subject to any export rules, including US regulations.
 * ----------------------------------------------------------------------------
 */

import '../abstract_isl_req_metadata.dart';
import 'new_version_req.dart';

abstract class NewVersionReqMetaData {
  static const String securityToken = "securityToken";
  static const String mposInfoData = "mposInfoData";

  static Set<String> getFields() {
    Set<String> fields = AbstractIslReqMetaData.getFields();
    fields.addAll({securityToken, mposInfoData});
    return fields;
  }

  static dynamic getFieldValue(String field, NewVersionReq newVersionReq) {
    if (securityToken == field) return newVersionReq.getSecurityToken();
    if (mposInfoData == field) return newVersionReq.getMposInfoData();

    return AbstractIslReqMetaData.getFieldValue(field, newVersionReq);
  }
}
