/*
 * ----------------------------------------------------------------------------
 * Copyright © 2009 by Mobile-Technologies Limited. All rights reserved. All intellectual property rights in and/or in
 * the computer program and its related documentation and technology are the sole Mobile-Technologies Limited property.
 * This computer program is under Mobile-Technologies Limited copyright and cannot be in whole or in part reproduced,
 * sublicensed, leased, sold or used in any form or by any means, including without limitation graphic, electronic,
 * mechanical, photocopying, recording, taping or information storage and retrieval systems without Mobile-Technologies
 * Limited prior written consent. The downloading, exporting or reexporting of this computer program or any related
 * documentation or technology is subject to any export rules, including US regulations.
 * ----------------------------------------------------------------------------
 */

import '../abstract_isl_req.dart';
import '../i_security_token.dart';
import '../register/mpos_info_data.dart';
import 'report_error_req_metadata.dart';

class ReportErrorReq extends AbstractIslReq implements ISecurityToken {
  String securityToken;
  String errorMessage;
  MposInfoData mposInfoData;

  ReportErrorReq();

  ReportErrorReq.full(this.securityToken, this.errorMessage) {
    this.securityToken = securityToken;
    this.errorMessage = errorMessage;
  }

  @override
  String getSecurityToken() {
    return securityToken;
  }

  void setSecurityToken(String securityToken) {
    this.securityToken = securityToken;
  }

  MposInfoData getMposInfoData() {
    return mposInfoData;
  }

  void setMposInfoData(MposInfoData mposInfoData) {
    this.mposInfoData = mposInfoData;
  }

  String getErrorMessage() {
    return errorMessage;
  }

  void setErrorMessage(String errorMessage) {
    this.errorMessage = errorMessage;
  }

  @override
  Set<String> getFields() => ReportErrorReqMetaData.getFields();

  @override
  dynamic getFieldValue(String field) =>
      ReportErrorReqMetaData.getFieldValue(field, this);
}
