/*
 * ----------------------------------------------------------------------------
 * Copyright © 2009 by Mobile-Technologies Limited. All rights reserved. All intellectual property rights in and/or in
 * the computer program and its related documentation and technology are the sole Mobile-Technologies Limited property.
 * This computer program is under Mobile-Technologies Limited copyright and cannot be in whole or in part reproduced,
 * sublicensed, leased, sold or used in any form or by any means, including without limitation graphic, electronic,
 * mechanical, photocopying, recording, taping or information storage and retrieval systems without Mobile-Technologies
 * Limited prior written consent. The downloading, exporting or reexporting of this computer program or any related
 * documentation or technology is subject to any export rules, including US regulations.
 * ----------------------------------------------------------------------------
 */

import '../../structure/string_object_map.dart';
import '../abstract_isl_req.dart';
import '../i_security_token.dart';
import '../register/mpos_info_data.dart';
import 'change_pw_req_metadata.dart';

class ChangePwReq extends AbstractIslReq implements ISecurityToken {
  String userName;
  String oldPassword; // MD5
  String newPassword; // MD5
  String hintQuestion;
  String hintAnswer;

  String securityToken;
  MposInfoData mPosInfoData;
  StringObjectMap map;
  bool forceChange;

  ChangePwReq() {
    map = StringObjectMap();
  }

  @override
  String getSecurityToken() {
    return securityToken;
  }

  void setSecurityToken(String securityToken) {
    this.securityToken = securityToken;
  }

  String getUserName() {
    return userName;
  }

  void setUserName(String userName) {
    this.userName = userName;
  }

  String getOldPassword() {
    return oldPassword;
  }

  void setOldPassword(String oldPassword) {
    this.oldPassword = oldPassword;
  }

  String getNewPassword() {
    return newPassword;
  }

  void setNewPassword(String newPassword) {
    this.newPassword = newPassword;
  }

  String getHintQuestion() {
    return hintQuestion;
  }

  void setHintQuestion(String hintQuestion) {
    this.hintQuestion = hintQuestion;
  }

  String getHintAnswer() {
    return hintAnswer;
  }

  void setHintAnswer(String hintAnswer) {
    this.hintAnswer = hintAnswer;
  }

  MposInfoData getmPosInfoData() {
    return mPosInfoData;
  }

  void setmPosInfoData(MposInfoData mPosInfoData) {
    this.mPosInfoData = mPosInfoData;
  }

  StringObjectMap getMap() {
    return map;
  }

  void setMap(StringObjectMap map) {
    this.map = map;
  }

  bool isForceChange() {
    return forceChange;
  }

  void setForceChange(bool forceChange) {
    this.forceChange = forceChange;
  }

  @override
  Set<String> getFields() => ChangePwReqMetaData.getFields();

  @override
  dynamic getFieldValue(String field) =>
      ChangePwReqMetaData.getFieldValue(field, this);
}
