/*
 * ----------------------------------------------------------------------------
 * Copyright © 2009 by Mobile-Technologies Limited. All rights reserved. All intellectual property rights in and/or in
 * the computer program and its related documentation and technology are the sole Mobile-Technologies Limited property.
 * This computer program is under Mobile-Technologies Limited copyright and cannot be in whole or in part reproduced,
 * sublicensed, leased, sold or used in any form or by any means, including without limitation graphic, electronic,
 * mechanical, photocopying, recording, taping or information storage and retrieval systems without Mobile-Technologies
 * Limited prior written consent. The downloading, exporting or reexporting of this computer program or any related
 * documentation or technology is subject to any export rules, including US regulations.
 * ----------------------------------------------------------------------------
 */

import '../abstract_isl_req_metadata.dart';
import 'change_pw_req.dart';

abstract class ChangePwReqMetaData {
  static const String userName = "userName";
  static const String oldPassword = "oldPassword";
  static const String newPassword = "newPassword";
  static const String hintQuestion = "hintQuestion";
  static const String hintAnswer = "hintAnswer";
  static const String securityToken = "securityToken";
  static const String mPosInfoData = "mPosInfoData";
  static const String map = "map";
  static const String forceChange = "forceChange";

  static Set<String> getFields() {
    Set<String> fields = AbstractIslReqMetaData.getFields();
    fields.addAll({
      userName,
      oldPassword,
      newPassword,
      hintQuestion,
      hintAnswer,
      securityToken,
      mPosInfoData,
      map,
      forceChange
    });
    return fields;
  }

  static dynamic getFieldValue(String field, ChangePwReq changePwReq) {
    if (userName == field) return changePwReq.getUserName();
    if (oldPassword == field) return changePwReq.getOldPassword();
    if (newPassword == field) return changePwReq.getNewPassword();
    if (hintQuestion == field) return changePwReq.getHintQuestion();
    if (hintAnswer == field) return changePwReq.getHintAnswer();
    if (securityToken == field) return changePwReq.getSecurityToken();
    if (mPosInfoData == field) return changePwReq.getmPosInfoData();
    if (map == field) return changePwReq.getMap();
    if (forceChange == field) return changePwReq.isForceChange();

    return AbstractIslReqMetaData.getFieldValue(field, changePwReq);
  }
}
