/*
 * ----------------------------------------------------------------------------
 * Copyright © 2009 by Mobile-Technologies Limited. All rights reserved. All intellectual property rights in and/or in
 * the computer program and its related documentation and technology are the sole Mobile-Technologies Limited property.
 * This computer program is under Mobile-Technologies Limited copyright and cannot be in whole or in part reproduced,
 * sublicensed, leased, sold or used in any form or by any means, including without limitation graphic, electronic,
 * mechanical, photocopying, recording, taping or information storage and retrieval systems without Mobile-Technologies
 * Limited prior written consent. The downloading, exporting or reexporting of this computer program or any related
 * documentation or technology is subject to any export rules, including US regulations.
 * ----------------------------------------------------------------------------
 */

import '../abstract_bean.dart';
import 'common_credential_bean_metadata.dart';

class CommonCredentialBean extends AbstractBean {
  String frequencyRetry;
  String freqWaitingToSend;
  String freqInprogress;
  String freqSuccess;
  String maxRetry;
  String maxRetryInprogress;
  String maxRetryUpgrade;
  String mposIP;
  String mposIPDate;
  String freqOfStats;
  String ticketPeriodValid;

  // Aradious switch IP
  String mposIPDateFormat;
  String bksUrl;
  String mposIPMD5;
  String retryDownloadCount;

  // ISL password regular expression
  String islPasswordRegex;

  int connectionTimeout;
  int readTimeout;

  // Max waiting to send transcation in mPos
  int maxWaitingToSend;

  Map<String, String> confMap;

  CommonCredentialBean() {
    confMap = {};
  }

  String getFrequencyRetry() {
    return frequencyRetry;
  }

  void setFrequencyRetry(String frequencyRetry) {
    this.frequencyRetry = frequencyRetry;
  }

  String getMaxRetry() {
    return maxRetry;
  }

  void setMaxRetry(String maxRetry) {
    this.maxRetry = maxRetry;
  }

  String getMaxRetryUpgrade() {
    return maxRetryUpgrade;
  }

  void setMaxRetryUpgrade(String maxRetryUpgrade) {
    this.maxRetryUpgrade = maxRetryUpgrade;
  }

  String getMposIP() {
    return mposIP;
  }

  void setMposIP(String mposIP) {
    this.mposIP = mposIP;
  }

  String getMposIPDate() {
    return mposIPDate;
  }

  void setMposIPDate(String mposIPDate) {
    this.mposIPDate = mposIPDate;
  }

  String getFreqOfStats() {
    return freqOfStats;
  }

  void setFreqOfStats(String freqOfStats) {
    this.freqOfStats = freqOfStats;
  }

  String getTicketPeriodValid() {
    return ticketPeriodValid;
  }

  void setTicketPeriodValid(String ticketPeriodValid) {
    this.ticketPeriodValid = ticketPeriodValid;
  }

  String getMposIPDateFormat() {
    return mposIPDateFormat;
  }

  void setMposIPDateFormat(String mposIPDateFormat) {
    this.mposIPDateFormat = mposIPDateFormat;
  }

  String getBksUrl() {
    return bksUrl;
  }

  void setBksUrl(String bksUrl) {
    this.bksUrl = bksUrl;
  }

  String getMposIPMD5() {
    return mposIPMD5;
  }

  void setMposIPMD5(String mposIPMD5) {
    this.mposIPMD5 = mposIPMD5;
  }

  String getRetryDownloadCount() {
    return retryDownloadCount;
  }

  void setRetryDownloadCount(String retryDownloadCount) {
    this.retryDownloadCount = retryDownloadCount;
  }

  String getIslPasswordRegex() {
    return islPasswordRegex;
  }

  void setIslPasswordRegex(String islPasswordRegex) {
    this.islPasswordRegex = islPasswordRegex;
  }

  int getConnectionTimeout() {
    return connectionTimeout;
  }

  void setConnectionTimeout(int connectionTimeout) {
    this.connectionTimeout = connectionTimeout;
  }

  int getReadTimeout() {
    return readTimeout;
  }

  void setReadTimeout(int readTimeout) {
    this.readTimeout = readTimeout;
  }

  Map<String, String> getConfMap() {
    return confMap;
  }

  void setConfMap(Map<String, String> confMap) {
    this.confMap = confMap;
  }

  int getMaxWaitingToSend() {
    return maxWaitingToSend;
  }

  void setMaxWaitingToSend(int maxWaitingToSend) {
    this.maxWaitingToSend = maxWaitingToSend;
  }

  String getFreqWaitingToSend() {
    return freqWaitingToSend;
  }

  void setFreqWaitingToSend(String freqWaitingToSend) {
    this.freqWaitingToSend = freqWaitingToSend;
  }

  String getFreqInprogress() {
    return freqInprogress;
  }

  void setFreqInprogress(String freqInprogress) {
    this.freqInprogress = freqInprogress;
  }

  String getFreqSuccess() {
    return freqSuccess;
  }

  void setFreqSuccess(String freqSuccess) {
    this.freqSuccess = freqSuccess;
  }

  String getMaxRetryInprogress() {
    return maxRetryInprogress;
  }

  void setMaxRetryInprogress(String maxRetryInprogress) {
    this.maxRetryInprogress = maxRetryInprogress;
  }

  @override
  Set<String> getFields() => CommonCredentialBeanMetaData.getFields();

  @override
  dynamic getFieldValue(String field) =>
      CommonCredentialBeanMetaData.getFieldValue(field, this);
}
