/*
 * ----------------------------------------------------------------------------
 * Copyright © 2009 by Mobile-Technologies Limited. All rights reserved. All intellectual property rights in and/or in
 * the computer program and its related documentation and technology are the sole Mobile-Technologies Limited property.
 * This computer program is under Mobile-Technologies Limited copyright and cannot be in whole or in part reproduced,
 * sublicensed, leased, sold or used in any form or by any means, including without limitation graphic, electronic,
 * mechanical, photocopying, recording, taping or information storage and retrieval systems without Mobile-Technologies
 * Limited prior written consent. The downloading, exporting or reexporting of this computer program or any related
 * documentation or technology is subject to any export rules, including US regulations.
 * ----------------------------------------------------------------------------
 */

import '../../../formalyze/validation/converter/c_number.dart';
import '../i_reflect.dart';
import 'common_credential_bean.dart';

abstract class CommonCredentialBeanMetaData {
  static const String frequencyRetry = "frequencyRetry";
  static const String freqWaitingToSend = "freqWaitingToSend";
  static const String freqInprogress = "freqInprogress";
  static const String freqSuccess = "freqSuccess";
  static const String maxRetry = "maxRetry";
  static const String maxRetryInprogress = "maxRetryInprogress";
  static const String maxRetryUpgrade = "maxRetryUpgrade";
  static const String mposIP = "mposIP";
  static const String mposIPDate = "mposIPDate";
  static const String freqOfStats = "freqOfStats";
  static const String ticketPeriodValid = "ticketPeriodValid";
  static const String mposIPDateFormat = "mposIPDateFormat";
  static const String bksUrl = "bksUrl";
  static const String mposIPMD5 = "mposIPMD5";
  static const String retryDownloadCount = "retryDownloadCount";
  static const String islPasswordRegex = "islPasswordRegex";
  static const String connectionTimeout = "connectionTimeout";
  static const String readTimeout = "readTimeout";
  static const String maxWaitingToSend = "maxWaitingToSend";
  static const String confMap = "confMap";

  static Set<String> getFields() => {
        frequencyRetry,
        freqWaitingToSend,
        freqInprogress,
        freqSuccess,
        maxRetry,
        maxRetryInprogress,
        maxRetryUpgrade,
        mposIP,
        mposIPDate,
        freqOfStats,
        ticketPeriodValid,
        mposIPDateFormat,
        bksUrl,
        mposIPMD5,
        retryDownloadCount,
        islPasswordRegex,
        connectionTimeout,
        readTimeout,
        maxWaitingToSend,
        confMap
      };

  static dynamic getFieldValue(
      String field, CommonCredentialBean commonCredentialBean) {
    if (frequencyRetry == field)
      return commonCredentialBean.getFrequencyRetry();
    if (freqWaitingToSend == field)
      return commonCredentialBean.getFreqWaitingToSend();
    if (freqInprogress == field)
      return commonCredentialBean.getFreqInprogress();
    if (freqSuccess == field) return commonCredentialBean.getFreqSuccess();
    if (maxRetry == field) return commonCredentialBean.getMaxRetry();
    if (maxRetryInprogress == field)
      return commonCredentialBean.getMaxRetryInprogress();
    if (maxRetryUpgrade == field)
      return commonCredentialBean.getMaxRetryUpgrade();
    if (mposIP == field) return commonCredentialBean.getMposIP();
    if (mposIPDate == field) return commonCredentialBean.getMposIPDate();
    if (freqOfStats == field) return commonCredentialBean.getFreqOfStats();
    if (ticketPeriodValid == field)
      return commonCredentialBean.getTicketPeriodValid();
    if (mposIPDateFormat == field)
      return commonCredentialBean.getMposIPDateFormat();
    if (bksUrl == field) return commonCredentialBean.getBksUrl();
    if (mposIPMD5 == field) return commonCredentialBean.getMposIPMD5();
    if (retryDownloadCount == field)
      return commonCredentialBean.getRetryDownloadCount();
    if (islPasswordRegex == field)
      return commonCredentialBean.getIslPasswordRegex();
    if (connectionTimeout == field)
      return commonCredentialBean.getConnectionTimeout();
    if (readTimeout == field) return commonCredentialBean.getReadTimeout();
    if (maxWaitingToSend == field)
      return commonCredentialBean.getMaxWaitingToSend();
    if (confMap == field) return commonCredentialBean.getConfMap();

    return null;
  }

  static CommonCredentialBean toBean(Map map) {
    if (map == null) {
      return null;
    }

    CommonCredentialBean commonCredentialBean = CommonCredentialBean();
    commonCredentialBean.frequencyRetry = map[frequencyRetry];
    commonCredentialBean.freqWaitingToSend = map[freqWaitingToSend];
    commonCredentialBean.freqInprogress = map[freqInprogress];
    commonCredentialBean.freqSuccess = map[freqSuccess];
    commonCredentialBean.maxRetry = map[maxRetry];
    commonCredentialBean.maxRetryInprogress = map[maxRetryInprogress];
    commonCredentialBean.maxRetryUpgrade = map[maxRetryUpgrade];
    commonCredentialBean.mposIP = map[mposIP];
    commonCredentialBean.mposIPDate = map[mposIPDate];
    commonCredentialBean.freqOfStats = map[freqOfStats];
    commonCredentialBean.ticketPeriodValid = map[ticketPeriodValid];
    commonCredentialBean.mposIPDateFormat = map[mposIPDateFormat];
    commonCredentialBean.bksUrl = map[bksUrl];
    commonCredentialBean.mposIPMD5 = map[mposIPMD5];
    commonCredentialBean.retryDownloadCount = map[retryDownloadCount];
    commonCredentialBean.islPasswordRegex = map[islPasswordRegex];
    commonCredentialBean.connectionTimeout =
        CNumber.parseNoErr(map[connectionTimeout]);
    commonCredentialBean.readTimeout = CNumber.parseNoErr(map[readTimeout]);
    commonCredentialBean.maxWaitingToSend =
        CNumber.parseNoErr(map[maxWaitingToSend]);
    commonCredentialBean.confMap = IReflect.transformMap(map[confMap]);
    return commonCredentialBean;
  }
}
