/*
 * ----------------------------------------------------------------------------
 * Copyright © 2009 by Mobile-Technologies Limited. All rights reserved. All intellectual property rights in and/or in
 * the computer program and its related documentation and technology are the sole Mobile-Technologies Limited property.
 * This computer program is under Mobile-Technologies Limited copyright and cannot be in whole or in part reproduced,
 * sublicensed, leased, sold or used in any form or by any means, including without limitation graphic, electronic,
 * mechanical, photocopying, recording, taping or information storage and retrieval systems without Mobile-Technologies
 * Limited prior written consent. The downloading, exporting or reexporting of this computer program or any related
 * documentation or technology is subject to any export rules, including US regulations.
 * ----------------------------------------------------------------------------
 */

import 'dart:typed_data' show Uint8List;

import '../../structure/string_object_map.dart';
import '../abstract_isl_req.dart';
import '../master_data_version_bean.dart';
import '../register/mpos_info_data.dart';
import 'credential_validation_req_metadata.dart';
import 'registered_fp.dart';

class CredentialValidationReq extends AbstractIslReq {
  String userName;
  String password; // MD5
  Uint8List passwordEncrypted; // AES256

  int appId;
  MposInfoData mPosInfoData;
  StringObjectMap map;
  List<MasterDataVersionBean> formVersions; // for multiple forms
  RegisteredFP registeredFP;

  CredentialValidationReq() {
    map = StringObjectMap();
  }

  String getUserName() {
    return userName;
  }

  void setUserName(String userName) {
    this.userName = userName;
  }

  String getPassword() {
    return password;
  }

  void setPassword(String password) {
    this.password = password;
  }

  Uint8List getPasswordEncrypted() {
    return passwordEncrypted;
  }

  void setPasswordEncrypted(Uint8List passwordEncrypted) {
    this.passwordEncrypted = passwordEncrypted;
  }

  StringObjectMap getMap() {
    return map;
  }

  void setMap(StringObjectMap map) {
    this.map = map;
  }

  List<MasterDataVersionBean> getFormVersions() {
    return formVersions;
  }

  void setFormVersions(List<MasterDataVersionBean> formVersions) {
    this.formVersions = formVersions;
  }

  MposInfoData getmPosInfoData() {
    return mPosInfoData;
  }

  void setmPosInfoData(MposInfoData mPosInfoData) {
    this.mPosInfoData = mPosInfoData;
  }

  int getAppId() {
    return appId;
  }

  void setAppId(int appId) {
    this.appId = appId;
  }

  RegisteredFP getRegisteredFP() {
    return registeredFP;
  }

  void setRegisteredFP(RegisteredFP registeredFP) {
    this.registeredFP = registeredFP;
  }

  @override
  Set<String> getFields() => CredentialValidationReqMetaData.getFields();

  @override
  dynamic getFieldValue(String field) =>
      CredentialValidationReqMetaData.getFieldValue(field, this);
}
