/*
 * ----------------------------------------------------------------------------
 * Copyright © 2009 by Mobile-Technologies Limited. All rights reserved. All intellectual property rights in and/or in
 * the computer program and its related documentation and technology are the sole Mobile-Technologies Limited property.
 * This computer program is under Mobile-Technologies Limited copyright and cannot be in whole or in part reproduced,
 * sublicensed, leased, sold or used in any form or by any means, including without limitation graphic, electronic,
 * mechanical, photocopying, recording, taping or information storage and retrieval systems without Mobile-Technologies
 * Limited prior written consent. The downloading, exporting or reexporting of this computer program or any related
 * documentation or technology is subject to any export rules, including US regulations.
 * ----------------------------------------------------------------------------
 */

import '../abstract_isl_req_metadata.dart';
import 'credential_validation_req.dart';

abstract class CredentialValidationReqMetaData {
  static const String userName = "userName";
  static const String password = "password";
  static const String passwordEncrypted = "passwordEncrypted";
  static const String appId = "appId";
  static const String mPosInfoData = "mPosInfoData";
  static const String map = "map";
  static const String formVersions = "formVersions";
  static const String registeredFP = "registeredFP";

  static Set<String> getFields() {
    Set<String> fields = AbstractIslReqMetaData.getFields();
    fields.addAll({
      userName,
      password,
      passwordEncrypted,
      appId,
      mPosInfoData,
      map,
      formVersions,
      registeredFP
    });
    return fields;
  }

  static dynamic getFieldValue(
      String field, CredentialValidationReq credentialValidationReq) {
    if (userName == field) return credentialValidationReq.getUserName();
    if (password == field) return credentialValidationReq.getPassword();
    if (passwordEncrypted == field)
      return credentialValidationReq.getPasswordEncrypted();
    if (appId == field) return credentialValidationReq.getAppId();
    if (mPosInfoData == field) return credentialValidationReq.getmPosInfoData();
    if (map == field) return credentialValidationReq.getMap();
    if (formVersions == field) return credentialValidationReq.getFormVersions();
    if (registeredFP == field) return credentialValidationReq.getRegisteredFP();

    return AbstractIslReqMetaData.getFieldValue(field, credentialValidationReq);
  }
}
