/*
 * ----------------------------------------------------------------------------
 * Copyright © 2009 by Mobile-Technologies Limited. All rights reserved. All intellectual property rights in and/or in
 * the computer program and its related documentation and technology are the sole Mobile-Technologies Limited property.
 * This computer program is under Mobile-Technologies Limited copyright and cannot be in whole or in part reproduced,
 * sublicensed, leased, sold or used in any form or by any means, including without limitation graphic, electronic,
 * mechanical, photocopying, recording, taping or information storage and retrieval systems without Mobile-Technologies
 * Limited prior written consent. The downloading, exporting or reexporting of this computer program or any related
 * documentation or technology is subject to any export rules, including US regulations.
 * ----------------------------------------------------------------------------
 */

import '../../structure/string_object_map.dart';
import '../abstract_isl_req.dart';
import '../register/mpos_info_data.dart';
import 'forget_pw_req_metadata.dart';

class ForgetPwReq extends AbstractIslReq {
  String userName;
  String hintQuestion;
  String hintAnswer;

  MposInfoData mPosInfoData;
  StringObjectMap map;

  ForgetPwReq() {
    map = StringObjectMap();
  }

  String getUserName() {
    return userName;
  }

  void setUserName(String userName) {
    this.userName = userName;
  }

  String getHintQuestion() {
    return hintQuestion;
  }

  void setHintQuestion(String hintQuestion) {
    this.hintQuestion = hintQuestion;
  }

  String getHintAnswer() {
    return hintAnswer;
  }

  void setHintAnswer(String hintAnswer) {
    this.hintAnswer = hintAnswer;
  }

  MposInfoData getmPosInfoData() {
    return mPosInfoData;
  }

  void setmPosInfoData(MposInfoData mPosInfoData) {
    this.mPosInfoData = mPosInfoData;
  }

  StringObjectMap getMap() {
    return map;
  }

  void setMap(StringObjectMap map) {
    this.map = map;
  }

  @override
  Set<String> getFields() => ForgetPwReqMetaData.getFields();

  @override
  dynamic getFieldValue(String field) =>
      ForgetPwReqMetaData.getFieldValue(field, this);
}
