/*
 * ----------------------------------------------------------------------------
 * Copyright © 2009 by Mobile-Technologies Limited. All rights reserved. All intellectual property rights in and/or in
 * the computer program and its related documentation and technology are the sole Mobile-Technologies Limited property.
 * This computer program is under Mobile-Technologies Limited copyright and cannot be in whole or in part reproduced,
 * sublicensed, leased, sold or used in any form or by any means, including without limitation graphic, electronic,
 * mechanical, photocopying, recording, taping or information storage and retrieval systems without Mobile-Technologies
 * Limited prior written consent. The downloading, exporting or reexporting of this computer program or any related
 * documentation or technology is subject to any export rules, including US regulations.
 * ----------------------------------------------------------------------------
 */

import 'dart:typed_data' show Uint8List;

import '../abstract_bean.dart';
import '../register/response_message.dart';
import 'form_detail_bean_metadata.dart';

class FormDetailBean extends AbstractBean {
  int formId;
  int trxTypeId;
  int modelFormVersion;
  Uint8List modelForm;
  int uiFormVersion;
  Uint8List uiForm;
  int i18nFormVersion;
  Uint8List i18nForm;

  int order;

  ResponseMessage menu;
  ResponseMessage history;

  FormDetailBean() : super();

  int getFormId() {
    return formId;
  }

  void setFormId(int formId) {
    this.formId = formId;
  }

  Uint8List getModelForm() {
    return modelForm;
  }

  void setModelForm(Uint8List modelForm) {
    this.modelForm = modelForm;
  }

  Uint8List getUiForm() {
    return uiForm;
  }

  void setUiForm(Uint8List uiForm) {
    this.uiForm = uiForm;
  }

  Uint8List getI18nForm() {
    return i18nForm;
  }

  void setI18nForm(Uint8List i18nForm) {
    this.i18nForm = i18nForm;
  }

  int getModelFormVersion() {
    return modelFormVersion;
  }

  void setModelFormVersion(int modelFormVersion) {
    this.modelFormVersion = modelFormVersion;
  }

  int getUiFormVersion() {
    return uiFormVersion;
  }

  void setUiFormVersion(int uiFormVersion) {
    this.uiFormVersion = uiFormVersion;
  }

  int getI18nFormVersion() {
    return i18nFormVersion;
  }

  void setI18nFormVersion(int i18nFormVersion) {
    this.i18nFormVersion = i18nFormVersion;
  }

  ResponseMessage getMenu() {
    return menu;
  }

  void setMenu(ResponseMessage menu) {
    this.menu = menu;
  }

  ResponseMessage getHistory() {
    return history;
  }

  void setHistory(ResponseMessage history) {
    this.history = history;
  }

  int getTrxTypeId() {
    return trxTypeId;
  }

  void setTrxTypeId(int trxTypeId) {
    this.trxTypeId = trxTypeId;
  }

  int getOrder() {
    return order;
  }

  void setOrder(int order) {
    this.order = order;
  }

  @override
  String getXmlTag() => 'formDetail';

  @override
  Set<String> getFields() => FormDetailBeanMetaData.getFields();

  @override
  dynamic getFieldValue(String field) =>
      FormDetailBeanMetaData.getFieldValue(field, this);
}
