/*
 * ----------------------------------------------------------------------------
 * Copyright © 2009 by Mobile-Technologies Limited. All rights reserved. All intellectual property rights in and/or in
 * the computer program and its related documentation and technology are the sole Mobile-Technologies Limited property.
 * This computer program is under Mobile-Technologies Limited copyright and cannot be in whole or in part reproduced,
 * sublicensed, leased, sold or used in any form or by any means, including without limitation graphic, electronic,
 * mechanical, photocopying, recording, taping or information storage and retrieval systems without Mobile-Technologies
 * Limited prior written consent. The downloading, exporting or reexporting of this computer program or any related
 * documentation or technology is subject to any export rules, including US regulations.
 * ----------------------------------------------------------------------------
 */

import '../../../formalyze/util/base64.dart';
import '../../../formalyze/validation/converter/c_number.dart';
import '../register/response_message_metadata.dart';
import 'form_detail_bean.dart';

abstract class FormDetailBeanMetaData {
  static const String formId = "formId";
  static const String trxTypeId = "trxTypeId";
  static const String modelFormVersion = "modelFormVersion";
  static const String modelForm = "modelForm";
  static const String uiFormVersion = "uiFormVersion";
  static const String uiForm = "uiForm";
  static const String i18nFormVersion = "i18nFormVersion";
  static const String i18nForm = "i18nForm";
  static const String order = "order";
  static const String menu = "menu";
  static const String history = "history";

  static Set<String> getFields() => {
        formId,
        trxTypeId,
        modelFormVersion,
        modelForm,
        uiFormVersion,
        uiForm,
        i18nFormVersion,
        i18nForm,
        order,
        menu,
        history
      };

  static dynamic getFieldValue(String field, FormDetailBean formDetailBean) {
    if (formId == field) return formDetailBean.getFormId();
    if (trxTypeId == field) return formDetailBean.getTrxTypeId();
    if (modelFormVersion == field) return formDetailBean.getModelFormVersion();
    if (modelForm == field) return formDetailBean.getModelForm();
    if (uiFormVersion == field) return formDetailBean.getUiFormVersion();
    if (uiForm == field) return formDetailBean.getUiForm();
    if (i18nFormVersion == field) return formDetailBean.getI18nFormVersion();
    if (i18nForm == field) return formDetailBean.getI18nForm();
    if (order == field) return formDetailBean.getOrder();
    if (menu == field) return formDetailBean.getMenu();
    if (history == field) return formDetailBean.getHistory();

    return null;
  }

  static FormDetailBean toBean(Map map) {
    if (map == null) {
      return null;
    }

    FormDetailBean formDetailBean = FormDetailBean();
    formDetailBean.formId = CNumber.parseNoErr(map[formId]);
    formDetailBean.trxTypeId = CNumber.parseNoErr(map[trxTypeId]);
    formDetailBean.modelFormVersion = CNumber.parseNoErr(map[modelFormVersion]);
    formDetailBean.modelForm = Base64.decode(map[modelForm]);
    formDetailBean.uiFormVersion = CNumber.parseNoErr(map[uiFormVersion]);
    formDetailBean.uiForm = Base64.decode(map[uiForm]);
    formDetailBean.i18nFormVersion = CNumber.parseNoErr(map[i18nFormVersion]);
    formDetailBean.i18nForm = Base64.decode(map[i18nForm]);
    formDetailBean.order = CNumber.parseNoErr(map[order]);
    formDetailBean.menu = ResponseMessageMetaData.toBean(map[menu]);
    formDetailBean.history = ResponseMessageMetaData.toBean(map[history]);
    return formDetailBean;
  }
}
