/*
 * ----------------------------------------------------------------------------
 * Copyright © 2009 by Mobile-Technologies Limited. All rights reserved. All intellectual property rights in and/or in
 * the computer program and its related documentation and technology are the sole Mobile-Technologies Limited property.
 * This computer program is under Mobile-Technologies Limited copyright and cannot be in whole or in part reproduced,
 * sublicensed, leased, sold or used in any form or by any means, including without limitation graphic, electronic,
 * mechanical, photocopying, recording, taping or information storage and retrieval systems without Mobile-Technologies
 * Limited prior written consent. The downloading, exporting or reexporting of this computer program or any related
 * documentation or technology is subject to any export rules, including US regulations.
 * ----------------------------------------------------------------------------
 */

import 'dart:typed_data' show Uint8List;

import '../i_reflect.dart';
import 'registered_fp_metadata.dart';

class RegisteredFP extends IReflect {
  String username;
  Uint8List fingerprint;

  RegisteredFP() : this.full(null, null);

  RegisteredFP.full(this.username, this.fingerprint);

  String getUsername() {
    return username;
  }

  void setUsername(String username) {
    this.username = username;
  }

  Uint8List getFingerprint() {
    return fingerprint;
  }

  void setFingerprint(Uint8List fingerprint) {
    this.fingerprint = fingerprint;
  }

  @override
  Set<String> getFields() => RegisteredFPMetaData.getFields();

  @override
  dynamic getFieldValue(String field) =>
      RegisteredFPMetaData.getFieldValue(field, this);
}
