/*
 * ----------------------------------------------------------------------------
 * Copyright © 2009 by Mobile-Technologies Limited. All rights reserved. All intellectual property rights in and/or in
 * the computer program and its related documentation and technology are the sole Mobile-Technologies Limited property.
 * This computer program is under Mobile-Technologies Limited copyright and cannot be in whole or in part reproduced,
 * sublicensed, leased, sold or used in any form or by any means, including without limitation graphic, electronic,
 * mechanical, photocopying, recording, taping or information storage and retrieval systems without Mobile-Technologies
 * Limited prior written consent. The downloading, exporting or reexporting of this computer program or any related
 * documentation or technology is subject to any export rules, including US regulations.
 * ----------------------------------------------------------------------------
 */

import '../../../formalyze/util/base64.dart';
import 'registered_fp.dart';

abstract class RegisteredFPMetaData {
  static const String username = "username";
  static const String fingerprint = "fingerprint";

  static Set<String> getFields() => {username, fingerprint};

  static dynamic getFieldValue(String field, RegisteredFP registeredFP) {
    if (username == field) return registeredFP.getUsername();
    if (fingerprint == field) return registeredFP.getFingerprint();

    return null;
  }

  static RegisteredFP toBean(Map map) {
    return map == null
        ? null
        : RegisteredFP.full(map[username], Base64.decode(map[fingerprint]));
  }
}
