/*
 * ----------------------------------------------------------------------------
 * Copyright © 2009 by Mobile-Technologies Limited. All rights reserved. All intellectual property rights in and/or in
 * the computer program and its related documentation and technology are the sole Mobile-Technologies Limited property.
 * This computer program is under Mobile-Technologies Limited copyright and cannot be in whole or in part reproduced,
 * sublicensed, leased, sold or used in any form or by any means, including without limitation graphic, electronic,
 * mechanical, photocopying, recording, taping or information storage and retrieval systems without Mobile-Technologies
 * Limited prior written consent. The downloading, exporting or reexporting of this computer program or any related
 * documentation or technology is subject to any export rules, including US regulations.
 * ----------------------------------------------------------------------------
 */

import '../abstract_bean.dart';
import 'version_bean_metadata.dart';

class VersionBean extends AbstractBean {
  String code;
  String name;
  String url;
  String checksum;
  String iOSAppId;
  String iOSCode;

  VersionBean();

  VersionBean.basic(this.code, this.name);

  VersionBean.full(this.code, this.name, this.url, this.checksum, this.iOSAppId,
      this.iOSCode);

  String getCode() {
    return code;
  }

  void setCode(String code) {
    this.code = code;
  }

  String getName() {
    return name;
  }

  void setName(String name) {
    this.name = name;
  }

  String getUrl() {
    return url;
  }

  void setUrl(String url) {
    this.url = url;
  }

  String getChecksum() {
    return checksum;
  }

  void setChecksum(String checksum) {
    this.checksum = checksum;
  }

  String getIOSAppId() {
    return iOSAppId;
  }

  void setIOSAppId(String iOSAppId) {
    this.iOSAppId = iOSAppId;
  }

  String getIOSCode() {
    return iOSCode;
  }

  void setIOSCode(String iOSCode) {
    this.iOSCode = iOSCode;
  }

  @override
  String getXmlTag() => 'versionDetail';

  @override
  Set<String> getFields() => VersionBeanMetaData.getFields();

  @override
  dynamic getFieldValue(String field) =>
      VersionBeanMetaData.getFieldValue(field, this);
}
