/*
 * ----------------------------------------------------------------------------
 * Copyright © 2009 by Mobile-Technologies Limited. All rights reserved. All intellectual property rights in and/or in
 * the computer program and its related documentation and technology are the sole Mobile-Technologies Limited property.
 * This computer program is under Mobile-Technologies Limited copyright and cannot be in whole or in part reproduced,
 * sublicensed, leased, sold or used in any form or by any means, including without limitation graphic, electronic,
 * mechanical, photocopying, recording, taping or information storage and retrieval systems without Mobile-Technologies
 * Limited prior written consent. The downloading, exporting or reexporting of this computer program or any related
 * documentation or technology is subject to any export rules, including US regulations.
 * ----------------------------------------------------------------------------
 */

import 'version_bean.dart';

abstract class VersionBeanMetaData {
  static const String code = "code";
  static const String name = "name";
  static const String url = "url";
  static const String checksum = "checksum";
  static const String iOSAppId = "iOSAppId";
  static const String iOSCode = "iOSCode";

  static Set<String> getFields() =>
      {code, name, url, checksum, iOSAppId, iOSCode};

  static dynamic getFieldValue(String field, VersionBean versionBean) {
    if (code == field) return versionBean.getCode();
    if (name == field) return versionBean.getName();
    if (url == field) return versionBean.getUrl();
    if (checksum == field) return versionBean.getChecksum();
    if (iOSAppId == field) return versionBean.getIOSAppId();
    if (iOSCode == field) return versionBean.getIOSCode();

    return null;
  }

  static VersionBean toBean(Map map) {
    return map == null
        ? null
        : VersionBean.full(map[code], map[name], map[url], map[checksum],
            map[iOSAppId], map[iOSCode]);
  }
}
