/*
 * ----------------------------------------------------------------------------
 * Copyright © 2009 by Mobile-Technologies Limited. All rights reserved. All intellectual property rights in and/or in
 * the computer program and its related documentation and technology are the sole Mobile-Technologies Limited property.
 * This computer program is under Mobile-Technologies Limited copyright and cannot be in whole or in part reproduced,
 * sublicensed, leased, sold or used in any form or by any means, including without limitation graphic, electronic,
 * mechanical, photocopying, recording, taping or information storage and retrieval systems without Mobile-Technologies
 * Limited prior written consent. The downloading, exporting or reexporting of this computer program or any related
 * documentation or technology is subject to any export rules, including US regulations.
 * ----------------------------------------------------------------------------
 */

import 'i_server_response_code.dart';

class BaseServerResponseCode implements IServerResponseCode {
  static final Map<int, IServerResponseCode> ENUMS_MAP = {};

  // Response code & description for undefined result
  static final IServerResponseCode UNDEFINED =
      getInstance(-1, "Trx status is undefined");

  // Response code & description for processing result
  static final IServerResponseCode PROCESSING =
      getInstance(100, "The transaction is being processed.");

  // Response code & description for cont101 result
  static final IServerResponseCode CONT101 = getInstance(
      101, "The transaction need to be continued by adding subscriber data.");

  // Response code & description for cont102 result
  static final IServerResponseCode CONT102 = getInstance(
      102, "The transaction need to be continued by adding POID document.");

  // Response code & description for cont103 result
  static final IServerResponseCode CONT103 = getInstance(103,
      "The transaction need to be continued by adding registration form document.");

  // Response code & description for cont104 result
  static final IServerResponseCode CONT104 =
      getInstance(104, "The transaction is being processed by another TRX.");

  // Response code & description for cont105 result
  static final IServerResponseCode CONT105 = getInstance(
      105, "The transaction need to be continued by adding subscriber image.");

  // Response code & description for cont105 result
  static final IServerResponseCode CONT110 = getInstance(
      110, "The transaction is waiting for primary msisdn to be success.");

  // Response code & description for cont111 result
  static final IServerResponseCode CONT111 = getInstance(111,
      "The transaction is received by the ESB and waiting for customer id.");

  // Response code & description for cont112 result
  static final IServerResponseCode CONT112 = getInstance(112,
      "The transaction is received by the server and waiting for provision status.");

  // Response code & description for success result
  static final IServerResponseCode SUCCESS =
      getInstance(200, "The trx is success on the server");

  static final IServerResponseCode PARTIAL_SUCCESS =
      getInstance(201, "he trx is partial success on the serverr");

  // Response code & description for accepted result
  static final IServerResponseCode ACCEPTED =
      getInstance(202, "The trx is accepted on the server");

  // Response code & description for msisdn occupied result
  static final IServerResponseCode MSISDN_OCCUPIED = getInstance(
      205, "MSISDN belonging to this TRX has been registered by another TRX");

  // Response code & description for poid occupied result
  static final IServerResponseCode POID_OCCUPIED = getInstance(
      206, "POID belonging to this TRX has been registered by another TRX");

  // Response code & description for Provisioning is deactivate success
  static final IServerResponseCode PROVISION_DEACTIVATE_SUCCESS =
      getInstance(208, "Provisioning is deactivate success");

  // Response code & description for Provisioning is active success
  static final IServerResponseCode PROVISION_ACTIVATE_SUCCESS =
      getInstance(209, "Provisioning is active success");

  static final IServerResponseCode TRX_ACCEPTED =
      getInstance(210, "The trx is accepted on the server");

  // Response code & description for unsuspense all
  static final IServerResponseCode UNSUSPENSE_ALL =
      getInstance(212, "unsuspense all");

  // Response code & description for timeout result
  static final IServerResponseCode REQ_TIMEOUT =
      getInstance(301, "Request Time out with communicate module");

  // Response code & description for failed result
  static final IServerResponseCode FAILED =
      getInstance(401, "The trx is failed on the server");

  // Response code & description for ICCID and MSISDN not match result
  static final IServerResponseCode ICCID_MSISDN_NOT_MATCH =
      getInstance(402, "ICCID and MSISDN not match for this trx");

  // Response code & description for cancelled result
  static final IServerResponseCode CANCELED =
      getInstance(403, "The trx is cancelled on the server");

  // Response code & description for cancelled result
  static final IServerResponseCode NOT_FOUND =
      getInstance(404, "MSISDN not found on the server");

  // Response code & The transactoin is reject
  static final IServerResponseCode REJECT =
      getInstance(405, "The transactoin is rejected");

  // Response code & The transactoin is reject
  static final IServerResponseCode BLOCK =
      getInstance(406, "The Transaction is block");

  // Response code for session time out
  static final IServerResponseCode SEC_TOKEN_TIMEOUT =
      getInstance(409, "The session time out");

  // Response code for customer registration is over limit
  static final IServerResponseCode REG_SAME_CUST_OVER_LIMIT =
      getInstance(410, "Registration in same customer is over limit.");

  // Response code & description for internal error result
  static final IServerResponseCode INT_ERR =
      getInstance(500, "The trx is facing internal error");

  // Response code & description for bad reg result
  static final IServerResponseCode BAD_REQ =
      getInstance(501, "Failed on contents validation");

  // blocked
  static final IServerResponseCode USER_IS_BLOCKED = getInstance(
      502, "User account has been blocked, please contact administrator");

  // Response code & description for service unavailable result
  static final IServerResponseCode SERVICE_UNAVAL =
      getInstance(503, "Service unavailable");

  // Response code & description for service unavailable result
  static final IServerResponseCode USER_INACTIVE =
      getInstance(504, "User account inactive, please contact administrator.");

  // Response code & description for external error result
  static final IServerResponseCode EXT_ERR =
      getInstance(505, "The trx is facing external error");

  // Response code & description for provision error result
  static final IServerResponseCode PROVISION_ACTIVATE_ERR =
      getInstance(506, "Provisioning is active error");

  // Response code & description for SMT is active error result
  static final IServerResponseCode SMT_ACTIVATE_ERROR_ERR =
      getInstance(507, "SMT is active error");

  // Response code & description for Provisioning is deactive error result
  static final IServerResponseCode PROVISION_DEACTIVATE_ERR =
      getInstance(508, "Provisioning is deactive error");

  // Response code & description for Provisioning is SMT is deactive error result
  static final IServerResponseCode SMT_DEACTIVATE_ERR =
      getInstance(509, "SMT_DEACTIVATE_ERR");

  // Response code & description for Re-Provisioining error
  static final IServerResponseCode RE_PROVISION_ERR =
      getInstance(511, "RE_PROVISION_ERR");

  // Response code & description for Re-Activate SMT error
  static final IServerResponseCode RE_ACTIVATE_SMT_ERR =
      getInstance(512, "RE_ACTIVATE_SMT_ERR");

  // Response code & description for invalid Active Directory user result
  static final IServerResponseCode USER_INVALID_ACTIVE_DIR = getInstance(
      513, "Error validating username / password from Active Directory");

  // Response code & description for external error result
  static final IServerResponseCode PASSWORD_INVALID =
      getInstance(601, "Invalid password");

  // Response code & description for external error result
  static final IServerResponseCode PASSWORD_EXPIRED =
      getInstance(602, "User password expired, please enter password.");

  // Response code & description for external error result
  static final IServerResponseCode IMEI_NOT_AUTHORIZED = getInstance(603,
      "Sorry, this device is not authorized to be used with mPOS. Please contact administrator.");

  // Response code & description for external error result
  static final IServerResponseCode IMEI_NOT_MATCHED = getInstance(604,
      "Your mobile device is not matched with you registered. Please contact administrator");

  static final IServerResponseCode USER_NOT_AUTHORIZED = getInstance(
      605, "Access denie. User not authorized to access this module.");

  static final IServerResponseCode USER_NOT_LINKED = getInstance(606,
      "User account is not associated with supplier/distribution channel. Please contact administrator");

  static final IServerResponseCode CHANNEL_SUPPLIER_INACTIVE = getInstance(
      607, "Supplier/Channel which this user is associated to, is Inactive");

  static final IServerResponseCode CHANNEL_SUPPLIER_BLOCKED = getInstance(
      608, "Supplier/Channel which this user is associated to, is Blocked");

  static final IServerResponseCode USER_NOT_EXIST =
      getInstance(609, "Invalid username. Please contact administrator");

  static final IServerResponseCode FORCE_CHANGE_PASSWORD =
      getInstance(610, "User must change password");

  // status code Return for Change Password Method
  // Response code & description for Failed to duplicate password same as 3 previous. Status is
  static final IServerResponseCode PASSWORD_SAME_AS_PREVIOUS = getInstance(611,
      "Your password is duplicate with previous one. Please choose a Password");

  static final IServerResponseCode AUTO_EXTEND_OFF =
      getInstance(612, "User password expired, please contact administrator.");

  static final IServerResponseCode USER_MAX_RETRY_ATTEMPT = getInstance(613,
      "Max number of password retries exceeded, please contact administrator.");

  // Status code for forget password.
  static final IServerResponseCode IMEI_INACTIVE =
      getInstance(614, "IMEI not active. Please contact administrator.");

  static final IServerResponseCode WRONG_HINTS_QUEST_ANS =
      getInstance(615, "Mismatch Hints question and answer.");

  static final IServerResponseCode CANNOT_ACCESS_DB =
      getInstance(666, "Database is not accessible at the moment.");

  /// iSM response code
  static final IServerResponseCode NO_NUMBER_MATCHING =
      getInstance(621, "No numbers matching the selection.");

  static final IServerResponseCode MSISDN_GROUP_DOES_NOT_EXIST =
      getInstance(622, "MSISDN group does not exist.");

  static final IServerResponseCode SIM_INFO_DOES_NOT_EXIST =
      getInstance(623, "SIM information does not exist.");

  static final IServerResponseCode MSISDN_IS_MAPPED =
      getInstance(624, "MSISDN is currently mapped.");

  static final IServerResponseCode MSISDN_INFO_NOT_EXIST =
      getInstance(625, "MSISDN information does not exist.");

  static final IServerResponseCode MSISDN_NOT_CORRECT_STATUS =
      getInstance(626, "MSISDN is not in the correct status.");

  static final IServerResponseCode MSISDN_NOT_RESERVED = getInstance(
      627, "MSISDN was not reserved with the correct reservation ID.");

  static final IServerResponseCode MSISDN_IS_RESERVED = getInstance(628,
      "MSISDN has been reserved. Please send the request with the associated reservation ID..");

  static final IServerResponseCode MSISDN_MULTIPLE_SIM = getInstance(
      629, "Please provide ICCID and IMSI as MSISDN paired with multiple SIMs");

  static final IServerResponseCode MSISDN_EXISTS =
      getInstance(630, "MSISDN exists in our system");

  static final IServerResponseCode RECORD_STATUS =
      getInstance(631, "Record is not in the correct status");

  static final IServerResponseCode MSISDN_IS_SELECTED =
      getInstance(632, "MSISDN has been selected previously.");

  static final IServerResponseCode IMSI_COUNT_MISMATCHED =
      getInstance(633, "IMSI count for old and SIM does not match.");

  static final IServerResponseCode INVALID_DEVICE_TIME = getInstance(634,
      "Device time is not synced with server. Please change date time in setting.");

  /// 670 series for non-mPOS
  static final IServerResponseCode USR_IS_LINED =
      getInstance(670, "Administrator account is required for login.");

  // Response code & description for authorized failed result
  static final IServerResponseCode AUTHORIZED_FAILED =
      getInstance(701, "The trx get forced to become failed");

  // Response code for authorized success result
  static final IServerResponseCode AUTHORIZED_SUCCESS =
      getInstance(800, "The Trx get forced to become Success");

  final int code;
  final String name;

  BaseServerResponseCode()
      : this.codeName(UNDEFINED.getCode(), UNDEFINED.getName());

  BaseServerResponseCode.codeName(this.code, this.name);

  static BaseServerResponseCode getInstance(int code, String name) {
    BaseServerResponseCode responseCode =
        BaseServerResponseCode.codeName(code, name);
    ENUMS_MAP[code] = responseCode;
    return responseCode;
  }

  static IServerResponseCode fromCode(int code) {
    if (code != null) {
      IServerResponseCode matched = ENUMS_MAP[code];
      if (matched != null) {
        return matched;
      }
    }

    return UNDEFINED;
  }

  @override
  bool matchWith(List<IServerResponseCode> codes) {
    if (codes == null || codes.length == 0) {
      return false;
    }
    for (IServerResponseCode iServerResponseCode in codes) {
      if (this == iServerResponseCode) {
        return true;
      }
    }
    return false;
  }

  @override
  int getCode() {
    return code;
  }

  @override
  int getCodeInt() {
    return code;
  }

  @override
  String getName() {
    return name;
  }

  @override
  String toString() => "$name - $code";

  @override
  int get hashCode {
    const int prime = 31;
    int result = 1;
    result = prime * result + (code == null ? 0 : code.hashCode);
    return result;
  }

  @override
  bool operator ==(Object obj) {
    if (identical(this, obj)) {
      return true;
    }
    if (obj == null) {
      return false;
    }
    if (runtimeType != obj.runtimeType) {
      return false;
    }

    // ignore: test_types_in_equals
    IServerResponseCode other = obj as IServerResponseCode;
    if (code == null) {
      if (other.getCode() != null) {
        return false;
      }
    } else if (code != other.getCode()) {
      return false;
    }

    return true;
  }
}
