/*
 * ----------------------------------------------------------------------------
 * Copyright © 2009 by Mobile-Technologies Limited. All rights reserved. All intellectual property rights in and/or in
 * the computer program and its related documentation and technology are the sole Mobile-Technologies Limited property.
 * This computer program is under Mobile-Technologies Limited copyright and cannot be in whole or in part reproduced,
 * sublicensed, leased, sold or used in any form or by any means, including without limitation graphic, electronic,
 * mechanical, photocopying, recording, taping or information storage and retrieval systems without Mobile-Technologies
 * Limited prior written consent. The downloading, exporting or reexporting of this computer program or any related
 * documentation or technology is subject to any export rules, including US regulations.
 * ----------------------------------------------------------------------------
 */

import 'abstract_bean.dart';
import 'master_data_version_bean_metadata.dart';

class MasterDataVersionBean extends AbstractBean {
  static const int FORCE_LOAD_VERSION = -1;

  int formId;
  int modelFormVersion;
  int i18nFormVersion;
  int wfUiFormVersion;

  MasterDataVersionBean();

  MasterDataVersionBean.formId(this.formId, this.modelFormVersion,
      this.i18nFormVersion, this.wfUiFormVersion);

  MasterDataVersionBean.versions(
      this.modelFormVersion, this.i18nFormVersion, this.wfUiFormVersion);

  int getFormId() {
    return formId;
  }

  void setFormId(int formId) {
    this.formId = formId;
  }

  int getModelFormVersion() {
    return modelFormVersion;
  }

  void setModelFormVersion(int modelFormVersion) {
    this.modelFormVersion = modelFormVersion;
  }

  int getI18nFormVersion() {
    return i18nFormVersion;
  }

  void setI18nFormVersion(int i18nFormVersion) {
    this.i18nFormVersion = i18nFormVersion;
  }

  int getWfUiFormVersion() {
    return wfUiFormVersion;
  }

  void setWfUiFormVersion(int wfUiFormVersion) {
    this.wfUiFormVersion = wfUiFormVersion;
  }

  String getFullVersion() {
    return "$wfUiFormVersion.$modelFormVersion.$i18nFormVersion";
  }

  @override
  String toString() => getFullVersion();

  @override
  String getXmlTag() => "formVersion";

  @override
  Set<String> getFields() => MasterDataVersionBeanMetaData.getFields();

  @override
  dynamic getFieldValue(String field) =>
      MasterDataVersionBeanMetaData.getFieldValue(field, this);
}
