/*
 * ----------------------------------------------------------------------------
 * Copyright © 2009 by Mobile-Technologies Limited. All rights reserved. All intellectual property rights in and/or in
 * the computer program and its related documentation and technology are the sole Mobile-Technologies Limited property.
 * This computer program is under Mobile-Technologies Limited copyright and cannot be in whole or in part reproduced,
 * sublicensed, leased, sold or used in any form or by any means, including without limitation graphic, electronic,
 * mechanical, photocopying, recording, taping or information storage and retrieval systems without Mobile-Technologies
 * Limited prior written consent. The downloading, exporting or reexporting of this computer program or any related
 * documentation or technology is subject to any export rules, including US regulations.
 * ----------------------------------------------------------------------------
 */

import 'master_data_version_bean.dart';

abstract class MasterDataVersionBeanMetaData {
  static const String formId = "formId";
  static const String modelFormVersion = "modelFormVersion";
  static const String i18nFormVersion = "i18nFormVersion";
  static const String wfUiFormVersion = "wfUiFormVersion";

  static Set<String> getFields() =>
      {formId, modelFormVersion, i18nFormVersion, wfUiFormVersion};

  static dynamic getFieldValue(
      String field, MasterDataVersionBean masterDataVersionBean) {
    if (formId == field) return masterDataVersionBean.getFormId();
    if (modelFormVersion == field)
      return masterDataVersionBean.getModelFormVersion();
    if (i18nFormVersion == field)
      return masterDataVersionBean.getI18nFormVersion();
    if (wfUiFormVersion == field)
      return masterDataVersionBean.getWfUiFormVersion();

    return null;
  }
}
