/*
 * ----------------------------------------------------------------------------
 * Copyright © 2009 by Mobile-Technologies Limited. All rights reserved. All intellectual property rights in and/or in
 * the computer program and its related documentation and technology are the sole Mobile-Technologies Limited property.
 * This computer program is under Mobile-Technologies Limited copyright and cannot be in whole or in part reproduced,
 * sublicensed, leased, sold or used in any form or by any means, including without limitation graphic, electronic,
 * mechanical, photocopying, recording, taping or information storage and retrieval systems without Mobile-Technologies
 * Limited prior written consent. The downloading, exporting or reexporting of this computer program or any related
 * documentation or technology is subject to any export rules, including US regulations.
 * ----------------------------------------------------------------------------
 */

import '../../../formalyze/validation/converter/c_boolean.dart';
import '../../../formalyze/validation/converter/c_date.dart';
import '../../../formalyze/validation/converter/c_number.dart';
import 'crm_form_data.dart';

abstract class CrmFormDataMetaData {
  static const String trxId = "trxId";
  static const String trxStatusId = "trxStatusId";
  static const String trxStatusDescription = "trxStatusDescription";
  static const String trxTypeId = "trxTypeId";
  static const String instanceId = "instanceId";
  static const String companyId = "companyId";
  static const String formVersion = "formVersion";
  static const String registrationTypeId = "registrationTypeId";
  static const String username = "username";
  static const String securityToken = "securityToken";
  static const String startRegistrationTime = "startRegistrationTime";
  static const String endRegistrationTime = "endRegistrationTime";
  static const String sendRegistrationTime = "sendRegistrationTime";
  static const String receivedRegistrationTime = "receivedRegistrationTime";
  static const String createdDateTime = "createdDateTime";
  static const String updatedDateTime = "updatedDateTime";
  static const String mPosInfoData = "mPosInfoData";
  static const String actionDealer = "actionDealer";
  static const String actionDate = "actionDate";
  static const String actionName = "actionName";
  static const String trxEventId = "trxEventId";
  static const String trxEventTypeId = "trxEventTypeId";
  static const String actionTrxStatusId = "actionTrxStatusId";
  static const String reasons = "reasons";
  static const String locale = "locale";
  static const String map = "map";
  static const String missingReasons = "missingReasons";
  static const String addRegDatas = "addRegDatas";
  static const String state = "state";
  static const String stateInfo = "stateInfo";
  static const String retries = "retries";
  static const String statusSummary = "statusSummary";
  static const String localId = "localId";
  static const String enableWhiteList = "enableWhiteList";
  static const String checkOccupied = "checkOccupied";
  static const String smsCount = "smsCount";
  static const String respCode = "respCode";
  static const String respDesc = "respDesc";

  static Set<String> getFields() => {
        trxId,
        trxStatusId,
        trxStatusDescription,
        trxTypeId,
        instanceId,
        companyId,
        formVersion,
        registrationTypeId,
        username,
        securityToken,
        startRegistrationTime,
        endRegistrationTime,
        sendRegistrationTime,
        receivedRegistrationTime,
        createdDateTime,
        updatedDateTime,
        mPosInfoData,
        actionDealer,
        actionDate,
        actionName,
        trxEventId,
        trxEventTypeId,
        actionTrxStatusId,
        reasons,
        locale,
        map,
        missingReasons,
        addRegDatas,
        state,
        stateInfo,
        retries,
        statusSummary,
        localId,
        enableWhiteList,
        checkOccupied,
        smsCount,
        respCode,
        respDesc
      };

  static dynamic getFieldValue(String field, CrmFormData crmFormData) {
    if (trxId == field) return crmFormData.getTrxId();
    if (trxStatusId == field) return crmFormData.getTrxStatusId();
    if (trxStatusDescription == field)
      return crmFormData.getTrxStatusDescription();
    if (trxTypeId == field) return crmFormData.getTrxTypeId();
    if (instanceId == field) return crmFormData.getInstanceId();
    if (companyId == field) return crmFormData.getCompanyId();
    if (formVersion == field) return crmFormData.getFormVersion();
    if (registrationTypeId == field) return crmFormData.getRegistrationTypeId();
    if (username == field) return crmFormData.getUsername();
    if (securityToken == field) return crmFormData.getSecurityToken();
    if (startRegistrationTime == field)
      return crmFormData.getStartRegistrationTime();
    if (endRegistrationTime == field)
      return crmFormData.getEndRegistrationTime();
    if (sendRegistrationTime == field)
      return crmFormData.getSendRegistrationTime();
    if (receivedRegistrationTime == field)
      return crmFormData.getReceivedRegistrationTime();
    if (createdDateTime == field) return crmFormData.getCreatedDateTime();
    if (updatedDateTime == field) return crmFormData.getUpdatedDateTime();
    if (mPosInfoData == field) return crmFormData.getmPosInfoData();
    if (actionDealer == field) return crmFormData.getActionDealer();
    if (actionDate == field) return crmFormData.getActionDate();
    if (actionName == field) return crmFormData.getActionName();
    if (trxEventId == field) return crmFormData.getTrxEventId();
    if (trxEventTypeId == field) return crmFormData.getTrxEventTypeId();
    if (actionTrxStatusId == field) return crmFormData.getActionTrxStatusId();
    if (reasons == field) return crmFormData.getReasons();
    if (locale == field) return crmFormData.getLocale();
    if (map == field) return crmFormData.getMap();
    if (missingReasons == field) return crmFormData.getMissingReasons();
    if (addRegDatas == field) return crmFormData.getAddRegDatas();
    if (state == field) return crmFormData.getState();
    if (stateInfo == field) return crmFormData.getStateInfo();
    if (retries == field) return crmFormData.getRetries();
    if (statusSummary == field) return crmFormData.getStatusSummary();
    if (localId == field) return crmFormData.getLocalId();
    if (enableWhiteList == field) return crmFormData.isEnableWhiteList();
    if (checkOccupied == field) return crmFormData.isCheckOccupied();
    if (smsCount == field) return crmFormData.getSmsCount();
    if (respCode == field) return crmFormData.getRespCode();
    if (respDesc == field) return crmFormData.getRespDesc();

    return null;
  }

  static void setFieldValue(
      String field, Object value, CrmFormData crmFormData) {
    if (trxId == field) {
      crmFormData.setTrxId(value);
    } else if (trxStatusId == field) {
      crmFormData.setTrxStatusId(CNumber.convertNoErr(value));
    } else if (trxStatusDescription == field) {
      crmFormData.setTrxStatusDescription(value);
    } else if (trxTypeId == field) {
      crmFormData.setTrxTypeId(CNumber.convertNoErr(value));
    } else if (instanceId == field) {
      crmFormData.setInstanceId(CNumber.convertNoErr(value));
    } else if (companyId == field) {
      crmFormData.setCompanyId(CNumber.convertNoErr(value));
    } else if (formVersion == field) {
      crmFormData.setFormVersion(value);
    } else if (registrationTypeId == field) {
      crmFormData.setRegistrationTypeId(CNumber.convertNoErr(value));
    } else if (username == field) {
      crmFormData.setUsername(value);
    } else if (securityToken == field) {
      crmFormData.setSecurityToken(value);
    } else if (startRegistrationTime == field) {
      crmFormData.setStartRegistrationTime(CDate.convertNoErr(value));
    } else if (endRegistrationTime == field) {
      crmFormData.setEndRegistrationTime(CDate.convertNoErr(value));
    } else if (sendRegistrationTime == field) {
      crmFormData.setSendRegistrationTime(CDate.convertNoErr(value));
    } else if (receivedRegistrationTime == field) {
      crmFormData.setReceivedRegistrationTime(CDate.convertNoErr(value));
    } else if (createdDateTime == field) {
      crmFormData.setCreatedDateTime(CDate.convertNoErr(value));
    } else if (updatedDateTime == field) {
      crmFormData.setUpdatedDateTime(CDate.convertNoErr(value));
    } else if (mPosInfoData == field) {
      crmFormData.setmPosInfoData(value);
    } else if (actionDealer == field) {
      crmFormData.setActionDealer(value);
    } else if (actionDate == field) {
      crmFormData.setActionDate(CDate.convertNoErr(value));
    } else if (actionName == field) {
      crmFormData.setActionName(value);
    } else if (trxEventId == field) {
      crmFormData.setTrxEventId(value);
    } else if (trxEventTypeId == field) {
      crmFormData.setTrxEventTypeId(CNumber.convertNoErr(value));
    } else if (actionTrxStatusId == field) {
      crmFormData.setActionTrxStatusId(CNumber.convertNoErr(value));
    } else if (reasons == field) {
      crmFormData.setReasons(value);
    } else if (locale == field) {
      crmFormData.setLocale(value);
    } else if (map == field) {
      crmFormData.setMap(value);
    } else if (missingReasons == field) {
      crmFormData.setMissingReasons(value);
    } else if (addRegDatas == field) {
      crmFormData.setAddRegDatas(value);
    } else if (state == field) {
      crmFormData.setState(value);
    } else if (stateInfo == field) {
      crmFormData.setStateInfo(value);
    } else if (retries == field) {
      crmFormData.setRetries(CNumber.convertNoErr(value));
    } else if (statusSummary == field) {
      crmFormData.setStatusSummary(value);
    } else if (localId == field) {
      crmFormData.setLocalId(CNumber.convertNoErr(value));
    } else if (enableWhiteList == field) {
      crmFormData.setEnableWhiteList(CBoolean.convertNoErr(value));
    } else if (checkOccupied == field) {
      crmFormData.setCheckOccupied(CBoolean.convertNoErr(value));
    } else if (smsCount == field) {
      crmFormData.setSmsCount(CNumber.convertNoErr(value));
    } else if (respCode == field) {
      crmFormData.setRespCode(CNumber.convertNoErr(value));
    } else if (respDesc == field) {
      crmFormData.setRespDesc(value);
    }
  }
}
