/*
 * ----------------------------------------------------------------------------
 * Copyright © 2009 by Mobile-Technologies Limited. All rights reserved. All intellectual property rights in and/or in
 * the computer program and its related documentation and technology are the sole Mobile-Technologies Limited property.
 * This computer program is under Mobile-Technologies Limited copyright and cannot be in whole or in part reproduced,
 * sublicensed, leased, sold or used in any form or by any means, including without limitation graphic, electronic,
 * mechanical, photocopying, recording, taping or information storage and retrieval systems without Mobile-Technologies
 * Limited prior written consent. The downloading, exporting or reexporting of this computer program or any related
 * documentation or technology is subject to any export rules, including US regulations.
 * ----------------------------------------------------------------------------
 */

import '../../structure/string_object_map.dart';
import '../abstract_bean.dart';
import 'mpos_info_data_metadata.dart';

class MposInfoData extends AbstractBean {
  // mPOS related fields
  String imei;
  bool offlineLogin;
  String cellId;
  String cellLac;
  String cellMcc;
  String cellMnc;
  bool smsPermission = false;
  String smsDestination;
  int smsMaxCount = 0;
  bool smsSent = false;
  int smsRetries = 0;

  String mPosVersionName;
  String mPosVersionCode;

  double latitude;
  double longitude;
  String androidVersion;

  String processorName;

  StringObjectMap extraInfos;

  MposInfoData() : extraInfos = StringObjectMap();

  MposInfoData.full(this.mPosVersionName, this.mPosVersionCode);

  String getImei() {
    return imei;
  }

  void setImei(String imei) {
    this.imei = imei;
  }

  bool isOfflineLogin() {
    return offlineLogin;
  }

  void setOfflineLogin(bool offlineLogin) {
    this.offlineLogin = offlineLogin;
  }

  String getCellId() {
    return cellId;
  }

  void setCellId(String cellId) {
    this.cellId = cellId;
  }

  String getCellLac() {
    return cellLac;
  }

  void setCellLac(String cellLac) {
    this.cellLac = cellLac;
  }

  String getCellMcc() {
    return cellMcc;
  }

  void setCellMcc(String cellMcc) {
    this.cellMcc = cellMcc;
  }

  String getCellMnc() {
    return cellMnc;
  }

  void setCellMnc(String cellMnc) {
    this.cellMnc = cellMnc;
  }

  bool isSmsPermission() {
    return smsPermission;
  }

  void setSmsPermission(bool smsPermission) {
    this.smsPermission = smsPermission;
  }

  String getSmsDestination() {
    return smsDestination;
  }

  void setSmsDestination(String smsDestination) {
    this.smsDestination = smsDestination;
  }

  int getSmsMaxCount() {
    return smsMaxCount;
  }

  void setSmsMaxCount(int smsMaxCount) {
    this.smsMaxCount = smsMaxCount;
  }

  bool isSmsSent() {
    return smsSent;
  }

  void setSmsSent(bool smsSent) {
    this.smsSent = smsSent;
  }

  int getSmsRetries() {
    return smsRetries;
  }

  void setSmsRetries(int smsRetries) {
    this.smsRetries = smsRetries;
  }

  String getmPosVersionName() {
    return mPosVersionName;
  }

  void setmPosVersionName(String mPosVersionName) {
    this.mPosVersionName = mPosVersionName;
  }

  String getmPosVersionCode() {
    return mPosVersionCode;
  }

  void setmPosVersionCode(String mPosVersionCode) {
    this.mPosVersionCode = mPosVersionCode;
  }

  double getLatitude() {
    return latitude;
  }

  void setLatitude(double latitude) {
    this.latitude = latitude;
  }

  double getLongitude() {
    return longitude;
  }

  void setLongitude(double longitude) {
    this.longitude = longitude;
  }

  String getAndroidVersion() {
    return androidVersion;
  }

  void setAndroidVersion(String androidVersion) {
    this.androidVersion = androidVersion;
  }

  StringObjectMap getExtraInfos() {
    return extraInfos;
  }

  void setExtraInfos(StringObjectMap extraInfos) {
    this.extraInfos = extraInfos;
  }

  String getProcessorName() {
    return processorName;
  }

  void setProcessorName(String processorName) {
    this.processorName = processorName;
  }

  @override
  String getXmlTag() => 'mPosInfoData';

  @override
  Set<String> getFields() => MposInfoDataMetaData.getFields();

  @override
  dynamic getFieldValue(String field) =>
      MposInfoDataMetaData.getFieldValue(field, this);

  @override
  void setFieldValue(String field, Object value) =>
      MposInfoDataMetaData.setFieldValue(field, value, this);
}
