/*
 * ----------------------------------------------------------------------------
 * Copyright © 2009 by Mobile-Technologies Limited. All rights reserved. All intellectual property rights in and/or in
 * the computer program and its related documentation and technology are the sole Mobile-Technologies Limited property.
 * This computer program is under Mobile-Technologies Limited copyright and cannot be in whole or in part reproduced,
 * sublicensed, leased, sold or used in any form or by any means, including without limitation graphic, electronic,
 * mechanical, photocopying, recording, taping or information storage and retrieval systems without Mobile-Technologies
 * Limited prior written consent. The downloading, exporting or reexporting of this computer program or any related
 * documentation or technology is subject to any export rules, including US regulations.
 * ----------------------------------------------------------------------------
 */

import '../../../formalyze/validation/converter/c_boolean.dart';
import '../../../formalyze/validation/converter/c_decimal.dart';
import '../../../formalyze/validation/converter/c_number.dart';
import 'mpos_info_data.dart';

abstract class MposInfoDataMetaData {
  static const String imei = "imei";
  static const String offlineLogin = "offlineLogin";
  static const String cellId = "cellId";
  static const String cellLac = "cellLac";
  static const String cellMcc = "cellMcc";
  static const String cellMnc = "cellMnc";
  static const String smsPermission = "smsPermission";
  static const String smsDestination = "smsDestination";
  static const String smsMaxCount = "smsMaxCount";
  static const String smsSent = "smsSent";
  static const String smsRetries = "smsRetries";
  static const String mPosVersionName = "mPosVersionName";
  static const String mPosVersionCode = "mPosVersionCode";
  static const String latitude = "latitude";
  static const String longitude = "longitude";
  static const String androidVersion = "androidVersion";
  static const String processorName = "processorName";
  static const String extraInfos = "extraInfos";

  static Set<String> getFields() => {
        imei,
        offlineLogin,
        cellId,
        cellLac,
        cellMcc,
        cellMnc,
        smsPermission,
        smsDestination,
        smsMaxCount,
        smsSent,
        smsRetries,
        mPosVersionName,
        mPosVersionCode,
        latitude,
        longitude,
        androidVersion,
        processorName,
        extraInfos
      };

  static dynamic getFieldValue(String field, MposInfoData mposInfoData) {
    if (imei == field) return mposInfoData.getImei();
    if (offlineLogin == field) return mposInfoData.isOfflineLogin();
    if (cellId == field) return mposInfoData.getCellId();
    if (cellLac == field) return mposInfoData.getCellLac();
    if (cellMcc == field) return mposInfoData.getCellMcc();
    if (cellMnc == field) return mposInfoData.getCellMnc();
    if (smsPermission == field) return mposInfoData.isSmsPermission();
    if (smsDestination == field) return mposInfoData.getSmsDestination();
    if (smsMaxCount == field) return mposInfoData.getSmsMaxCount();
    if (smsSent == field) return mposInfoData.isSmsSent();
    if (smsRetries == field) return mposInfoData.getSmsRetries();
    if (mPosVersionName == field) return mposInfoData.getmPosVersionName();
    if (mPosVersionCode == field) return mposInfoData.getmPosVersionCode();
    if (latitude == field) return mposInfoData.getLatitude();
    if (longitude == field) return mposInfoData.getLongitude();
    if (androidVersion == field) return mposInfoData.getAndroidVersion();
    if (processorName == field) return mposInfoData.getProcessorName();
    if (extraInfos == field) return mposInfoData.getExtraInfos();

    return null;
  }

  static void setFieldValue(
      String field, Object value, MposInfoData mposInfoData) {
    if (imei == field) {
      mposInfoData.setImei(value);
    } else if (offlineLogin == field) {
      mposInfoData.setOfflineLogin(CBoolean.convertNoErr(value));
    } else if (cellId == field) {
      mposInfoData.setCellId(value);
    } else if (cellLac == field) {
      mposInfoData.setCellLac(value);
    } else if (cellMcc == field) {
      mposInfoData.setCellMcc(value);
    } else if (cellMnc == field) {
      mposInfoData.setCellMnc(value);
    } else if (smsPermission == field) {
      mposInfoData.setSmsPermission(CBoolean.convertNoErr(value));
    } else if (smsDestination == field) {
      mposInfoData.setSmsDestination(value);
    } else if (smsMaxCount == field) {
      mposInfoData.setSmsMaxCount(CNumber.convertNoErr(value));
    } else if (smsSent == field) {
      mposInfoData.setSmsSent(CBoolean.convertNoErr(value));
    } else if (smsRetries == field) {
      mposInfoData.setSmsRetries(CNumber.convertNoErr(value));
    } else if (mPosVersionName == field) {
      mposInfoData.setmPosVersionName(value);
    } else if (mPosVersionCode == field) {
      mposInfoData.setmPosVersionCode(value);
    } else if (latitude == field) {
      mposInfoData.setLatitude(CDecimal.convertNoErr(value));
    } else if (longitude == field) {
      mposInfoData.setLongitude(CDecimal.convertNoErr(value));
    } else if (androidVersion == field) {
      mposInfoData.setAndroidVersion(value);
    } else if (processorName == field) {
      mposInfoData.setProcessorName(value);
    } else if (extraInfos == field) {
      mposInfoData.setExtraInfos(value);
    }
  }
}
