/*
 * ----------------------------------------------------------------------------
 * Copyright © 2009 by Mobile-Technologies Limited. All rights reserved. All intellectual property rights in and/or in
 * the computer program and its related documentation and technology are the sole Mobile-Technologies Limited property.
 * This computer program is under Mobile-Technologies Limited copyright and cannot be in whole or in part reproduced,
 * sublicensed, leased, sold or used in any form or by any means, including without limitation graphic, electronic,
 * mechanical, photocopying, recording, taping or information storage and retrieval systems without Mobile-Technologies
 * Limited prior written consent. The downloading, exporting or reexporting of this computer program or any related
 * documentation or technology is subject to any export rules, including US regulations.
 * ----------------------------------------------------------------------------
 */

import '../abstract_bean.dart';
import 'reason_metadata.dart';

class Reason extends AbstractBean {
  // PK of CrmI18nMessageArrayOpts = crmMsgArrayOptionId + crmMsgArrayId + projectId
  String crmMsgArrayOptionId;
  String crmMsgArrayId;

  int formId;

  // for every reason, we need / can set a comment
  String comment;

  Reason();

  Reason.full(
      this.crmMsgArrayOptionId, this.crmMsgArrayId, this.formId, this.comment);

  String getCrmMsgArrayOptionId() {
    return crmMsgArrayOptionId;
  }

  void setCrmMsgArrayOptionId(String crmMsgArrayOptionId) {
    this.crmMsgArrayOptionId = crmMsgArrayOptionId;
  }

  String getCrmMsgArrayId() {
    return crmMsgArrayId;
  }

  void setCrmMsgArrayId(String crmMsgArrayId) {
    this.crmMsgArrayId = crmMsgArrayId;
  }

  int getFormId() {
    return formId;
  }

  void setFormId(int formId) {
    this.formId = formId;
  }

  String getComment() {
    return comment;
  }

  void setComment(String comment) {
    this.comment = comment;
  }

  @override
  Set<String> getFields() => ReasonMetaData.getFields();

  @override
  dynamic getFieldValue(String field) =>
      ReasonMetaData.getFieldValue(field, this);
}
