/*
 * ----------------------------------------------------------------------------
 * Copyright © 2009 by Mobile-Technologies Limited. All rights reserved. All intellectual property rights in and/or in
 * the computer program and its related documentation and technology are the sole Mobile-Technologies Limited property.
 * This computer program is under Mobile-Technologies Limited copyright and cannot be in whole or in part reproduced,
 * sublicensed, leased, sold or used in any form or by any means, including without limitation graphic, electronic,
 * mechanical, photocopying, recording, taping or information storage and retrieval systems without Mobile-Technologies
 * Limited prior written consent. The downloading, exporting or reexporting of this computer program or any related
 * documentation or technology is subject to any export rules, including US regulations.
 * ----------------------------------------------------------------------------
 */

import 'reason.dart';

abstract class ReasonMetaData {
  static const String crmMsgArrayOptionId = "crmMsgArrayOptionId";
  static const String crmMsgArrayId = "crmMsgArrayId";
  static const String formId = "formId";
  static const String comment = "comment";

  static Set<String> getFields() =>
      {crmMsgArrayOptionId, crmMsgArrayId, formId, comment};

  static dynamic getFieldValue(String field, Reason reason) {
    if (crmMsgArrayOptionId == field) return reason.getCrmMsgArrayOptionId();
    if (crmMsgArrayId == field) return reason.getCrmMsgArrayId();
    if (formId == field) return reason.getFormId();
    if (comment == field) return reason.getComment();

    return null;
  }
}
