/*
 * ----------------------------------------------------------------------------
 * Copyright © 2009 by Mobile-Technologies Limited. All rights reserved. All intellectual property rights in and/or in
 * the computer program and its related documentation and technology are the sole Mobile-Technologies Limited property.
 * This computer program is under Mobile-Technologies Limited copyright and cannot be in whole or in part reproduced,
 * sublicensed, leased, sold or used in any form or by any means, including without limitation graphic, electronic,
 * mechanical, photocopying, recording, taping or information storage and retrieval systems without Mobile-Technologies
 * Limited prior written consent. The downloading, exporting or reexporting of this computer program or any related
 * documentation or technology is subject to any export rules, including US regulations.
 * ----------------------------------------------------------------------------
 */

import '../abstract_bean.dart';
import 'response_message_metadata.dart';

class ResponseMessage extends AbstractBean {
  String id;
  Map<String, String> messages;

  ResponseMessage() : messages = {};

  ResponseMessage.id(this.id) : this.messages = {};

  String getMessage(String language) {
    String message;

    if (messages != null) {
      message = findMessage(language);

      if (message == null) {
        message = findMessage("en");

        if (message == null && messages.isNotEmpty) {
          message = messages.values.first;
        }
      }
    }

    return message;
  }

  String findMessage(String language) {
    String message = messages[language.toLowerCase()];
    return message == null ? messages[language.toUpperCase()] : message;
  }

  void addMessage(String language, String message) {
    messages[language] = message;
  }

  Map<String, String> getMessages() {
    return messages;
  }

  void setMessages(Map<String, String> messages) {
    this.messages = messages;
  }

  String getId() {
    return id;
  }

  void setId(String id) {
    this.id = id;
  }

  @override
  String toString() => "ResponseMessage [id=$id, messages=$messages]";

  @override
  Set<String> getFields() => ResponseMessageMetaData.getFields();

  @override
  dynamic getFieldValue(String field) =>
      ResponseMessageMetaData.getFieldValue(field, this);
}
