/*
 * ----------------------------------------------------------------------------
 * Copyright © 2009 by Mobile-Technologies Limited. All rights reserved. All intellectual property rights in and/or in
 * the computer program and its related documentation and technology are the sole Mobile-Technologies Limited property.
 * This computer program is under Mobile-Technologies Limited copyright and cannot be in whole or in part reproduced,
 * sublicensed, leased, sold or used in any form or by any means, including without limitation graphic, electronic,
 * mechanical, photocopying, recording, taping or information storage and retrieval systems without Mobile-Technologies
 * Limited prior written consent. The downloading, exporting or reexporting of this computer program or any related
 * documentation or technology is subject to any export rules, including US regulations.
 * ----------------------------------------------------------------------------
 */

import '../i_reflect.dart';
import 'response_message.dart';

abstract class ResponseMessageMetaData {
  static const String id = "id";
  static const String messages = "messages";

  static Set<String> getFields() => {
        id,
        messages,
      };

  static dynamic getFieldValue(String field, ResponseMessage responseMessage) {
    if (id == field) return responseMessage.getId();
    if (messages == field) return responseMessage.getMessages();

    return null;
  }

  static ResponseMessage toBean(Map map) {
    if (map == null) {
      return null;
    }

    ResponseMessage responseMessage = ResponseMessage();
    responseMessage.id = map[id];
    responseMessage.messages = IReflect.transformMap(map[messages]);
    return responseMessage;
  }
}
