/*
 * ----------------------------------------------------------------------------
 * Copyright © 2009 by Mobile-Technologies Limited. All rights reserved. All intellectual property rights in and/or in
 * the computer program and its related documentation and technology are the sole Mobile-Technologies Limited property.
 * This computer program is under Mobile-Technologies Limited copyright and cannot be in whole or in part reproduced,
 * sublicensed, leased, sold or used in any form or by any means, including without limitation graphic, electronic,
 * mechanical, photocopying, recording, taping or information storage and retrieval systems without Mobile-Technologies
 * Limited prior written consent. The downloading, exporting or reexporting of this computer program or any related
 * documentation or technology is subject to any export rules, including US regulations.
 * ----------------------------------------------------------------------------
 */

import '../../structure/string_object_map.dart';
import '../abstract_isl_resp.dart';
import 'customer_information_metadata.dart';

class CustomerInformation extends AbstractIslResp {
  String trxId;
  String msisdn;
  String iccid;
  String puk;
  String kitNumber;
  String firstName;
  String lastName;
  String dealerName;

  /* SUCESS = 1, REJECTED = 2, BLOCKED = 3, PENDING = 4 */
  String trxStatusId;
  String trxStatusName;
  String trxTypeId;
  DateTime createdDateTime;
  StringObjectMap map;

  String registrationType;

  bool isTrxLock;

  @override
  String getTrxId() {
    return trxId;
  }

  @override
  void setTrxId(String trxId) {
    this.trxId = trxId;
  }

  String getMsisdn() {
    return msisdn;
  }

  void setMsisdn(String msisdn) {
    this.msisdn = msisdn;
  }

  String getTrxTypeId() {
    return trxTypeId;
  }

  void setTrxTypeId(String trxTypeId) {
    this.trxTypeId = trxTypeId;
  }

  String getFirstName() {
    return firstName;
  }

  void setFirstName(String firstName) {
    this.firstName = firstName;
  }

  String getLastName() {
    return lastName;
  }

  void setLastName(String lastName) {
    this.lastName = lastName;
  }

  @override
  DateTime getCreatedDateTime() {
    return createdDateTime == null
        ? super.getCreatedDateTime()
        : createdDateTime;
  }

  @override
  void setCreatedDateTime(DateTime createdDateTime) {
    this.createdDateTime = createdDateTime;
  }

  String getPuk() {
    return puk;
  }

  void setPuk(String puk) {
    this.puk = puk;
  }

  String getKitNumber() {
    return kitNumber;
  }

  void setKitNumber(String kitNumber) {
    this.kitNumber = kitNumber;
  }

  String getTrxStatusId() {
    return trxStatusId;
  }

  void setTrxStatusId(String trxStatusId) {
    this.trxStatusId = trxStatusId;
  }

  String getDealerName() {
    return dealerName;
  }

  void setDealerName(String dealerName) {
    this.dealerName = dealerName;
  }

  String getIccid() {
    return iccid;
  }

  void setIccid(String iccid) {
    this.iccid = iccid;
  }

  String getName() {
    return "$firstName $lastName";
  }

  String getTrxStatusName() {
    return trxStatusName;
  }

  void setTrxStatusName(String trxStatusName) {
    this.trxStatusName = trxStatusName;
  }

  StringObjectMap getMap() {
    return map;
  }

  void setMap(StringObjectMap map) {
    this.map = map;
  }

  String getRegistrationType() {
    return registrationType;
  }

  void setRegistrationType(String registrationType) {
    this.registrationType = registrationType;
  }

  bool isIsTrxLock() {
    return isTrxLock;
  }

  void setIsTrxLock(bool isTrxLock) {
    this.isTrxLock = isTrxLock;
  }

  @override
  Set<String> getFields() => CustomerInformationMetaData.getFields();

  @override
  dynamic getFieldValue(String field) =>
      CustomerInformationMetaData.getFieldValue(field, this);
}
