/*
 * ----------------------------------------------------------------------------
 * Copyright © 2009 by Mobile-Technologies Limited. All rights reserved. All intellectual property rights in and/or in
 * the computer program and its related documentation and technology are the sole Mobile-Technologies Limited property.
 * This computer program is under Mobile-Technologies Limited copyright and cannot be in whole or in part reproduced,
 * sublicensed, leased, sold or used in any form or by any means, including without limitation graphic, electronic,
 * mechanical, photocopying, recording, taping or information storage and retrieval systems without Mobile-Technologies
 * Limited prior written consent. The downloading, exporting or reexporting of this computer program or any related
 * documentation or technology is subject to any export rules, including US regulations.
 * ----------------------------------------------------------------------------
 */

import '../../../formalyze/generator/reader/xml_reader.dart';
import '../../../formalyze/validation/converter/c_boolean.dart';
import '../abstract_isl_resp_metadata.dart';
import '../i_reflect.dart';
import 'customer_information.dart';

abstract class CustomerInformationMetaData {
  static const String trxId = "trxId";
  static const String msisdn = "msisdn";
  static const String iccid = "iccid";
  static const String puk = "puk";
  static const String kitNumber = "kitNumber";
  static const String firstName = "firstName";
  static const String lastName = "lastName";
  static const String dealerName = "dealerName";
  static const String trxStatusId = "trxStatusId";
  static const String trxStatusName = "trxStatusName";
  static const String trxTypeId = "trxTypeId";
  static const String createdDateTime = "createdDateTime";
  static const String map = "map";
  static const String registrationType = "registrationType";
  static const String isTrxLock = "isTrxLock";

  static Set<String> getFields() {
    Set<String> fields = AbstractIslRespMetaData.getFields();
    fields.addAll({
      trxId,
      msisdn,
      iccid,
      puk,
      kitNumber,
      firstName,
      lastName,
      dealerName,
      trxStatusId,
      trxStatusName,
      trxTypeId,
      createdDateTime,
      map,
      registrationType,
      isTrxLock
    });
    return fields;
  }

  static dynamic getFieldValue(
      String field, CustomerInformation customerInformation) {
    if (trxId == field) return customerInformation.getTrxId();
    if (msisdn == field) return customerInformation.getMsisdn();
    if (iccid == field) return customerInformation.getIccid();
    if (puk == field) return customerInformation.getPuk();
    if (kitNumber == field) return customerInformation.getKitNumber();
    if (firstName == field) return customerInformation.getFirstName();
    if (lastName == field) return customerInformation.getLastName();
    if (dealerName == field) return customerInformation.getDealerName();
    if (trxStatusId == field) return customerInformation.getTrxStatusId();
    if (trxStatusName == field) return customerInformation.getTrxStatusName();
    if (trxTypeId == field) return customerInformation.getTrxTypeId();
    if (createdDateTime == field)
      return customerInformation.getCreatedDateTime();
    if (map == field) return customerInformation.getMap();
    if (registrationType == field)
      return customerInformation.getRegistrationType();
    if (isTrxLock == field) return customerInformation.isIsTrxLock();

    return AbstractIslRespMetaData.getFieldValue(field, customerInformation);
  }

  static CustomerInformation toBean(Map map) {
    if (map == null) {
      return null;
    }

    CustomerInformation customerInformation = CustomerInformation();
    customerInformation.trxId = map[trxId];
    customerInformation.msisdn = map[msisdn];
    customerInformation.iccid = map[iccid];
    customerInformation.puk = map[puk];
    customerInformation.kitNumber = map[kitNumber];
    customerInformation.firstName = map[firstName];
    customerInformation.lastName = map[lastName];
    customerInformation.dealerName = map[dealerName];
    customerInformation.trxStatusId = map[trxStatusId];
    customerInformation.trxStatusName = map[trxStatusName];
    customerInformation.trxTypeId = map[trxTypeId];
    customerInformation.createdDateTime =
        XmlReader.toDate(map[createdDateTime]);
    customerInformation.map =
        IReflect.transformMap_(map[CustomerInformationMetaData.map]);
    customerInformation.registrationType = map[registrationType];
    customerInformation.isTrxLock = CBoolean.parseNoErr(map[isTrxLock]);
    return AbstractIslRespMetaData.toBean(map, customerInformation);
  }
}
