/*
 * ----------------------------------------------------------------------------
 * Copyright © 2009 by Mobile-Technologies Limited. All rights reserved. All intellectual property rights in and/or in
 * the computer program and its related documentation and technology are the sole Mobile-Technologies Limited property.
 * This computer program is under Mobile-Technologies Limited copyright and cannot be in whole or in part reproduced,
 * sublicensed, leased, sold or used in any form or by any means, including without limitation graphic, electronic,
 * mechanical, photocopying, recording, taping or information storage and retrieval systems without Mobile-Technologies
 * Limited prior written consent. The downloading, exporting or reexporting of this computer program or any related
 * documentation or technology is subject to any export rules, including US regulations.
 * ----------------------------------------------------------------------------
 */

import '../../../../formalyze/validation/converter/c_boolean.dart';
import '../../abstract_isl_resp_metadata.dart';
import 'search_registration_information_resp.dart';

abstract class SearchRegistrationInformationRespMetaData {
  static const String searchResult = "searchResult";
  static const String maxLimitReached = "maxLimitReached";

  static Set<String> getFields() {
    Set<String> fields = AbstractIslRespMetaData.getFields();
    fields.addAll({searchResult, maxLimitReached});
    return fields;
  }

  static dynamic getFieldValue(
      String field, SearchRegistrationInformationResp resp) {
    if (searchResult == field) return resp.getSearchResult();
    if (maxLimitReached == field) return resp.isMaxLimitReached();

    return AbstractIslRespMetaData.getFieldValue(field, resp);
  }

  static SearchRegistrationInformationResp toBean(Map map) {
    if (map == null) {
      return null;
    }

    SearchRegistrationInformationResp responseMessage =
        SearchRegistrationInformationResp();
    responseMessage.searchResult =
        map[searchResult]; // FIXME List<StringObjectMap>
    responseMessage.maxLimitReached = CBoolean.parseNoErr(map[maxLimitReached]);
    return AbstractIslRespMetaData.toBean(map, responseMessage);
  }
}
