/*
 * ----------------------------------------------------------------------------
 * Copyright © 2009 by Mobile-Technologies Limited. All rights reserved. All intellectual property rights in and/or in
 * the computer program and its related documentation and technology are the sole Mobile-Technologies Limited property.
 * This computer program is under Mobile-Technologies Limited copyright and cannot be in whole or in part reproduced,
 * sublicensed, leased, sold or used in any form or by any means, including without limitation graphic, electronic,
 * mechanical, photocopying, recording, taping or information storage and retrieval systems without Mobile-Technologies
 * Limited prior written consent. The downloading, exporting or reexporting of this computer program or any related
 * documentation or technology is subject to any export rules, including US regulations.
 * ----------------------------------------------------------------------------
 */

import '../../formalyze/validation/converter/c_number.dart';
import 'credential/common_credential_bean_metadata.dart';
import 'credential/form_detail_bean_metadata.dart';
import 'credential/registered_fp_metadata.dart';
import 'credential/version_bean_metadata.dart';
import 'i_reflect.dart';
import 'register/response_message_metadata.dart';
import 'search/customer_information_metadata.dart';
import 'search/external/search_registration_information_resp_metadata.dart';
import 'server_response.dart';

abstract class ServerResponseMetaData {
  static const String responseCode = "responseCode";
  static const String responseDesc = "responseDesc";
  static const String statusInformation = "statusInformation";
  static const String statusSummary = "statusSummary";
  static const String customMessage = "customMessage";
  static const String abillityRespCode = "abillityRespCode";
  static const String abillityRespMsg = "abillityRespMsg";
  static const String securityToken = "securityToken";
  static const String offlinePeriod = "offlinePeriod";
  static const String msisdn = "msisdn";
  static const String iccid = "iccid";
  static const String promotionalMessageName = "promotionalMessageName";
  static const String promotionalMessageText = "promotionalMessageText";
  static const String eaiBackendUrl = "eaiBackendUrl";
  static const String responseReasons = "responseReasons";
  static const String responseReasonComments = "responseReasonComments";
  static const String loginLimit = "loginLimit";
  static const String searchRegistrationInformationResp =
      "searchRegistrationInformationResp";
  static const String customerInformation = "customerInformation";
  static const String permissions = "permissions";
  static const String printedRegistrationUrl = "printedRegistrationUrl";
  static const String nbTotalRegistrations = "nbTotalRegistrations";
  static const String nbSuccessRegistrations = "nbSuccessRegistrations";
  static const String nbPendingRegistrations = "nbPendingRegistrations";
  static const String nbFailedRegistrations = "nbFailedRegistrations";
  static const String versionDetails = "versionDetails";
  static const String formDetails = "formDetails";
  static const String hintQuestion = "hintQuestion";
  static const String hintAnswer = "hintAnswer";
  static const String remainRetryLoginAttempt = "remainRetryLoginAttempt";
  static const String enableFlows = "enableFlows";
  static const String arrayOptions = "arrayOptions";
  static const String data = "data";
  static const String commonCredentialBean = "commonCredentialBean";
  static const String fingerprints = "fingerprints";
  static const String msisdnList = "msisdnList";
  static const String reservationId = "reservationId";
  static const String resultMap = "resultMap";
  static const String smsActivationDestNumber = "smsActivationDestNumber";
  static const String smsActivationMsgFormat = "smsActivationMsgFormat";
  static const String smsActivationSentCount = "smsActivationSentCount";
  static const String smsActivationMaxOutbox = "smsActivationMaxOutbox";
  static const String otpPasswordChangeEnable = "otpPasswordChangeEnable";
  static const String license = "license";
  static const String remainingStorageWarningValue =
      "remainingStorageWarningValue";

  static Set<String> getFields() => {
        responseCode,
        responseDesc,
        statusInformation,
        statusSummary,
        customMessage,
        abillityRespCode,
        abillityRespMsg,
        securityToken,
        offlinePeriod,
        msisdn,
        iccid,
        promotionalMessageName,
        promotionalMessageText,
        eaiBackendUrl,
        responseReasons,
        responseReasonComments,
        loginLimit,
        searchRegistrationInformationResp,
        customerInformation,
        permissions,
        printedRegistrationUrl,
        nbTotalRegistrations,
        nbSuccessRegistrations,
        nbPendingRegistrations,
        nbFailedRegistrations,
        versionDetails,
        formDetails,
        hintQuestion,
        hintAnswer,
        remainRetryLoginAttempt,
        enableFlows,
        arrayOptions,
        data,
        commonCredentialBean,
        fingerprints,
        msisdnList,
        reservationId,
        resultMap,
        smsActivationDestNumber,
        smsActivationMsgFormat,
        smsActivationSentCount,
        smsActivationMaxOutbox,
        otpPasswordChangeEnable,
        license,
        remainingStorageWarningValue
      };

  static dynamic getFieldValue(String field, ServerResponse serverResponse) {
    if (responseCode == field) return serverResponse.getResponseCode();
    if (responseDesc == field) return serverResponse.getResponseDesc();
    if (statusInformation == field)
      return serverResponse.getStatusInformation();
    if (statusSummary == field) return serverResponse.getStatusSummary();
    if (customMessage == field) return serverResponse.getCustomMessage();
    if (abillityRespCode == field) return serverResponse.getAbillityRespCode();
    if (abillityRespMsg == field) return serverResponse.getAbillityRespMsg();
    if (securityToken == field) return serverResponse.getSecurityToken();
    if (offlinePeriod == field) return serverResponse.getOfflinePeriod();
    if (msisdn == field) return serverResponse.getMsisdn();
    if (iccid == field) return serverResponse.getIccid();
    if (promotionalMessageName == field)
      return serverResponse.getPromotionalMessageName();
    if (promotionalMessageText == field)
      return serverResponse.getPromotionalMessageText();
    if (eaiBackendUrl == field) return serverResponse.getEaiBackendUrl();
    if (responseReasons == field) return serverResponse.getResponseReasons();
    if (responseReasonComments == field)
      return serverResponse.getResponseReasonComments();
    if (loginLimit == field) return serverResponse.getLoginLimit();
    if (searchRegistrationInformationResp == field)
      return serverResponse.getSearchRegistrationInformationResp();
    if (customerInformation == field)
      return serverResponse.getCustomerInformation();
    if (permissions == field) return serverResponse.getPermissions();
    if (printedRegistrationUrl == field)
      return serverResponse.getPrintedRegistrationUrl();
    if (nbTotalRegistrations == field)
      return serverResponse.getNbTotalRegistrations();
    if (nbSuccessRegistrations == field)
      return serverResponse.getNbSuccessRegistrations();
    if (nbPendingRegistrations == field)
      return serverResponse.getNbPendingRegistrations();
    if (nbFailedRegistrations == field)
      return serverResponse.getNbFailedRegistrations();
    if (versionDetails == field) return serverResponse.getVersionDetails();
    if (formDetails == field) return serverResponse.getFormDetails();
    if (hintQuestion == field) return serverResponse.getHintQuestion();
    if (hintAnswer == field) return serverResponse.getHintAnswer();
    if (remainRetryLoginAttempt == field)
      return serverResponse.getRemainRetryLoginAttempt();
    if (enableFlows == field) return serverResponse.getEnableFlows();
    if (arrayOptions == field) return serverResponse.getArrayOptions();
    if (data == field) return serverResponse.getData();
    if (commonCredentialBean == field)
      return serverResponse.getCommonCredentialBean();
    if (fingerprints == field) return serverResponse.getFingerprints();
    if (msisdnList == field) return serverResponse.getMsisdnList();
    if (reservationId == field) return serverResponse.getReservationId();
    if (resultMap == field) return serverResponse.getResultMap();
    if (smsActivationDestNumber == field)
      return serverResponse.getSmsActivationDestNumber();
    if (smsActivationMsgFormat == field)
      return serverResponse.getSmsActivationMsgFormat();
    if (smsActivationSentCount == field)
      return serverResponse.getSmsActivationSentCount();
    if (smsActivationMaxOutbox == field)
      return serverResponse.getSmsActivationMaxOutbox();
    if (otpPasswordChangeEnable == field)
      return serverResponse.getOtpPasswordChangeEnable();
    if (license == field) return serverResponse.getLicense();
    if (remainingStorageWarningValue == field)
      return serverResponse.getRemainingStorageWarningValue();

    return null;
  }

  static ServerResponse toBean(Map map) {
    if (map == null) {
      return null;
    }

    ServerResponse serverResponse = ServerResponse();
    serverResponse.responseCode = CNumber.parseNoErr(map[responseCode]);
    serverResponse.responseDesc = map[responseDesc];
    serverResponse.statusInformation = map[statusInformation];
    serverResponse.statusSummary = map[statusSummary];
    serverResponse.customMessage =
        ResponseMessageMetaData.toBean(map[customMessage]);
    serverResponse.abillityRespCode = CNumber.parseNoErr(map[abillityRespCode]);
    serverResponse.abillityRespMsg = map[abillityRespMsg];
    serverResponse.securityToken = map[securityToken];
    serverResponse.offlinePeriod = CNumber.parseNoErr(map[offlinePeriod]);
    serverResponse.msisdn = map[msisdn];
    serverResponse.iccid = map[iccid];
    serverResponse.promotionalMessageName = map[promotionalMessageName];
    serverResponse.promotionalMessageText = map[promotionalMessageText];
    serverResponse.eaiBackendUrl = map[eaiBackendUrl];
    serverResponse.responseReasons = map[responseReasons];
    serverResponse.responseReasonComments = map[responseReasonComments];
    serverResponse.loginLimit = CNumber.parseNoErr(map[loginLimit]);
    serverResponse.searchRegistrationInformationResp =
        SearchRegistrationInformationRespMetaData.toBean(
            map[searchRegistrationInformationResp]);
    serverResponse.customerInformation =
        CustomerInformationMetaData.toBean(map[customerInformation]);
    serverResponse.permissions = map[permissions];
    serverResponse.printedRegistrationUrl = map[printedRegistrationUrl];
    serverResponse.nbTotalRegistrations = map[nbTotalRegistrations];
    serverResponse.nbSuccessRegistrations = map[nbSuccessRegistrations];
    serverResponse.nbPendingRegistrations = map[nbPendingRegistrations];
    serverResponse.nbFailedRegistrations = map[nbFailedRegistrations];
    serverResponse.versionDetails = IReflect.transformToList(
        map[versionDetails], (map) => VersionBeanMetaData.toBean(map));
    serverResponse.formDetails = IReflect.transformToList(
        map[formDetails], (map) => FormDetailBeanMetaData.toBean(map));
    serverResponse.hintQuestion = map[hintQuestion];
    serverResponse.hintAnswer = map[hintAnswer];
    serverResponse.remainRetryLoginAttempt =
        CNumber.parseNoErr(map[remainRetryLoginAttempt]);
    serverResponse.enableFlows = IReflect.transformMap___(map[enableFlows]);
    serverResponse.arrayOptions = IReflect.transformMap__(map[arrayOptions]);
    serverResponse.data = IReflect.transformMap(map[data]);
    serverResponse.commonCredentialBean =
        CommonCredentialBeanMetaData.toBean(map[commonCredentialBean]);
    serverResponse.fingerprints = IReflect.transformToList(
        map[fingerprints], (map) => RegisteredFPMetaData.toBean(map));
    serverResponse.msisdnList = map[msisdnList];
    serverResponse.reservationId = CNumber.parseNoErr(map[reservationId]);
    serverResponse.resultMap = IReflect.transformMap(map[resultMap]);
    serverResponse.smsActivationDestNumber = map[smsActivationDestNumber];
    serverResponse.smsActivationMsgFormat = map[smsActivationMsgFormat];
    serverResponse.smsActivationSentCount = map[smsActivationSentCount];
    serverResponse.smsActivationMaxOutbox = map[smsActivationMaxOutbox];
    serverResponse.otpPasswordChangeEnable = map[otpPasswordChangeEnable];
    serverResponse.license = map[license];
    serverResponse.remainingStorageWarningValue =
        map[remainingStorageWarningValue];
    return serverResponse;
  }
}
