/*
 * ----------------------------------------------------------------------------
 * Copyright © 2009 by Mobile-Technologies Limited. All rights reserved. All intellectual property rights in and/or in
 * the computer program and its related documentation and technology are the sole Mobile-Technologies Limited property.
 * This computer program is under Mobile-Technologies Limited copyright and cannot be in whole or in part reproduced,
 * sublicensed, leased, sold or used in any form or by any means, including without limitation graphic, electronic,
 * mechanical, photocopying, recording, taping or information storage and retrieval systems without Mobile-Technologies
 * Limited prior written consent. The downloading, exporting or reexporting of this computer program or any related
 * documentation or technology is subject to any export rules, including US regulations.
 * ----------------------------------------------------------------------------
 */

import '../../bean/common/new_version_req.dart';
import '../../bean/common/report_error_req.dart';
import '../../bean/server_response.dart';

abstract class ICommonService {
  static const String NAME = "CommonWebService?wsdl";
  static const String NAMESPACE = "http://mobile-technologies.com/eai/isl/";

  // constants related to 'getNewVersionMPOS' method
  static const String METHOD_NEW_VERSION = "getNewVersionMPOS";
  static const String ARG_NEW_VERSION_REQ = "newVersionReq";

  Future<ServerResponse> getNewVersionMPOS(NewVersionReq newVersionReq);

  // constants related to 'reportError' method
  static const String METHOD_REPORT_ERR = "reportError";
  static const String ARG_REPORT_ERR_REQ = "reportErrorReq";

  Future<ServerResponse> reportError(ReportErrorReq reportErrorReq);
}
