/*
 * ----------------------------------------------------------------------------
 * Copyright © 2009 by Mobile-Technologies Limited. All rights reserved. All intellectual property rights in and/or in
 * the computer program and its related documentation and technology are the sole Mobile-Technologies Limited property.
 * This computer program is under Mobile-Technologies Limited copyright and cannot be in whole or in part reproduced,
 * sublicensed, leased, sold or used in any form or by any means, including without limitation graphic, electronic,
 * mechanical, photocopying, recording, taping or information storage and retrieval systems without Mobile-Technologies
 * Limited prior written consent. The downloading, exporting or reexporting of this computer program or any related
 * documentation or technology is subject to any export rules, including US regulations.
 * ----------------------------------------------------------------------------
 */

import '../../bean/credential/change_pw_req.dart';
import '../../bean/credential/credential_validation_req.dart';
import '../../bean/credential/forget_pw_req.dart';
import '../../bean/credential/logout_req.dart';
import '../../bean/credential/user_info_req.dart';
import '../../bean/server_response.dart';

abstract class ICredentialService {
  static const String NAME = "CredentialWebService?wsdl";
  static const String NAMESPACE = "http://mobile-technologies.com/eai/isl/";

  // constants related to 'login' method
  static const String METHOD_LOGIN = "login";
  static const String ARG_LOGIN_REQ = "credentialValidationReq";

  Future<ServerResponse> login(CredentialValidationReq credentialValidationReq);

  // constants related to 'logout' method
  static const String METHOD_LOGOUT = "logout";
  static const String ARG_LOGOUT_REQ = "logoutReq";

  Future<ServerResponse> logout(LogoutReq logoutReq);

  // constants related to 'changePassword' method
  static const String METHOD_CHANGE_PWD = "changePassword";
  static const String ARG_CHANGE_PWD_REQ = "changePassReq";

  Future<ServerResponse> changePassword(ChangePwReq changePassReq);

  // constants related to 'forgetPassword' method
  static const String METHOD_FORGET_PWD = "forgetPassword";
  static const String ARG_FORGET_PWD_REQ = "forgetPwReq";

  Future<ServerResponse> forgetPassword(ForgetPwReq forgetPwReq);

  // constants related to 'getUserInfo' method
  static const String METHOD_GET_USER_INFO = "getUserInfo";
  static const String ARG_USER_INFO_REQ = "userInfoReq";

  Future<ServerResponse> getUserInfo(UserInfoReq userInfoReq);
}
