/*
 * ----------------------------------------------------------------------------
 * Copyright © 2009 by Mobile-Technologies Limited. All rights reserved. All intellectual property rights in and/or in
 * the computer program and its related documentation and technology are the sole Mobile-Technologies Limited property.
 * This computer program is under Mobile-Technologies Limited copyright and cannot be in whole or in part reproduced,
 * sublicensed, leased, sold or used in any form or by any means, including without limitation graphic, electronic,
 * mechanical, photocopying, recording, taping or information storage and retrieval systems without Mobile-Technologies
 * Limited prior written consent. The downloading, exporting or reexporting of this computer program or any related
 * documentation or technology is subject to any export rules, including US regulations.
 * ----------------------------------------------------------------------------
 */

import '../../bean/register/crm_form_data.dart';
import '../../bean/server_response.dart';
import '../../support/request/support_request_req.dart';

abstract class IRegistrationService {
  static const String NAME = "RegistrationWebService?wsdl";
  static const String NAMESPACE = "http://mobile-technologies.com/eai/isl/";

  static const String METHOD_NEW_REG = "newRegistrationSubscriber";
  static const String ARG_NEW_REG_FORM_DATA = "crmFormData";

  Future<ServerResponse> newRegistrationSubscriber(CrmFormData crmFormData);

  static const String METHOD_REG_STATUS = "checkStatus";
  static const String ARG_REG_STATUS_FORM_DATA = "crmFormData";

  Future<ServerResponse> checkStatus(CrmFormData crmFormData);

  static const String METHOD_STANDARD_RMI = "standardRmi";
  static const String ARG_STANDARD_RMI_FORM_DATA = "crmFormData";

  Future<ServerResponse> standardRmi(CrmFormData crmFormData);

  static const String METHOD_GENERATE_OTP = "generateOtp";
  static const String ARG_GENERATE_OTP_FORM_DATA = "crmFormData";

  Future<ServerResponse> generateOtp(CrmFormData crmFormData);

  static const String METHOD_VALIDATE_OTP = "validateOtp";
  static const String ARG_VALIDATE_OTP_FORM_DATA = "crmFormData";

  Future<ServerResponse> validateOtp(CrmFormData crmFormData);

  static const String METHOD_PRINT_REG = "printRegistration";
  static const String ARG_PRINT_REG_FORM_DATA = "crmFormData";

  Future<ServerResponse> printRegistration(CrmFormData crmFormData);

  static const String METHOD_SUPPORT_REQ = "supportRequest";
  static const String ARG_SUPPORT_REQUEST_FORM_DATA = "supportRequestReq";

  Future<ServerResponse> supportRequest(SupportRequestReq supportRequestReq);

  // *** Not implement method in current product.
  Future<ServerResponse> getDealerReport(
      String securityToken, String dealerName, String fromDate, String toDate);

  static const String METHOD_GET_VERSION_DETAILS = "getVersionDetails";

  Future<ServerResponse> getVersionDetails(
      String trxId, String securityToken, int instanceId);
}
