/*
 * ----------------------------------------------------------------------------
 * Copyright © 2009 by Mobile-Technologies Limited. All rights reserved. All intellectual property rights in and/or in
 * the computer program and its related documentation and technology are the sole Mobile-Technologies Limited property.
 * This computer program is under Mobile-Technologies Limited copyright and cannot be in whole or in part reproduced,
 * sublicensed, leased, sold or used in any form or by any means, including without limitation graphic, electronic,
 * mechanical, photocopying, recording, taping or information storage and retrieval systems without Mobile-Technologies
 * Limited prior written consent. The downloading, exporting or reexporting of this computer program or any related
 * documentation or technology is subject to any export rules, including US regulations.
 * ----------------------------------------------------------------------------
 */

import '../bean/i_reflect.dart';
import '../util/to_string_utils.dart';

class MyMap<K, V> extends IReflect implements Map<K, V> {
  static const String key = "key";
  static const String value = "value";

  final Map<K, V> internalMap = {};

  MyMap() {
    // nothing to do here
  }

  @override
  V operator [](Object key) {
    return internalMap[key];
  }

  @override
  void operator []=(K key, V value) {
    internalMap[key] = value;
  }

  @override
  void addAll(Map<K, V> other) {
    internalMap.addAll(other);
  }

  @override
  void addEntries(Iterable<MapEntry<K, V>> newEntries) {
    internalMap.addEntries(newEntries);
  }

  @override
  Map<RK, RV> cast<RK, RV>() {
    return internalMap.cast();
  }

  @override
  void clear() {
    internalMap.clear();
  }

  @override
  bool containsKey(Object key) {
    return internalMap.containsKey(key);
  }

  @override
  bool containsValue(Object value) {
    return internalMap.containsValue(value);
  }

  @override
  Iterable<MapEntry<K, V>> get entries => internalMap.entries;

  @override
  void forEach(void Function(K key, V value) action) {
    internalMap.forEach(action);
  }

  @override
  bool get isEmpty => internalMap.isEmpty;

  @override
  bool get isNotEmpty => internalMap.isNotEmpty;

  @override
  Iterable<K> get keys => internalMap.keys;

  @override
  int get length => internalMap.length;

  @override
  Map<K2, V2> map<K2, V2>(MapEntry<K2, V2> Function(K key, V value) convert) {
    return internalMap.map(convert);
  }

  @override
  V putIfAbsent(K key, V Function() ifAbsent) {
    return internalMap.putIfAbsent(key, ifAbsent);
  }

  @override
  V remove(Object key) {
    return internalMap.remove(key);
  }

  @override
  void removeWhere(bool Function(K key, V value) test) {
    internalMap.removeWhere(test);
  }

  @override
  V update(K key, V Function(V value) update, {V Function() ifAbsent}) {
    return internalMap.update(key, update, ifAbsent: ifAbsent);
  }

  @override
  void updateAll(V Function(K key, V value) update) {
    internalMap.updateAll(update);
  }

  @override
  Iterable<V> get values => internalMap.values;

  String toString() => ToStringUtils.mapToString(internalMap);

  @override
  Set<String> getFields() => {key, value};

  @override
  dynamic getFieldValue(String field) => internalMap[key];

  void setFieldValue(String field, Object value) =>
      internalMap[field as K] = value;
}
