/*
 * ----------------------------------------------------------------------------
 * Copyright � 2009 by Mobile-Technologies Limited. All rights reserved. All intellectual property rights in and/or in
 * the computer program and its related documentation and technology are the sole Mobile-Technologies Limited property.
 * This computer program is under Mobile-Technologies Limited copyright and cannot be in whole or in part reproduced,
 * sublicensed, leased, sold or used in any form or by any means, including without limitation graphic, electronic,
 * mechanical, photocopying, recording, taping or information storage and retrieval systems without Mobile-Technologies
 * Limited prior written consent. The downloading, exporting or reexporting of this computer program or any related
 * documentation or technology is subject to any export rules, including US regulations.
 * ----------------------------------------------------------------------------
 */

const EN = "EN", AR = "AR";

abstract class BaseBundle {
  static const Map<String, Map<String, String>> map = {
    "form.data.fetch.failure": {
      EN: "Service is temporarily unavailable. Please try again later.",
      AR: "Service is temporarily unavailable. Please try again later. [ar]"
    },
    "form.permission.missing": {
      EN: "You don't have '{0}' permission.",
      AR: "You don't have '{0}' permission. [ar]"
    },
    "form.concurrent.view.error": {
      EN: "Access to this data is restricted as it's being currently viewed by another user.",
      AR: "Access to this data is restricted as it's being currently viewed by another user. [ar]"
    },
    "view.default.hint": {EN: "{0} - {1}", AR: "{0} - {1}"},
    "view.mandatory": {EN: "Mandatory", AR: "Mandatory [ar]"},
    "view.optional": {EN: "Optional", AR: "Optional [ar]"},
    "validation.mandatory.invalid": {
      EN: "Should not be empty.",
      AR: "Should not be empty. [ar]"
    },
    "validation.groupmandatory.invalid": {
      EN: "At least {0} field(s) should not be empty.",
      AR: "At least {0} field(s) should not be empty. [ar]"
    },
    "validation.pattern.invalid": {
      EN: "Must match '{0}'.",
      AR: "Must match '{0}'. [ar]"
    },
    "validation.pattern.find.invalid": {
      EN: "Must be able to find '{0}'.",
      AR: "Must be able to find '{0}'. [ar]"
    },
    "validation.email.invalid": {
      EN: "Not a well-formed email address.",
      AR: "Not a well-formed email address. [ar]"
    },
    "validation.future.invalid": {
      EN: "Date must be in the future.",
      AR: "Date must be in the future. [ar]"
    },
    "validation.future.date.invalid": {
      EN: "Date should be at least {0} year(s) {1} month(s) and {2} day(s) in future.",
      AR: "Date should be at least {0} year(s) {1} month(s) and {2} day(s) in future. [ar]"
    },
    "validation.past.invalid": {
      EN: "Date must be in the past.",
      AR: "Date must be in the past. [ar]"
    },
    "validation.past.date.invalid": {
      EN: "Date should be at least {0} year(s) {1} month(s) and {2} day(s) in past.",
      AR: "Date should be at least {0} year(s) {1} month(s) and {2} day(s) in past. [ar]"
    },
    "validation.length.invalid": {
      EN: "Length must be between {0} and {1}.",
      AR: "Length must be between {0} and {1}. [ar]"
    },
    "validation.length.equal.invalid": {
      EN: "Length must exactly be {1}.",
      AR: "Length must exactly be {1}. [ar]"
    },
    "validation.length.min.invalid": {
      EN: "Length must minimum be {0}.",
      AR: "Length must minimum be {0}. [ar]"
    },
    "validation.length.max.invalid": {
      EN: "Length must maximum be {1}.",
      AR: "Length must maximum be {1}. [ar]"
    },
    "validation.range.invalid": {
      EN: "Must be between {0} and {1}.",
      AR: "Must be between {0} and {1}. [ar]"
    },
    "validation.range.equal.invalid": {
      EN: "Must exactly be {1}.",
      AR: "Must exactly be {1}. [ar]"
    },
    "validation.range.min.invalid": {
      EN: "Must minimum be {0}.",
      AR: "Must minimum be {0}. [ar]"
    },
    "validation.range.max.invalid": {
      EN: "Must maximum be {1}.",
      AR: "Must maximum be {1}. [ar]"
    },
    "validation.word.invalid": {
      EN: "Words count must be between {0} and {1}.",
      AR: "Words count must be between {0} and {1}. [ar]"
    },
    "validation.word.equal.invalid": {
      EN: "Words count must exactly be {1}.",
      AR: "Words count must exactly be {1}. [ar]"
    },
    "validation.word.min.invalid": {
      EN: "Words count must minimum be {0}.",
      AR: "Words count must minimum be {0}. [ar]"
    },
    "validation.word.max.invalid": {
      EN: "Words count must maximum be {1}.",
      AR: "Words count must maximum be {1}. [ar]"
    },
    "validation.count.invalid": {
      EN: "Characters count must be between {0} and {1}.",
      AR: "Characters count must be between {0} and {1}. [ar]"
    },
    "validation.count.equal.invalid": {
      EN: "Characters count must exactly be {1}.",
      AR: "Characters count must exactly be {1}. [ar]"
    },
    "validation.count.min.invalid": {
      EN: "Characters count must minimum be {0}.",
      AR: "Characters count must minimum be {0}. [ar]"
    },
    "validation.count.max.invalid": {
      EN: "Characters count must maximum be {1}.",
      AR: "Characters count must maximum be {1}. [ar]"
    },
    "validation.alpha.invalid": {
      EN: "Should be alphabets only.",
      AR: "Should be alphabets only. [ar]"
    },
    "validation.numeric.invalid": {
      EN: "Should be numeric.",
      AR: "Should be numeric. [ar]"
    },
    "validation.alphanumeric.invalid": {
      EN: "Should be alpha-numeric.",
      AR: "Should be alpha-numeric. [ar]"
    },
    "validation.alphanumeric.mix.invalid": {
      EN: "Shouldn't have mixed languages.",
      AR: "Shouldn't have mixed languages. [ar]"
    },
    "validation.url.invalid": {
      EN: "Must be a valid URL.",
      AR: "Must be a valid URL. [ar]"
    },
    "validation.lowercase.invalid": {
      EN: "Text should be in lower case.",
      AR: "Text should be in lower case. [ar]"
    },
    "validation.mixedcase.invalid": {
      EN: "Text should be in mixed case.",
      AR: "Text should be in mixed case. [ar]"
    },
    "validation.camelcase.invalid": {
      EN: "Text should be in camel case.",
      AR: "Text should be in camel case. [ar]"
    },
    "validation.uppercase.invalid": {
      EN: "Text should be in upper case.",
      AR: "Text should be in upper case. [ar]"
    },
    "validation.hexadecimal.invalid": {
      EN: "Value should be hexadecimal (0-9 and A-F).",
      AR: "Value should be hexadecimal (0-9 and A-F). [ar]"
    },
    "validation.ipaddress.invalid": {
      EN: "Not a valid IP address.",
      AR: "Not a valid IP address. [ar]"
    },
    "validation.nospace.invalid": {
      EN: "Should not contain any spaces.",
      AR: "Should not contain any spaces. [ar]"
    },
    "validation.link.invalid": {
      EN: "Link is malformed.",
      AR: "Link is malformed. [ar]"
    },
    "validation.password.invalid": {
      EN: "Password must have 6 to 20 characters with at least one digit, one upper case letter, one lower case letter and one special symbol (\u201c@\#\$%\u201d).",
      AR: "Password must have 6 to 20 characters with at least one digit, one upper case letter, one lower case letter and one special symbol (\u201c@\#\$%\u201d). [ar]"
    },
    "validation.username.invalid": {
      EN: "User name is invalid.",
      AR: "User name is invalid. [ar]"
    },
    "validation.imsi.length.invalid": {
      EN: "Expected a positive number with 15 digits long.",
      AR: "Expected a positive number with 15 digits long. [ar]"
    },
    "validation.exclude.invalid": {
      EN: "Should not have '{0}' at position {1}.",
      AR: "Should not have '{0}' at position {1}. [ar]"
    },
    "validation.phonenumber.nospace": {
      EN: "Should not contain any spaces.",
      AR: "Should not contain any spaces. [ar]"
    },
    "validation.phonenumber.invalid": {
      EN: "Phone number format isn't correct.",
      AR: "Phone number format isn't correct. [ar]"
    },
    "validation.compare.invalid": {
      EN: "Should be {0} {1}.",
      AR: "Should be {0} {1}. [ar]"
    },
    "validation.iccid.invalid": {
      EN: "Invalid ICCID: the last 4 digits do not match with the full ICCID linked with this MSISDN.",
      AR: "Invalid ICCID: the last 4 digits do not match with the full ICCID linked with this MSISDN. [ar]"
    },
    "validation.msisdn.invalid": {
      EN: "Invalid GSM number: GSM number is not found, rejected / blocked, already registered or is going to be registered.",
      AR: "Invalid GSM number: GSM number is not found, rejected / blocked, already registered or is going to be registered. [ar]"
    },
    "validation.repetition.invalid": {
      EN: "Same characters can not repeat {0} times.",
      AR: "Same characters can not repeat {0} times. [ar]"
    },
    "validation.distinct.invalid": {
      EN: "Should contain minimum {0} distinct characters.",
      AR: "Should contain minimum {0} distinct characters. [ar]"
    },
    "validation.image.dimension": {
      EN: "Image dimension should comply to width({0}x{1}) and height({2}x{3}).",
      AR: "Image dimension should comply to width({0}x{1}) and height({2}x{3}). [ar]"
    },
    "validation.image.blurry": {
      EN: "Image looks blurry, please capture again. (Variance = {4})",
      AR: "Image looks blurry, please capture again. (Variance = {4}) [ar]"
    },
    "validation.file.size": {
      EN: "File size should comply to {0} - {1} KBs.",
      AR: "File size should comply to {0} - {1} KBs. [ar]"
    },
    "validation.duplicate.invalid": {
      EN: "Do not allow more than {0} duplicate values.",
      AR: "Do not allow more than {0} duplicate values. [ar]"
    },
    "validation.fingerprint.nfiq": {
      EN: "Please capture valid fingerprint (low NFIQ score).",
      AR: "Please capture valid fingerprint (low NFIQ score). [ar]"
    },
    "validation.fingerprint.minutiae": {
      EN: "Please capture valid fingerprint (low minutiae count).",
      AR: "Please capture valid fingerprint (low minutiae count). [ar]"
    },
    "validation.fingerprint.partial": {
      EN: "Can't accept partial fingerprint.",
      AR: "Can't accept partial fingerprint. [ar]"
    },
    "validation.script.invalid": {
      EN: "Value doesn't comply to the boolean expression.",
      AR: "Value doesn't comply to the boolean expression. [ar]"
    },
    "validation.face.min.invalid": {
      EN: "Should have minimum {0} face(s).",
      AR: "Should have minimum {0} face(s). [ar]"
    },
    "validation.face.max.invalid": {
      EN: "Should have maximum {1} face(s).",
      AR: "Should have maximum {1} face(s). [ar]"
    },
    "validation.face.equal.invalid": {
      EN: "Should have exactly {0} face(s).",
      AR: "Should have exactly {0} face(s). [ar]"
    },
    "validation.face.invalid": {
      EN: "Should have minimum {0} and maximum {1} faces.",
      AR: "Should have minimum {0} and maximum {1} faces. [ar]"
    },
    "validation.compare.eq": {EN: "equal to", AR: "equal to"},
    "validation.compare.ne": {EN: "unequal to", AR: "unequal to"},
    "validation.compare.le": {
      EN: "lesser than or equal to",
      AR: "lesser than or equal to"
    },
    "validation.compare.lt": {EN: "lesser than", AR: "lesser than"},
    "validation.compare.ge": {
      EN: "greater than or equal to",
      AR: "greater than or equal to"
    },
    "validation.compare.gt": {EN: "greater than", AR: "greater than"},
    "validation.text.contains.invalid": {
      EN: "Should contain '{0}'",
      AR: "Should contain '{0}' [ar]"
    },
    "validation.text.notcontains.invalid": {
      EN: "Shouldn't contain '{0}'",
      AR: "Shouldn't contain '{0}' [ar]"
    },
    "validation.text.equals.invalid": {
      EN: "Should be equal to '{0}'",
      AR: "Should be equal to '{0}' [ar]"
    },
    "validation.text.notequals.invalid": {
      EN: "Shoudn't be equal to '{0}'",
      AR: "Shoudn't be equal to '{0}' [ar]"
    },
    "validation.text.matches.invalid": {
      EN: "Should match '{0}'",
      AR: "Should match '{0}' [ar]"
    },
    "validation.text.notmatches.invalid": {
      EN: "Shouldn't match '{0}'",
      AR: "Shouldn't match '{0}' [ar]"
    },
    "validation.text.startswith.invalid": {
      EN: "Should start with '{0}'",
      AR: "Should start with '{0}' [ar]"
    },
    "validation.text.notstartswith.invalid": {
      EN: "Shouldn't start with '{0}'",
      AR: "Shouldn't start with '{0}' [ar]"
    },
    "validation.text.endswith.invalid": {
      EN: "Should end with '{0}'",
      AR: "Should end with '{0}' [ar]"
    },
    "validation.text.notendswith.invalid": {
      EN: "Shouldn't end with '{0}'",
      AR: "Shouldn't end with '{0}' [ar]"
    },
    "conversion.byte.failure": {
      EN: "Unable to convert input value to byte data type.",
      AR: "Unable to convert input value to byte data type. [ar]"
    },
    "conversion.short.failure": {
      EN: "Unable to convert input value to short data type.",
      AR: "Unable to convert input value to short data type. [ar]"
    },
    "conversion.number.failure": {
      EN: "Unable to convert input value to number data type.",
      AR: "Unable to convert input value to number data type. [ar]"
    },
    "conversion.long.failure": {
      EN: "Unable to convert input value to long data type.",
      AR: "Unable to convert input value to long data type. [ar]"
    },
    "conversion.float.failure": {
      EN: "Unable to convert input value to float data type.",
      AR: "Unable to convert input value to float data type. [ar]"
    },
    "conversion.decimal.failure": {
      EN: "Unable to convert input value to decimal data type.",
      AR: "Unable to convert input value to decimal data type. [ar]"
    },
    "conversion.character.failure": {
      EN: "Unable to convert input value to character data type.",
      AR: "Unable to convert input value to character data type. [ar]"
    },
    "conversion.boolean.failure": {
      EN: "Unable to convert input value to boolean data type.",
      AR: "Unable to convert input value to boolean data type. [ar]"
    },
    "conversion.date.failure": {
      EN: "Unable to convert input value to date data type.",
      AR: "Unable to convert input value to date data type. [ar]"
    },
    "conversion.time.failure": {
      EN: "Unable to convert input value to time data type.",
      AR: "Unable to convert input value to time data type. [ar]"
    },
    "conversion.datetime.failure": {
      EN: "Unable to convert input value to date-time data type.",
      AR: "Unable to convert input value to date-time data type. [ar]"
    },
    "conversion.binary.failure": {
      EN: "Unable to convert input value to binary data type.",
      AR: "Unable to convert input value to binary data type. [ar]"
    },
    "action.form.data.invalid": {
      EN: "Form data is invalid.",
      AR: "Form data is invalid. [ar]"
    },
    "action.accept.success": {
      EN: "Transaction has been accepted successfully.",
      AR: "Transaction has been accepted successfully. [ar]"
    },
    "action.accept.failure": {
      EN: "Unable to accept the transaction.",
      AR: "Unable to accept the transaction. [ar]"
    },
    "action.reject.wrong.mode": {
      EN: "REJECT_ALL and REJECT_NONE actions are only allowed in reject mode!",
      AR: "REJECT_ALL and REJECT_NONE actions are only allowed in reject mode! [ar]"
    },
    "action.reject.reason.missing": {
      EN: "Please provide the reason to reject!",
      AR: "Please provide the reason to reject! [ar]"
    },
    "action.reject.none.selected": {
      EN: "Please reject at least one field!",
      AR: "Please reject at least one field! [ar]"
    },
    "action.reject.success": {
      EN: "Transaction has been rejected successfully.",
      AR: "Transaction has been rejected successfully. [ar]"
    },
    "action.reject.failure": {
      EN: "Unable to reject the transaction.",
      AR: "Unable to reject the transaction. [ar]"
    },
    "action.reject.no.reason": {
      EN: "No reason provided to reject.",
      AR: "No reason provided to reject. [ar]"
    },
    "action.no.change": {
      EN: "There are no changes to save.",
      AR: "There are no changes to save. [ar]"
    },
    "action.revise.all": {
      EN: "Please revise all rejected values.",
      AR: "Please revise all rejected values. [ar]"
    },
    "action.value.not.revised": {
      EN: "Please enter revised value.",
      AR: "Please enter revised value. [ar]"
    },
    "action.update.successful": {
      EN: "Transaction updated successfully!",
      AR: "Transaction updated successfully! [ar]"
    },
    "action.update.error": {
      EN: "Unable to update the registration:",
      AR: "Unable to update the registration: [ar]"
    },
    "action.save.successful": {
      EN: "Transaction saved successfully!",
      AR: "Transaction saved successfully! [ar]"
    },
    "action.save.error": {
      EN: "Unable to save the registration:",
      AR: "Unable to save the registration: [ar]"
    },
    "action.unknown.reason": {
      EN: "Unknown reason!",
      AR: "Unknown reason! [ar]"
    },
    "action.unable.print": {
      EN: "Unable to print the transaction!",
      AR: "Unable to print the transaction! [ar]"
    },
    "action.print.success": {
      EN: "Transaction is successfully printed!",
      AR: "Transaction is successfully printed! [ar]"
    },
    "action.validation.code": {
      EN: "Validation code : {0}",
      AR: "Validation code : {0} [ar]"
    },
    "action.validation.code.sent": {
      EN: "Validation code sent to {0}!",
      AR: "Validation code sent to {0}! [ar]"
    },
    "action.no.sim.error": {
      EN: "Please install your SIM card and try again!",
      AR: "Please install your SIM card and try again! [ar]"
    },
    "action.sms.error": {
      EN: "Unable to SMS the validation code. Please try again!",
      AR: "Unable to SMS the validation code. Please try again! [ar]"
    },
    "validation.100.invalid": {
      EN: "MSISDN validation failed. Registration MSISDN in processing.",
      AR: "\u0641\u0634\u0644 \u0627\u0644\u062a\u062d\u0642\u0642 \u0645\u0646 \u0635\u062d\u0629 \u0634\u0631\u064a\u062d\u0629 \u0627\u0644\u062e\u0637\u060c \u064a\u062c\u0631\u064a \u062a\u0633\u062c\u064a\u0644 \u0634\u0631\u064a\u062d\u0629 \u0627\u0644\u062e\u0637"
    },
    "validation.200.invalid": {
      EN: "Registration already completed for this number.",
      AR: "\u0627\u0644\u062a\u0633\u062c\u064a\u0644 \u0627\u0646\u062c\u0632\u062a \u0628\u0627\u0644\u0641\u0639\u0644 \u0644\u0647\u0630\u0627 \u0627\u0644\u0631\u0642\u0645(\u0627\u0644\u0631\u0645\u0632 200-AC)."
    },
    "validation.205.invalid": {
      EN: "This GSM number and ICCID already registered or is going to be registered.",
      AR: "This GSM number and ICCID already registered or is going to be registered. [ar]"
    },
    "validation.301.invalid": {
      EN: "Service unavailable. The registration will be processed automatically later",
      AR: "Service unavailable. The registration will be processed automatically later [ar]"
    },
    "validation.401.invalid": {
      EN: "Transaction failed on the server.",
      AR: "Transaction failed on the server. [ar]"
    },
    "validation.402.invalid": {
      EN: "This GSM number and ICCID are not matched.",
      AR: "\u0631\u0642\u0645 \u0634\u0631\u064a\u062d\u0629 \u0627\u0644\u062e\u0637 \u0623\u0648\"\u0631\u0642\u0645 \u0627\u0644\u062a\u0633\u0644\u0633\u0644\u064a\" \u063a\u064a\u0631 \u0635\u062d\u064a\u062d \u0641\u064a \u0627\u0644\u0646\u0638\u0627\u0645"
    },
    "validation.403.invalid": {
      EN: "The transaction is cancelled on the server.",
      AR: "The transaction is cancelled on the server. [ar]"
    },
    "validation.404.invalid": {
      EN: "GSM number not found on the server.",
      AR: "GSM Number not found on the server. [ar]"
    },
    "validation.405.invalid": {
      EN: "This GSM number and ICCID are rejected.",
      AR: "This GSM number and ICCID are rejected. [ar]"
    },
    "validation.410.invalid": {
      EN: "The subscriber has reached his maximum numbers of SIM registrations.",
      AR: "The subscriber has reached his maximum numbers of SIM registrations. [ar]"
    },
    "validation.500.invalid": {
      EN: "Internal error in registration system (error code 500).",
      AR: "\u062e\u0637\u0623 \u062f\u0627\u062e\u0644\u064a \u0641\u064a \u0646\u0638\u0627\u0645 \u0627\u0644\u062a\u0633\u062c\u064a\u0644 (error code 500)"
    },
    "validation.503.invalid": {
      EN: "Can not communicate to each other internal module.",
      AR: "\u062e\u0637\u0623 \u0641\u064a \u0627\u062a\u0635\u0627\u0644 \u0628\u0627\u0644\u0634\u0628\u0643\u0629. \u0627\u0644\u0631\u062c\u0627\u0621 \u0641\u062d\u0635 \u0627\u0644\u062a\u0648\u0635\u064a\u0644 (error code 503)"
    },
    "validation.505.invalid": {
      EN: "External connection error in registration system (error code 505).",
      AR: "\u062e\u0637\u0623 \u0627\u062a\u0635\u0627\u0644 \u062e\u0627\u0631\u062c\u064a \u0641\u064a \u0646\u0638\u0627\u0645 \u0627\u0644\u062a\u0633\u062c\u064a\u0644 (error code 505)"
    },
    "validation.535.invalid": {
      EN: "External registration creation failed (error code 535).",
      AR: "External registration creation failed (error code 535). [ar]"
    },
    "validation.duplicated.msisdn": {
      EN: "MSISDN number is duplicated.",
      AR: "MSISDN Number is duplicated. [ar]"
    },
    "validation.duplicated.iccid": {
      EN: "ICCID number is duplicated.",
      AR: "ICCID Number is duplicated. [ar]"
    },
    "validation.tableduplicate.invalid": {
      EN: "Already in the table for max allowed count.",
      AR: "Already in the table for max allowed count. [ar]"
    },
    "table.row.exists": {
      EN: "Such record already exists at row # {0}.",
      AR: "Such record already exists at row # {0}. [ar]"
    },
    "table.disabled": {
      EN: "This table is disabled.",
      AR: "This table is disabled. [ar]"
    },
    "table.max.reached": {
      EN: "This table already holds maximum allowed number of rows.",
      AR: "This table already holds maximum allowed number of rows. [ar]"
    },
    "table.import.nothing": {
      EN: "No data found in the CSV to import into the table.",
      AR: "No data found in the CSV to import into the table. [ar]"
    },
    "table.import.success": {
      EN: "{0} of {1} rows were successfully imported into the table. Faulty rows: {2}",
      AR: "{0} of {1} rows were successfully imported into the table. Faulty rows: {2} [ar]"
    },
    "table.export.nothing": {
      EN: "No data to export.",
      AR: "No data to export. [ar]"
    },
    "table.edit": {EN: "Edit", AR: "Edit [ar]"},
    "table.remove": {EN: "Remove", AR: "Remove [ar]"},
    "array.invalid.empty": {
      EN: "There are no items in the drop-down.",
      AR: "There are no items in the drop-down. [ar]"
    },
    "array.invalid.item": {
      EN: "Invalid item '{0}'",
      AR: "Invalid item '{0}' [ar]"
    },
    "array.invalid.list": {
      EN: "Wrong options loaded, please select parent again.",
      AR: "Wrong options loaded, please select parent again. [ar]"
    },
    "array.invalid.text": {
      EN: "Please select a valid item.",
      AR: "Please select a valid item. [ar]"
    },
    "network.required.unavailable": {
      EN: "This feature is only available in online mode. Please ensure that data connection is available.",
      AR: "This feature is only available in online mode. Please ensure that data connection is available. [ar]"
    },
    "network.optional.unavailable": {
      EN: "Network not available, please check your connection.",
      AR: "Network not available, please check your connection. [ar]"
    },
    "rmi.unavailable": {
      EN: "Service is temporarily unavailable. Please try again later.",
      AR: "Service is temporarily unavailable. Please try again later. [ar]"
    },
    "rmi.service.unavailable": {
      EN: "Service is not available.",
      AR: "Service is not available. [ar]"
    },
    "rmi.network.unstable": {
      EN: "Network connection is unstable. Please check your connection.",
      AR: "Network connection is unstable. Please check your connection. [ar]"
    },
    "database.unavailable": {
      EN: "Unable to connect to database, please retry again later. If problem persists, please contact administrator.",
      AR: "Unable to connect to database, please retry again later. If problem persist, please contact administrator. [ar]"
    },
    "camera.resolution.unavailable": {
      EN: "Camera doesn't support the configured minimum resolution. It will be launched in the maximum available resolution {0}x{1}",
      AR: "Camera doesn't support the configured minimum resolution. It will be launched in the maximum available resolution {0}x{1} [ar]"
    },
    "fileupload.title": {
      EN: "Open Resource File",
      AR: "Open Resource File [ar]"
    },
    "fileupload.file.blank": {
      EN: "Can't upload a blank file.",
      AR: "Can't upload a blank file. [ar]"
    },
    "fileupload.filetype.error": {
      EN: "Only {0} files are accepted!",
      AR: "Only {0} files are accepted! [ar]"
    },
    "fileupload.image.unreadable": {
      EN: "Unable to read the selected image, please select another image.",
      AR: "Unable to read the selected image, please select another image. [ar]"
    },
    "card.data.missing": {
      EN: "Card reading failed, please use MRZ.",
      AR: "Card reading failed, please use MRZ. [ar]"
    },
    "card.data.error.101": {
      EN: "No card detected, please insert a valid card.",
      AR: "No card detected, please insert a valid card. [ar]"
    },
    "card.data.error.102": {
      EN: "Failed to open ICC reader, please try again.",
      AR: "Failed to open ICC reader. Please try again. [ar]"
    },
    "card.data.error.103": {
      EN: "Failed to properly close the Smart Card Reader.",
      AR: "Failed to properly close the Smart Card Reader. [ar]"
    },
    "card.data.error.104": {
      EN: "Failed to properly power off the ICC.",
      AR: "Failed to properly power off the ICC. [ar]"
    },
    "card.data.error.105": {
      EN: "Unsupported card, please try again with another card.",
      AR: "Unsupported card. Please try again with another card. [ar]"
    },
    "card.data.captured": {
      EN: "Card successfully read, please remove the card.",
      AR: "Card successfully read, please remove the card. [ar]"
    },
  };
}
