/*
 * ----------------------------------------------------------------------------
 * Copyright © 2009 by Mobile-Technologies Limited. All rights reserved. All intellectual property rights in and/or in
 * the computer program and its related documentation and technology are the sole Mobile-Technologies Limited property.
 * This computer program is under Mobile-Technologies Limited copyright and cannot be in whole or in part reproduced,
 * sublicensed, leased, sold or used in any form or by any means, including without limitation graphic, electronic,
 * mechanical, photocopying, recording, taping or information storage and retrieval systems without Mobile-Technologies
 * Limited prior written consent. The downloading, exporting or reexporting of this computer program or any related
 * documentation or technology is subject to any export rules, including US regulations.
 * ----------------------------------------------------------------------------
 */

import '../validation/converter/c_boolean.dart';

class Config {
  const Config._();

  // In production mode we parse JSON instead of XML for performance sake. But we parse XML during development as JSON
  // is harder to read for humans.
  static bool PRODUCTION_MODE = true;

  // On successful form parsing, should we cache it in memory for better performance sake?
  static bool CACHE_FORM = false;

  // this should be true only in case of Android version lesser than 4.
  static bool ENCODE_TEXT = CBoolean.NO;
  static String NAMESPACE = "http://web.internal.rm.isl.mt.com/";
  static bool DEBUG = false;

  // Map of 'msgId -> (langId -> translation)'
  static Map<String, Map<String, String>> EXTERNAL_BUNDLE;
  static bool IMMEDIATE = CBoolean.NO;
  static bool CUSTOM_CODE = CBoolean.NO;

  // Related to TLS cipher
  static bool USE_TLS_12 = false;

  // @see "https://developer.android.com/reference/javax/net/ssl/SSLSocket.html"
  static List<String> CIPHER_SUITES;
}
