/*
 * ----------------------------------------------------------------------------
 * Copyright © 2009 by Mobile-Technologies Limited. All rights reserved. All intellectual property rights in and/or in
 * the computer program and its related documentation and technology are the sole Mobile-Technologies Limited property.
 * This computer program is under Mobile-Technologies Limited copyright and cannot be in whole or in part reproduced,
 * sublicensed, leased, sold or used in any form or by any means, including without limitation graphic, electronic,
 * mechanical, photocopying, recording, taping or information storage and retrieval systems without Mobile-Technologies
 * Limited prior written consent. The downloading, exporting or reexporting of this computer program or any related
 * documentation or technology is subject to any export rules, including US regulations.
 * ----------------------------------------------------------------------------
 */

import '../ui/discrete/form_controller.dart';
import '../ui/discrete/view_state.dart';

/// Contract for custom action to be invoked when button is clicked.
abstract class IAction {
  /// Method that will be called with view parameter (the initiator).
  ///
  /// @param view
  ///        invoking component's viewState.
  /// @param controller
  ///        current controller.
  /// @return 'True' when need render/enable attributes of configured views are toggled, otherwise return 'False' for
  ///         skipping.
  bool doAct(ViewState view, FormController controller);
}
