/*
 * ----------------------------------------------------------------------------
 * Copyright © 2009 by Mobile-Technologies Limited. All rights reserved. All intellectual property rights in and/or in
 * the computer program and its related documentation and technology are the sole Mobile-Technologies Limited property.
 * This computer program is under Mobile-Technologies Limited copyright and cannot be in whole or in part reproduced,
 * sublicensed, leased, sold or used in any form or by any means, including without limitation graphic, electronic,
 * mechanical, photocopying, recording, taping or information storage and retrieval systems without Mobile-Technologies
 * Limited prior written consent. The downloading, exporting or reexporting of this computer program or any related
 * documentation or technology is subject to any export rules, including US regulations.
 * ----------------------------------------------------------------------------
 */

import '../ui/discrete/view_state.dart';

/// Contract for custom constraint that defines some special validation to be performed on a field.
abstract class IConstraint {
  /// Should define the constraint logic for the given view with the configured arguments.
  ///
  /// @param view
  ///        validating component's viewState.
  /// @param args
  ///        validate parameters
  /// @return Error message id when validation failed, otherwise return null.
  String doCheck(ViewState view, Map<String, Object> args);
}
