/*
 * ----------------------------------------------------------------------------
 * Copyright © 2009 by Mobile-Technologies Limited. All rights reserved. All intellectual property rights in and/or in
 * the computer program and its related documentation and technology are the sole Mobile-Technologies Limited property.
 * This computer program is under Mobile-Technologies Limited copyright and cannot be in whole or in part reproduced,
 * sublicensed, leased, sold or used in any form or by any means, including without limitation graphic, electronic,
 * mechanical, photocopying, recording, taping or information storage and retrieval systems without Mobile-Technologies
 * Limited prior written consent. The downloading, exporting or reexporting of this computer program or any related
 * documentation or technology is subject to any export rules, including US regulations.
 * ----------------------------------------------------------------------------
 */

import '../../form/structure/string_object_map.dart';
import '../ui/discrete/renderer/ui_renderer.dart';

abstract class IPhase {
  /// UIRenderer will be in preRender phase when 'rendering' is true. And it will be in postRender phase when
  /// 'rendering' is false.
  void onRender(bool rendering, UIRenderer renderer);

  /// In non-creation mode when data is successfully fetched, this method will check if there is any discrepancy in the
  /// data, if so, it should return the message-id of that error to be found in i18n or bundle.
  String checkData(StringObjectMap data, UIRenderer renderer);
}
