/*
 * ----------------------------------------------------------------------------
 * Copyright © 2009 by Mobile-Technologies Limited. All rights reserved. All intellectual property rights in and/or in
 * the computer program and its related documentation and technology are the sole Mobile-Technologies Limited property.
 * This computer program is under Mobile-Technologies Limited copyright and cannot be in whole or in part reproduced,
 * sublicensed, leased, sold or used in any form or by any means, including without limitation graphic, electronic,
 * mechanical, photocopying, recording, taping or information storage and retrieval systems without Mobile-Technologies
 * Limited prior written consent. The downloading, exporting or reexporting of this computer program or any related
 * documentation or technology is subject to any export rules, including US regulations.
 * ----------------------------------------------------------------------------
 */

import '../util/enum.dart';
import '../util/enum_utils.dart';

class Action extends Enum<Action> {
  // Supportive actions for a form
  static const NOTHING = Action("NOTHING");
  static const RENDER = Action("RENDER");
  static const ENABLE = Action("ENABLE");
  static const CLEAR = Action("CLEAR");
  static const RESET = Action("RESET");
  static const RECREATE = Action("RECREATE");
  static const NAVIGATE = Action("NAVIGATE");
  static const CLOSE = Action("CLOSE");
  static const DESTROY = Action("DESTROY");
  static const SHOWPOPUP = Action("SHOWPOPUP");
  static const CLOSEPOPUP = Action("CLOSEPOPUP");
  static const REJECT_ALL = Action("REJECT_ALL");
  static const REJECT_NONE = Action("REJECT_NONE");

  // Mode changing actions
  static const PRE_SAVE_VIEW = Action("PRE_SAVE_VIEW");
  static const PREVIEW = Action("PREVIEW");
  static const POST_SAVE_VIEW = Action("POST_SAVE_VIEW");
  static const CREATE = Action("CREATE");
  static const EDIT = Action("EDIT");
  static const REJECTION = Action("REJECTION");
  static const REVISION = Action("REVISION");

  // Actions dealing directly with form data
  static const VALIDATE = Action("VALIDATE");
  static const ACCEPT = Action("ACCEPT");
  static const REJECT = Action("REJECT");
  static const REVISE = Action("REVISE");
  static const SAVE = Action("SAVE");
  static const FETCH = Action("FETCH");
  static const CLEAR_LIST = Action("CLEAR_LIST");
  static const FETCH_LIST = Action("FETCH_LIST");
  static const UPDATE = Action("UPDATE");
  static const PRINT = Action("PRINT");
  static const SMS = Action("SMS");

  // Actions for the table component
  static const TABLE_SAVE = Action("TABLE_SAVE");
  static const TABLE_CLEAR = Action("TABLE_CLEAR");
  static const TABLE_CANCEL = Action("TABLE_CANCEL");

  const Action(String name) : super(name);

  static Action toAction(String action, bool throwOnMismatch) {
    return EnumUtils.toEnum_(action, _ENUMS, throwOnMismatch);
  }

  static const List<Action> _ENUMS = [
    NOTHING,
    RENDER,
    ENABLE,
    CLEAR,
    RESET,
    RECREATE,
    NAVIGATE,
    CLOSE,
    DESTROY,
    SHOWPOPUP,
    CLOSEPOPUP,
    REJECT_ALL,
    REJECT_NONE,
    PRE_SAVE_VIEW,
    PREVIEW,
    POST_SAVE_VIEW,
    CREATE,
    EDIT,
    REJECTION,
    REVISION,
    VALIDATE,
    ACCEPT,
    REJECT,
    REVISE,
    SAVE,
    FETCH,
    CLEAR_LIST,
    FETCH_LIST,
    UPDATE,
    PRINT,
    SMS,
    TABLE_SAVE,
    TABLE_CLEAR,
    TABLE_CANCEL
  ];
}
