/*
 * ----------------------------------------------------------------------------
 * Copyright © 2009 by Mobile-Technologies Limited. All rights reserved. All intellectual property rights in and/or in
 * the computer program and its related documentation and technology are the sole Mobile-Technologies Limited property.
 * This computer program is under Mobile-Technologies Limited copyright and cannot be in whole or in part reproduced,
 * sublicensed, leased, sold or used in any form or by any means, including without limitation graphic, electronic,
 * mechanical, photocopying, recording, taping or information storage and retrieval systems without Mobile-Technologies
 * Limited prior written consent. The downloading, exporting or reexporting of this computer program or any related
 * documentation or technology is subject to any export rules, including US regulations.
 * ----------------------------------------------------------------------------
 */

import '../util/enum.dart';
import '../util/enum_utils.dart';

class Alignment extends Enum<Alignment> {
  static const Alignment START = Alignment('START');
  static const Alignment END = Alignment('END');

  static const Alignment TOP_START = Alignment('TOP_START');
  static const Alignment TOP_END = Alignment('TOP_END');
  static const Alignment TOP_LEFT = Alignment('TOP_LEFT');
  static const Alignment TOP_CENTER = Alignment('TOP_CENTER');
  static const Alignment TOP_RIGHT = Alignment('TOP_RIGHT');

  static const Alignment CENTER_START = Alignment('CENTER_START');
  static const Alignment CENTER_END = Alignment('CENTER_END');
  static const Alignment CENTER_LEFT = Alignment('CENTER_LEFT');
  static const Alignment CENTER = Alignment('CENTER');
  static const Alignment CENTER_RIGHT = Alignment('CENTER_RIGHT');

  static const Alignment BOTTOM_START = Alignment('BOTTOM_START');
  static const Alignment BOTTOM_END = Alignment('BOTTOM_END');
  static const Alignment BOTTOM_LEFT = Alignment('BOTTOM_LEFT');
  static const Alignment BOTTOM_CENTER = Alignment('BOTTOM_CENTER');
  static const Alignment BOTTOM_RIGHT = Alignment('BOTTOM_RIGHT');

  static const Alignment LEFT = Alignment('LEFT');

  static const Alignment CENTER_HORIZONTAL = Alignment('CENTER_HORIZONTAL');
  static const Alignment CENTER_VERTICAL = Alignment('CENTER_VERTICAL');

  static const Alignment RIGHT = Alignment('RIGHT');

  const Alignment(String name) : super(name);

  static Alignment toAlignment(String alignment, bool throwOnMismatch) {
    return EnumUtils.toEnum_(alignment, _ENUMS, throwOnMismatch);
  }

  static const List<Alignment> _ENUMS = [
    START,
    END,
    TOP_LEFT,
    TOP_CENTER,
    TOP_RIGHT,
    CENTER_LEFT,
    CENTER,
    CENTER_RIGHT,
    BOTTOM_LEFT,
    BOTTOM_CENTER,
    BOTTOM_RIGHT,
    LEFT,
    CENTER_HORIZONTAL,
    CENTER_VERTICAL,
    RIGHT
  ];
}
