/*
 * ----------------------------------------------------------------------------
 * Copyright © 2009 by Mobile-Technologies Limited. All rights reserved. All intellectual property rights in and/or in
 * the computer program and its related documentation and technology are the sole Mobile-Technologies Limited property.
 * This computer program is under Mobile-Technologies Limited copyright and cannot be in whole or in part reproduced,
 * sublicensed, leased, sold or used in any form or by any means, including without limitation graphic, electronic,
 * mechanical, photocopying, recording, taping or information storage and retrieval systems without Mobile-Technologies
 * Limited prior written consent. The downloading, exporting or reexporting of this computer program or any related
 * documentation or technology is subject to any export rules, including US regulations.
 * ----------------------------------------------------------------------------
 */

import '../util/enum.dart';
import '../util/enum_utils.dart';

class FontStyle extends Enum<FontStyle> {
  static const NORMAL = FontStyle("NORMAL");
  static const BOLD = FontStyle("BOLD");
  static const ITALIC = FontStyle("ITALIC");

  // TODO Support BOLD_ITALIC?

  const FontStyle(String name) : super(name);

  static FontStyle toStyle(String style, bool throwOnMismatch) {
    return EnumUtils.toEnum_(style, _ENUMS, throwOnMismatch);
  }

  static const List<FontStyle> _ENUMS = [NORMAL, BOLD, ITALIC];
}
