/*
 * ----------------------------------------------------------------------------
 * Copyright © 2009 by Mobile-Technologies Limited. All rights reserved. All intellectual property rights in and/or in
 * the computer program and its related documentation and technology are the sole Mobile-Technologies Limited property.
 * This computer program is under Mobile-Technologies Limited copyright and cannot be in whole or in part reproduced,
 * sublicensed, leased, sold or used in any form or by any means, including without limitation graphic, electronic,
 * mechanical, photocopying, recording, taping or information storage and retrieval systems without Mobile-Technologies
 * Limited prior written consent. The downloading, exporting or reexporting of this computer program or any related
 * documentation or technology is subject to any export rules, including US regulations.
 * ----------------------------------------------------------------------------
 */

import '../config/defaults.dart';
import '../util/enum.dart';
import '../util/enum_utils.dart';

class Orientation extends Enum<Orientation> {
  static const VERTICAL = Orientation(1, "VERTICAL");
  static const HORIZONTAL = Orientation(Defaults.MISSING, "HORIZONTAL");

  final int columns;

  const Orientation(this.columns, String name) : super(name);

  static Orientation getDefault(bool container) {
    return container ? VERTICAL : HORIZONTAL;
  }

  static bool isHorizontal(int columns) {
    return columns == HORIZONTAL.columns;
  }

  static Orientation toOrientation(String orientation, bool throwOnMismatch) {
    return EnumUtils.toEnum_(orientation, _ENUMS, throwOnMismatch);
  }

  static const List<Orientation> _ENUMS = [VERTICAL, HORIZONTAL];
}
