/*
 * ----------------------------------------------------------------------------
 * Copyright © 2009 by Mobile-Technologies Limited. All rights reserved. All intellectual property rights in and/or in
 * the computer program and its related documentation and technology are the sole Mobile-Technologies Limited property.
 * This computer program is under Mobile-Technologies Limited copyright and cannot be in whole or in part reproduced,
 * sublicensed, leased, sold or used in any form or by any means, including without limitation graphic, electronic,
 * mechanical, photocopying, recording, taping or information storage and retrieval systems without Mobile-Technologies
 * Limited prior written consent. The downloading, exporting or reexporting of this computer program or any related
 * documentation or technology is subject to any export rules, including US regulations.
 * ----------------------------------------------------------------------------
 */

import '../util/enum.dart';
import '../util/enum_utils.dart';

class Permission extends Enum<Permission> {
  static const CREATE = Permission("CREATE");
  static const VIEW = Permission("VIEW");
  static const UPDATE = Permission("UPDATE");
  static const ACCEPT = Permission("ACCEPT");
  static const REJECT = Permission("REJECT");
  static const REVISE = Permission("REVISE");
  static const PRINT = Permission("PRINT");
  static const CHANGEPIN = Permission("CHANGEPIN");
  static const ADD = Permission("ADD");
  static const REMOTE_VALIDATE = Permission("REMOTE_VALIDATE");
  static const OFFLINE_LOGIN = Permission("OFFLINE_LOGIN");

  const Permission(String name) : super(name);

  static Permission toPermission(String permission, bool throwOnMismatch) {
    return EnumUtils.toEnum_(permission, _ENUMS, throwOnMismatch);
  }

  static const List<Permission> _ENUMS = [
    CREATE,
    VIEW,
    UPDATE,
    ACCEPT,
    REJECT,
    REVISE,
    PRINT,
    CHANGEPIN,
    ADD,
    REMOTE_VALIDATE,
    OFFLINE_LOGIN
  ];
}
