/*
 * ----------------------------------------------------------------------------
 * Copyright © 2009 by Mobile-Technologies Limited. All rights reserved. All intellectual property rights in and/or in
 * the computer program and its related documentation and technology are the sole Mobile-Technologies Limited property.
 * This computer program is under Mobile-Technologies Limited copyright and cannot be in whole or in part reproduced,
 * sublicensed, leased, sold or used in any form or by any means, including without limitation graphic, electronic,
 * mechanical, photocopying, recording, taping or information storage and retrieval systems without Mobile-Technologies
 * Limited prior written consent. The downloading, exporting or reexporting of this computer program or any related
 * documentation or technology is subject to any export rules, including US regulations.
 * ----------------------------------------------------------------------------
 */

import '../config/defaults.dart';
import '../util/enum.dart';
import '../util/enum_utils.dart';

class Platform extends Enum<Platform> {
  static const ANDROID = Platform("form.wf.ui", "ANDROID");
  static const IOS = Platform("form.wf.ui", "IOS");
  static const JAVAFX = Platform("form.ui.fx", "JAVAFX");
  static const JSF = Platform(Defaults.FORM_UI, "JSF");
  static const VIRTUAL = Platform(Defaults.FORM_UI, "VIRTUAL");
  static const TEST = Platform(Defaults.FORM_UI, "TEST");

  final String _uiFile;

  const Platform(this._uiFile, String name) : super(name);

  String getUiFile() {
    return _uiFile;
  }

  static Platform toPlatform(String platform, bool throwOnMismatch) {
    return EnumUtils.toEnum_(platform, _ENUMS, throwOnMismatch);
  }

  static const List<Platform> _ENUMS = [
    ANDROID,
    IOS,
    JAVAFX,
    JSF,
    VIRTUAL,
    TEST
  ];
}
