/*
 * ----------------------------------------------------------------------------
 * Copyright © 2009 by Mobile-Technologies Limited. All rights reserved. All intellectual property rights in and/or in
 * the computer program and its related documentation and technology are the sole Mobile-Technologies Limited property.
 * This computer program is under Mobile-Technologies Limited copyright and cannot be in whole or in part reproduced,
 * sublicensed, leased, sold or used in any form or by any means, including without limitation graphic, electronic,
 * mechanical, photocopying, recording, taping or information storage and retrieval systems without Mobile-Technologies
 * Limited prior written consent. The downloading, exporting or reexporting of this computer program or any related
 * documentation or technology is subject to any export rules, including US regulations.
 * ----------------------------------------------------------------------------
 */

import '../util/enum.dart';
import '../util/enum_utils.dart';
import '../util/utils.dart';
import 'code.dart';

class Scope extends Enum<Scope> {
  static const ALLTOPVIEWS = Scope("ALLTOPVIEWS");
  static const NOTOPVIEWS = Scope("NOTOPVIEWS");

  static const ALLINPUTVIEWS = Scope("ALLINPUTVIEWS");
  static const NOINPUTVIEWS = Scope("NOINPUTVIEWS");

  static const ALL = Scope("ALL");
  static const NONE = Scope("NONE");
  static const THIS = Scope("THIS");

  static const REGION = Scope("REGION");

  const Scope(String name) : super(name);

  String id() {
    return Code.EFFECT.prefix(toString());
  }

  bool check(String id) {
    return Utils.equalsIgnoreCase(this.id(), id);
  }

  static bool isNone(String scope) {
    return NONE.check(scope);
  }

  static Scope toScope(String scope, bool throwOnMismatch) {
    return EnumUtils.toEnum_(scope, _ENUMS, throwOnMismatch);
  }

  static const List<Scope> _ENUMS = [
    ALLTOPVIEWS,
    NOTOPVIEWS,
    ALLINPUTVIEWS,
    NOINPUTVIEWS,
    ALL,
    NONE,
    THIS,
    REGION
  ];
}
