/*
 * ----------------------------------------------------------------------------
 * Copyright © 2009 by Mobile-Technologies Limited. All rights reserved. All intellectual property rights in and/or in
 * the computer program and its related documentation and technology are the sole Mobile-Technologies Limited property.
 * This computer program is under Mobile-Technologies Limited copyright and cannot be in whole or in part reproduced,
 * sublicensed, leased, sold or used in any form or by any means, including without limitation graphic, electronic,
 * mechanical, photocopying, recording, taping or information storage and retrieval systems without Mobile-Technologies
 * Limited prior written consent. The downloading, exporting or reexporting of this computer program or any related
 * documentation or technology is subject to any export rules, including US regulations.
 * ----------------------------------------------------------------------------
 */

import '../util/enum.dart';
import '../util/enum_utils.dart';

class SortMethod extends Enum<SortMethod> {
  static const ID_ASC = SortMethod("ID_ASC");
  static const ID_DESC = SortMethod("ID_DESC");
  static const MSG_ASC = SortMethod("MSG_ASC");
  static const MSG_DESC = SortMethod("MSG_DESC");
  static const SHUFFLE = SortMethod("SHUFFLE");
  static const REVERSE = SortMethod("REVERSE");

  const SortMethod(String name) : super(name);

  static SortMethod toMethod(String method, bool throwOnMismatch) {
    return EnumUtils.toEnum_(method, _ENUMS, throwOnMismatch);
  }

  static const List<SortMethod> _ENUMS = [
    ID_ASC,
    ID_DESC,
    MSG_ASC,
    MSG_DESC,
    SHUFFLE,
    REVERSE
  ];
}
