/*
 * ----------------------------------------------------------------------------
 * Copyright © 2009 by Mobile-Technologies Limited. All rights reserved. All intellectual property rights in and/or in
 * the computer program and its related documentation and technology are the sole Mobile-Technologies Limited property.
 * This computer program is under Mobile-Technologies Limited copyright and cannot be in whole or in part reproduced,
 * sublicensed, leased, sold or used in any form or by any means, including without limitation graphic, electronic,
 * mechanical, photocopying, recording, taping or information storage and retrieval systems without Mobile-Technologies
 * Limited prior written consent. The downloading, exporting or reexporting of this computer program or any related
 * documentation or technology is subject to any export rules, including US regulations.
 * ----------------------------------------------------------------------------
 */

import '../util/enum.dart';
import '../util/enum_utils.dart';

class TableAction extends Enum<TableAction> {
  static const NONE = TableAction(0, "NONE");
  static const EDIT = TableAction(1, "EDIT");
  static const REMOVE = TableAction(1, "REMOVE");
  static const EDIT_REMOVE = TableAction(2, "EDIT_REMOVE");

  final int columns;

  const TableAction(this.columns, String name) : super(name);

  static TableAction toAction(String action, bool throwOnMismatch) {
    return EnumUtils.toEnum_(action, _ENUMS, throwOnMismatch);
  }

  static const List<TableAction> _ENUMS = [NONE, EDIT, REMOVE, EDIT_REMOVE];
}
