/*
 * ----------------------------------------------------------------------------
 * Copyright © 2009 by Mobile-Technologies Limited. All rights reserved. All intellectual property rights in and/or in
 * the computer program and its related documentation and technology are the sole Mobile-Technologies Limited property.
 * This computer program is under Mobile-Technologies Limited copyright and cannot be in whole or in part reproduced,
 * sublicensed, leased, sold or used in any form or by any means, including without limitation graphic, electronic,
 * mechanical, photocopying, recording, taping or information storage and retrieval systems without Mobile-Technologies
 * Limited prior written consent. The downloading, exporting or reexporting of this computer program or any related
 * documentation or technology is subject to any export rules, including US regulations.
 * ----------------------------------------------------------------------------
 */

import '../config/defaults.dart';
import '../error/illegal_argument_exception.dart';
import '../structure/i18n/i18n.dart';
import '../structure/model/model.dart';
import '../structure/ui/ui.dart';
import '../util/utils.dart';

class Form {
  final Model model;
  final UI ui;
  final I18n i18n;

  Form(this.model, this.ui, this.i18n) {
    if (Utils.anyNull([model, ui, i18n])) {
      throw IllegalArgumentException(Defaults.MSG_MISSING_ARTIFACT);
    }

    this.model.toMap();
    this.ui.toMap();
    this.i18n.toMap();
  }

  int getId() {
    return model.getId(); // id from any artifact should be fine
  }

  Model getModel() {
    return model;
  }

  UI getUi() {
    return ui;
  }

  I18n getI18n() {
    return i18n;
  }

  @override
  String toString() => "Form [model=$model, ui=$ui, i18n=$i18n]";
}
