/*
 * ----------------------------------------------------------------------------
 * Copyright © 2009 by Mobile-Technologies Limited. All rights reserved. All intellectual property rights in and/or in
 * the computer program and its related documentation and technology are the sole Mobile-Technologies Limited property.
 * This computer program is under Mobile-Technologies Limited copyright and cannot be in whole or in part reproduced,
 * sublicensed, leased, sold or used in any form or by any means, including without limitation graphic, electronic,
 * mechanical, photocopying, recording, taping or information storage and retrieval systems without Mobile-Technologies
 * Limited prior written consent. The downloading, exporting or reexporting of this computer program or any related
 * documentation or technology is subject to any export rules, including US regulations.
 * ----------------------------------------------------------------------------
 */

import 'dart:typed_data' show Uint8List;

import '../config/defaults.dart';
import '../error/illegal_argument_exception.dart';
import '../util/base64.dart';
import '../util/utils.dart';

class RawForm {
  final String model;
  final String ui;
  final String i18n;

  RawForm(this.model, this.ui, this.i18n) {
    if (Utils.anyBlank([model, ui, i18n])) {
      throw IllegalArgumentException(Defaults.MSG_MISSING_ARTIFACT);
    }
  }

  static RawForm getDecodedForm(Uint8List model, Uint8List ui, Uint8List i18n) {
    return RawForm(Base64.decodeToString(model), Base64.decodeToString(ui),
        Base64.decodeToString(i18n));
  }

  String getModel() {
    return model;
  }

  String getUi() {
    return ui;
  }

  String getI18n() {
    return i18n;
  }
}
