/*
 * ----------------------------------------------------------------------------
 * Copyright © 2009 by Mobile-Technologies Limited. All rights reserved. All intellectual property rights in and/or in
 * the computer program and its related documentation and technology are the sole Mobile-Technologies Limited property.
 * This computer program is under Mobile-Technologies Limited copyright and cannot be in whole or in part reproduced,
 * sublicensed, leased, sold or used in any form or by any means, including without limitation graphic, electronic,
 * mechanical, photocopying, recording, taping or information storage and retrieval systems without Mobile-Technologies
 * Limited prior written consent. The downloading, exporting or reexporting of this computer program or any related
 * documentation or technology is subject to any export rules, including US regulations.
 * ----------------------------------------------------------------------------
 */

import 'dart:typed_data' show Uint8List;

import '../../config/defaults.dart';
import '../../enums/platform.dart';
import '../../structure/i18n/i18n.dart';
import '../../util/utils.dart';
import '../form.dart';
import 'json_reader.dart';

class FormReader {
  const FormReader();

  Form read(String path, Platform platform) {
    return read_(path, platform.getUiFile());
  }

  Form read_(String path, String baseUI) {
    String folder = Utils.suffixSlash(path);
    return read__(folder + Defaults.FORM_MODEL, folder + baseUI,
        folder + Defaults.FORM_I18N);
  }

  Form read__(String modelPath, String uiPath, String i18nPath) {
    // const String ext = JsonReader.EXT;
    //
    // try (InputStream model = FileInputStream(Utils.suffix(modelPath, ext));
    //         InputStream ui = FileInputStream(Utils.suffix(uiPath, ext));
    //         InputStream i18n = FileInputStream(Utils.suffix(i18nPath, ext))) {
    //     return read(model, ui, i18n);
    // }
    return Form(null, null, null);
  }

  Form read___(Uint8List model, Uint8List ui, Uint8List i18n) {
    // try (InputStream sModel = IOUtils.toStream(model);
    //         InputStream sUi = IOUtils.toStream(ui);
    //         InputStream sI18n = IOUtils.toStream(i18n)) {
    //     if (Utils.anyNull(sModel, sUi, sI18n)) {
    //         throw IllegalArgumentException(Defaults.MSG_MISSING_ARTIFACT);
    //     }
    //
    //     return read(sModel, sUi, sI18n);
    // }
    return Form(null, null, null);
  }

  Form read____(Stream model, Stream ui, Stream i18n) {
    return JsonReader().read_(model, ui, i18n);
  }

  I18n toI18n(String raw) {
    I18n i18n = JsonReader().fromJson(raw, I18n);
    i18n.toMap();
    return i18n;
  }
}
