/*
 * ----------------------------------------------------------------------------
 * Copyright © 2009 by Mobile-Technologies Limited. All rights reserved. All intellectual property rights in and/or in
 * the computer program and its related documentation and technology are the sole Mobile-Technologies Limited property.
 * This computer program is under Mobile-Technologies Limited copyright and cannot be in whole or in part reproduced,
 * sublicensed, leased, sold or used in any form or by any means, including without limitation graphic, electronic,
 * mechanical, photocopying, recording, taping or information storage and retrieval systems without Mobile-Technologies
 * Limited prior written consent. The downloading, exporting or reexporting of this computer program or any related
 * documentation or technology is subject to any export rules, including US regulations.
 * ----------------------------------------------------------------------------
 */

import '../../config/defaults.dart';
import '../../enums/dir.dart';
import '../../util/form_utils.dart';
import '../../util/utils.dart';
import '../required_id_tag.dart';

// @Root
class Locale extends RequiredIdTag {
  // @Attribute(required = false)
  Dir dir;

  // @Attribute(required = false)
  bool prefixStar;

  // @Attribute(required = false)
  String country; // for external bundle only

  // @Attribute(required = false)
  String digits; // for non-EN locale

  Locale() {
    // default constructor required for de/serialization
  }

  Locale.id(String id) : this.dir(id, Defaults.DIR);

  Locale.dir(String id, Dir dir) : super.id(id) {
    this.dir = dir;
  }

  Locale.json(Map json) : super.json(json) {
    this.dir = Dir.toDir(json['dir'], true);
    this.prefixStar = json['prefixStar'];
    this.country = json['country'];
    this.digits = json['digits'];
  }

  Dir getDir() {
    return Utils.toDefault(dir, Defaults.DIR);
  }

  bool getPrefixStar() {
    return prefixStar == null ? FormUtils.isLtr_(getDir()) : prefixStar;
  }

  String getCountry() {
    return this.country;
  }

  String getDigits() {
    return this.digits;
  }

  @override
  String toString() => "Locale [language=${getId()}, dir=$dir]";
}
