/*
 * ----------------------------------------------------------------------------
 * Copyright © 2009 by Mobile-Technologies Limited. All rights reserved. All intellectual property rights in and/or in
 * the computer program and its related documentation and technology are the sole Mobile-Technologies Limited property.
 * This computer program is under Mobile-Technologies Limited copyright and cannot be in whole or in part reproduced,
 * sublicensed, leased, sold or used in any form or by any means, including without limitation graphic, electronic,
 * mechanical, photocopying, recording, taping or information storage and retrieval systems without Mobile-Technologies
 * Limited prior written consent. The downloading, exporting or reexporting of this computer program or any related
 * documentation or technology is subject to any export rules, including US regulations.
 * ----------------------------------------------------------------------------
 */

import '../../error/value_required_exception.dart';
import '../../util/utils.dart';
import 'constraint.dart';

class GlobalConstraint extends Constraint {
  // @Attribute(required = true)
  String alias;

  GlobalConstraint() {
    // default constructor required for de/serialization
  }

  GlobalConstraint.json(Map json) : super.json(json) {
    this.alias = json['alias'];

    if (Utils.isBlank(this.alias)) {
      throw ValueRequiredException("GlobalConstraint", "alias");
    }
  }

  @override
  String resolveId() {
    return getAlias();
  }

  String getAlias() {
    return alias;
  }

  @override
  String toString() => "GlobalConstraint [alias=$alias], ${super.toString()}";
}
