/*
 * ----------------------------------------------------------------------------
 * Copyright © 2009 by Mobile-Technologies Limited. All rights reserved. All intellectual property rights in and/or in
 * the computer program and its related documentation and technology are the sole Mobile-Technologies Limited property.
 * This computer program is under Mobile-Technologies Limited copyright and cannot be in whole or in part reproduced,
 * sublicensed, leased, sold or used in any form or by any means, including without limitation graphic, electronic,
 * mechanical, photocopying, recording, taping or information storage and retrieval systems without Mobile-Technologies
 * Limited prior written consent. The downloading, exporting or reexporting of this computer program or any related
 * documentation or technology is subject to any export rules, including US regulations.
 * ----------------------------------------------------------------------------
 */

import '../error/value_required_exception.dart';
import '../ui/discrete/component/behavior/i_map.dart';

abstract class RootTag implements IMap {
  // @Attribute(required = true)
  int id;

  // @Attribute(required = true)
  int version;

  RootTag() {
    // default constructor required for de/serialization
  }

  RootTag.id(this.id, this.version) {
    if (this.id == null) {
      throw ValueRequiredException("RootTag", "id");
    }

    if (this.version == null) {
      throw ValueRequiredException("RootTag", "version");
    }
  }

  RootTag.json(Map json) : this.id(json['id'], json['version']);

  int getId() {
    return id;
  }

  int getVersion() {
    return version;
  }

  @override
  String toString() => "$id v$version";
}
