/*
 * ----------------------------------------------------------------------------
 * Copyright © 2009 by Mobile-Technologies Limited. All rights reserved. All intellectual property rights in and/or in
 * the computer program and its related documentation and technology are the sole Mobile-Technologies Limited property.
 * This computer program is under Mobile-Technologies Limited copyright and cannot be in whole or in part reproduced,
 * sublicensed, leased, sold or used in any form or by any means, including without limitation graphic, electronic,
 * mechanical, photocopying, recording, taping or information storage and retrieval systems without Mobile-Technologies
 * Limited prior written consent. The downloading, exporting or reexporting of this computer program or any related
 * documentation or technology is subject to any export rules, including US regulations.
 * ----------------------------------------------------------------------------
 */

import '../../../../../form/bean/server_response.dart';

abstract class RMI {
  static const String SECURITY_TOKEN = "SECURITY_TOKEN";

  /// Before invocation, we need to make sure that the network is available.
  Future<bool> isNetworkAvailable();

  /// Invoked the remote method for the given parameters.
  ///
  /// @param service
  ///        Web Service or CMI core name
  /// @param method
  ///        Web Service method or CMI task name
  /// @param namespace
  ///        Web Service namespace or <null> for CMI
  /// @param timeout
  ///        Connection timeout in milliseconds
  /// @param clazz
  ///        Class of the bean to be set in the request object (CMI only)
  /// @param data
  ///        Data to be passed to the service's method. For CMI, map will be dynamically assigned to bean
  ///        attributes. Map keys should be case-sensitive since Java is case-sensitive.
  Future<ServerResponse> invoke(String service, String method, String namespace,
      int timeout, String clazz, Map<String, Object> data);
}
