/*
 * ----------------------------------------------------------------------------
 * Copyright © 2009 by Mobile-Technologies Limited. All rights reserved. All intellectual property rights in and/or in
 * the computer program and its related documentation and technology are the sole Mobile-Technologies Limited property.
 * This computer program is under Mobile-Technologies Limited copyright and cannot be in whole or in part reproduced,
 * sublicensed, leased, sold or used in any form or by any means, including without limitation graphic, electronic,
 * mechanical, photocopying, recording, taping or information storage and retrieval systems without Mobile-Technologies
 * Limited prior written consent. The downloading, exporting or reexporting of this computer program or any related
 * documentation or technology is subject to any export rules, including US regulations.
 * ----------------------------------------------------------------------------
 */

import '../../../../../../form/bean/server_response.dart';
import '../../../../../../form/structure/ordered_map.dart';
import '../../../../../contract/i_rmi.dart';
import '../../../../../structure/i18n/option.dart';
import '../../../../../structure/ui/method/response.dart';
import '../../../../../util/utils.dart';
import '../../../method_state.dart';
import '../../../renderer/ui_renderer.dart';
import 'rmi_cycle.dart';

class ArrayCycle extends RMICycle {
  List<Option> options;

  ArrayCycle(MethodState methodState, IRmi iRmi, UIRenderer renderer)
      : super(methodState, iRmi, null, renderer);

  @override
  void gotResponse(
      bool success, ServerResponse serverResponse, Response response) {
    // TODO On failure, we should return blank list?
    OrderedMap<String> map = success ? serverResponse.getArrayOptions() : null;

    if (!Utils.isBlank(map)) {
      options = [];

      for (String optionId in map.keys) {
        options.add(Option.id(optionId, map[optionId]));
      }
    }

    super.gotResponse(success, serverResponse, response);
  }

  @override
  List<Option> getResult() {
    return options;
  }
}
