/*
 * ----------------------------------------------------------------------------
 * Copyright © 2009 by Mobile-Technologies Limited. All rights reserved. All intellectual property rights in and/or in
 * the computer program and its related documentation and technology are the sole Mobile-Technologies Limited property.
 * This computer program is under Mobile-Technologies Limited copyright and cannot be in whole or in part reproduced,
 * sublicensed, leased, sold or used in any form or by any means, including without limitation graphic, electronic,
 * mechanical, photocopying, recording, taping or information storage and retrieval systems without Mobile-Technologies
 * Limited prior written consent. The downloading, exporting or reexporting of this computer program or any related
 * documentation or technology is subject to any export rules, including US regulations.
 * ----------------------------------------------------------------------------
 */

import '../../../../../../form/bean/i_reflect.dart';

class SoapAnnotations {
  const SoapAnnotations();

  bool isTransient(String field, Object bean) =>
      bean is IReflect ? bean.getTransientFields().contains(field) : false;

  String getPropertyName(String field, Object bean) {
    if (bean is IReflect) {
      Map<String, String> propertyMap = bean.getPropertyMap();
      return propertyMap.containsKey(field) ? propertyMap[field] : field;
    }

    return field;
  }

  String getEntryName(String field, Object bean) {
    if (bean is IReflect) {
      Map<String, String> entryMap = bean.getEntryMap();
      return entryMap.containsKey(field) ? entryMap[field] : field;
    }

    return field;
  }
}
