/*
 * ----------------------------------------------------------------------------
 * Copyright © 2009 by Mobile-Technologies Limited. All rights reserved. All intellectual property rights in and/or in
 * the computer program and its related documentation and technology are the sole Mobile-Technologies Limited property.
 * This computer program is under Mobile-Technologies Limited copyright and cannot be in whole or in part reproduced,
 * sublicensed, leased, sold or used in any form or by any means, including without limitation graphic, electronic,
 * mechanical, photocopying, recording, taping or information storage and retrieval systems without Mobile-Technologies
 * Limited prior written consent. The downloading, exporting or reexporting of this computer program or any related
 * documentation or technology is subject to any export rules, including US regulations.
 * ----------------------------------------------------------------------------
 */

import '../../../../../../form/bean/server_response.dart';
import '../../../../../../form/bean/server_response_metadata.dart';
import '../../../../../generator/reader/xml_reader.dart';
import '../../../../../util/map_utils.dart';
import '../../../../../util/utils.dart';

// We don't have to do all the details as in SoapDeserializer.java
// We can't do reflection in Flutter.
// We simply convert SOAP response to Map and then transform it to ServerResponse.
// We don't have to implement a generic function to handle all sorts of Objects.
// Response from server is always compliant to ServerResponse bean.
class SoapDeserializer {
  const SoapDeserializer._();

  static ServerResponse deserialize(String soap) {
    final Map<String, dynamic> map =
        Utils.isBlank(soap) ? null : XmlReader.toMap(soap);
    // findValueByKey() will do same as map['Envelope']['Body']['loginResponse']['return'];
    // but since 'loginResponse' will never be the same, we have to find 'result' entry
    return ServerResponseMetaData.toBean(
        MapUtils.findValueByKey('return', map));
  }
}
