/*
 * ----------------------------------------------------------------------------
 * Copyright © 2009 by Mobile-Technologies Limited. All rights reserved. All intellectual property rights in and/or in
 * the computer program and its related documentation and technology are the sole Mobile-Technologies Limited property.
 * This computer program is under Mobile-Technologies Limited copyright and cannot be in whole or in part reproduced,
 * sublicensed, leased, sold or used in any form or by any means, including without limitation graphic, electronic,
 * mechanical, photocopying, recording, taping or information storage and retrieval systems without Mobile-Technologies
 * Limited prior written consent. The downloading, exporting or reexporting of this computer program or any related
 * documentation or technology is subject to any export rules, including US regulations.
 * ----------------------------------------------------------------------------
 */

import '../../../../util/form_utils.dart';
import '../../../../util/utils.dart';
import '../../../../validation/converter/c_boolean.dart';
import '../../component/behavior/i_value.dart';
import '../../component/tick_box.dart';
import '../on_value_change_listener.dart';

class CTickBox {
  const CTickBox._();

  static void setVal(Object val, TickBox tickbox, IValue<bool> iValue,
      OnValueChangeListener onValueChange) {
    bool newVal = Utils.isBlank(val) ? CBoolean.NO : CBoolean.convertNoErr(val);

    if (newVal != null) {
      bool oldVal = tickbox.getVal() as bool;

      // ensure value change
      if (oldVal != newVal) {
        iValue.setValue(newVal);
        FormUtils.fireOnValueChange__(newVal, false, onValueChange);
      }
    }
  }
}
