/*
 * ----------------------------------------------------------------------------
 * Copyright © 2009 by Mobile-Technologies Limited. All rights reserved. All intellectual property rights in and/or in
 * the computer program and its related documentation and technology are the sole Mobile-Technologies Limited property.
 * This computer program is under Mobile-Technologies Limited copyright and cannot be in whole or in part reproduced,
 * sublicensed, leased, sold or used in any form or by any means, including without limitation graphic, electronic,
 * mechanical, photocopying, recording, taping or information storage and retrieval systems without Mobile-Technologies
 * Limited prior written consent. The downloading, exporting or reexporting of this computer program or any related
 * documentation or technology is subject to any export rules, including US regulations.
 * ----------------------------------------------------------------------------
 */

import '../../structure/ui/method/method.dart';

class MethodState {
  final Method method;

  int attempts = 0;
  Map<String, Object>
      lastPreparedData; // ever changing properties are excluded in it

  MethodState(this.method);

  Method getMethod() {
    return method;
  }

  String getName() {
    return method.isStandardRmi() ? "standardRmi" : method.getName();
  }

  bool isBlocked() {
    final int maxAttempts = method.getMaxAttempts();
    return maxAttempts > 0 && attempts >= maxAttempts;
  }

  void resetAttempts() {
    attempts = 0;
  }

  void incrementAttempt() {
    attempts++;
    setLastPreparedData(null);
  }

  Map<String, Object> getLastPreparedData() {
    return lastPreparedData;
  }

  void setLastPreparedData(Map<String, Object> lastPreparedData) {
    this.lastPreparedData = lastPreparedData;
  }

  @override
  String toString() => method.toString();
}
