/*
 * ----------------------------------------------------------------------------
 * Copyright © 2009 by Mobile-Technologies Limited. All rights reserved. All intellectual property rights in and/or in
 * the computer program and its related documentation and technology are the sole Mobile-Technologies Limited property.
 * This computer program is under Mobile-Technologies Limited copyright and cannot be in whole or in part reproduced,
 * sublicensed, leased, sold or used in any form or by any means, including without limitation graphic, electronic,
 * mechanical, photocopying, recording, taping or information storage and retrieval systems without Mobile-Technologies
 * Limited prior written consent. The downloading, exporting or reexporting of this computer program or any related
 * documentation or technology is subject to any export rules, including US regulations.
 * ----------------------------------------------------------------------------
 */

import '../../../util/utils.dart';
import '../component/message.dart';
import '../form_controller.dart';
import '../renderer/component_factory.dart';

// Can't use internationalized messages here since renderer won't be initialized.
class ErrorPage {
  const ErrorPage._();

  static Message creation<T extends FormController>(
      String msg, StackTrace e, ComponentFactory<T> factory) {
    return custom('$msg\n\n${Utils.getStackTrace(e)}', factory);
  }

  static Message creation_<T extends FormController>(
      ComponentFactory<T> factory) {
    return custom("Couldn't create the form due to unknown reason", factory);
  }

  static Message custom<T extends FormController>(
      String msg, ComponentFactory<T> factory) {
    Message msgErr = factory.message();
    msgErr.setFormMsg(msg);
    return msgErr;
  }
}
