/*
 * ----------------------------------------------------------------------------
 * Copyright © 2009 by Mobile-Technologies Limited. All rights reserved. All intellectual property rights in and/or in
 * the computer program and its related documentation and technology are the sole Mobile-Technologies Limited property.
 * This computer program is under Mobile-Technologies Limited copyright and cannot be in whole or in part reproduced,
 * sublicensed, leased, sold or used in any form or by any means, including without limitation graphic, electronic,
 * mechanical, photocopying, recording, taping or information storage and retrieval systems without Mobile-Technologies
 * Limited prior written consent. The downloading, exporting or reexporting of this computer program or any related
 * documentation or technology is subject to any export rules, including US regulations.
 * ----------------------------------------------------------------------------
 */

import '../../../config/defaults.dart';
import '../../../enums/view_type.dart';
import '../../../generator/reader/json_reader.dart';
import '../../../structure/root_tag.dart';
import '../../../structure/ui/view.dart';
import '../renderer/params/renderer_params.dart';

class RawPage {
  const RawPage._();

  /// TabPanel containing three tabs to show UI, model and i18n in different labels.
  static List<View> create(RendererParams params) {
    JsonReader reader = JsonReader();
    List<View> tabs = [
      View.layout("tab1", ViewType.TAB, "UI",
          getLabel(Defaults.UI, params.getBaseUI(), reader)),
      View.layout("tab2", ViewType.TAB, "Model",
          getLabel(Defaults.MODEL, params.getModel(), reader)),
      View.layout("tab3", ViewType.TAB, "I18n",
          getLabel(Defaults.I18N, params.getI18n(), reader))
    ];
    return [View.layout("tabPanel", ViewType.TABPANEL, null, tabs)];
  }

  static List<View> getLabel(String id, RootTag tag, JsonReader reader) {
    return []; // FIXME
    // try (ByteArrayOutputStream outputStream = ByteArrayOutputStream()) {
    //     tag.toList(); // we wouldn't need this if there was no form caching
    //
    //     reader.write(tag, outputStream);
    //     return [View(id, ViewType.LABEL, Utils.toUtf8(outputStream.toByteArray()), ""))];
    // }
  }
}
