/*
 * ----------------------------------------------------------------------------
 * Copyright © 2009 by Mobile-Technologies Limited. All rights reserved. All intellectual property rights in and/or in
 * the computer program and its related documentation and technology are the sole Mobile-Technologies Limited property.
 * This computer program is under Mobile-Technologies Limited copyright and cannot be in whole or in part reproduced,
 * sublicensed, leased, sold or used in any form or by any means, including without limitation graphic, electronic,
 * mechanical, photocopying, recording, taping or information storage and retrieval systems without Mobile-Technologies
 * Limited prior written consent. The downloading, exporting or reexporting of this computer program or any related
 * documentation or technology is subject to any export rules, including US regulations.
 * ----------------------------------------------------------------------------
 */

import '../../config/defaults.dart';

class Dimension {
  final int width;
  final int height;

  const Dimension(this.width, this.height);

  @override
  int get hashCode => 31 * (31 + height) + width;

  @override
  bool operator ==(Object obj) {
    if (identical(this, obj)) {
      return true;
    }

    if (obj == null || runtimeType != obj.runtimeType) {
      return false;
    }

    Dimension other = obj;
    return width == other.width && height == other.height;
  }

  @override
  String toString() =>
      "Dimension [${Defaults.WIDTH}=$width, ${Defaults.HEIGHT}=$height]";
}
