/*
 * ----------------------------------------------------------------------------
 * Copyright © 2009 by Mobile-Technologies Limited. All rights reserved. All intellectual property rights in and/or in
 * the computer program and its related documentation and technology are the sole Mobile-Technologies Limited property.
 * This computer program is under Mobile-Technologies Limited copyright and cannot be in whole or in part reproduced,
 * sublicensed, leased, sold or used in any form or by any means, including without limitation graphic, electronic,
 * mechanical, photocopying, recording, taping or information storage and retrieval systems without Mobile-Technologies
 * Limited prior written consent. The downloading, exporting or reexporting of this computer program or any related
 * documentation or technology is subject to any export rules, including US regulations.
 * ----------------------------------------------------------------------------
 */

import '../../../../form/structure/string_object_map.dart';
import '../../../validation/converter/c_float.dart';
import '../../utils.dart';
import 'range.dart';

class FloatRange extends Range<double> {
  FloatRange(double min, double max) : super(min, max);

  static FloatRange min_(double min) {
    return get_(min, null);
  }

  static double min__(FloatRange range) {
    return range == null ? null : range.min;
  }

  static FloatRange max_(double max) {
    return get_(null, max);
  }

  static double max__(FloatRange range) {
    return range == null ? null : range.max;
  }

  static FloatRange fixed(double minAndMax) {
    return get_(minAndMax, minAndMax);
  }

  static FloatRange get(String minKey, String maxKey, StringObjectMap map) {
    return get_(
        CFloat.convertNoErr(map[minKey]), CFloat.convertNoErr(map[maxKey]));
  }

  static FloatRange get_(double min, double max) {
    return Utils.allNull([min, max]) ? null : FloatRange(min, max);
  }
}
