/*
 * ----------------------------------------------------------------------------
 * Copyright © 2009 by Mobile-Technologies Limited. All rights reserved. All intellectual property rights in and/or in
 * the computer program and its related documentation and technology are the sole Mobile-Technologies Limited property.
 * This computer program is under Mobile-Technologies Limited copyright and cannot be in whole or in part reproduced,
 * sublicensed, leased, sold or used in any form or by any means, including without limitation graphic, electronic,
 * mechanical, photocopying, recording, taping or information storage and retrieval systems without Mobile-Technologies
 * Limited prior written consent. The downloading, exporting or reexporting of this computer program or any related
 * documentation or technology is subject to any export rules, including US regulations.
 * ----------------------------------------------------------------------------
 */

import '../../../../form/structure/string_object_map.dart';
import '../../../validation/converter/c_number.dart';
import '../../utils.dart';
import 'range.dart';

class IntRange extends Range<int> {
  IntRange(int min, int max) : super(min, max);

  static IntRange min_(int min) {
    return get_(min, null);
  }

  static int min__(IntRange range) {
    return range == null ? null : range.min;
  }

  static IntRange max_(int max) {
    return get_(null, max);
  }

  static int max__(IntRange range) {
    return range == null ? null : range.max;
  }

  static IntRange fixed(int minAndMax) {
    return get_(minAndMax, minAndMax);
  }

  static IntRange get(String minKey, String maxKey, StringObjectMap map) {
    return get_(
        CNumber.convertNoErr(map[minKey]), CNumber.convertNoErr(map[maxKey]));
  }

  static IntRange get_(int min, int max) {
    return Utils.allNull([min, max]) ? null : IntRange(min, max);
  }
}
