/*
 * ----------------------------------------------------------------------------
 * Copyright © 2009 by Mobile-Technologies Limited. All rights reserved. All intellectual property rights in and/or in
 * the computer program and its related documentation and technology are the sole Mobile-Technologies Limited property.
 * This computer program is under Mobile-Technologies Limited copyright and cannot be in whole or in part reproduced,
 * sublicensed, leased, sold or used in any form or by any means, including without limitation graphic, electronic,
 * mechanical, photocopying, recording, taping or information storage and retrieval systems without Mobile-Technologies
 * Limited prior written consent. The downloading, exporting or reexporting of this computer program or any related
 * documentation or technology is subject to any export rules, including US regulations.
 * ----------------------------------------------------------------------------
 */

import 'dart:math' show Random;

class CaptchaUtils {
  static const List<String> CHARS = [
    'a',
    'b',
    'c',
    'd',
    'e',
    'f',
    'g',
    'h',
    'i',
    'j',
    'k',
    'l',
    'm',
    'n',
    'o',
    'p',
    'q',
    'r',
    's',
    't',
    'u',
    'v',
    'w',
    'x',
    'y',
    'z',
    '0',
    '1',
    '2',
    '3',
    '4',
    '5',
    '6',
    '7',
    '8',
    '9',
    'A',
    'B',
    'C',
    'D',
    'E',
    'F',
    'G',
    'H',
    'I',
    'J',
    'K',
    'L',
    'M',
    'N',
    'O',
    'P',
    'Q',
    'R',
    'S',
    'T',
    'U',
    'V',
    'W',
    'X',
    'Y',
    'Z'
  ];
  static final int LENGTH = CHARS.length;

  const CaptchaUtils._();

  /// Generate Length between 5 and 8.
  static int randomLength() {
    return 5 + (Random().nextInt(1000) % 4).abs();
  }

  static String generate() {
    return generate_(randomLength());
  }

  /// Generate a CAPTCHA String consisting of random lower case & upper case letters, and numbers.
  static String generate_(int length) {
    StringBuffer captcha = StringBuffer();
    Random random = Random();

    for (int i = 0; i < length; i++) {
      // Generate the Random Character between 0 to 61.
      // NOTE: Take abs value, because there may be ArrayIndexOutOfBoundsException for negative number
      captcha.write(CHARS[(random.nextInt(1000)).abs() % LENGTH]);
    }

    return captcha.toString();
  }
}
