/*
 * ----------------------------------------------------------------------------
 * Copyright © 2009 by Mobile-Technologies Limited. All rights reserved. All intellectual property rights in and/or in
 * the computer program and its related documentation and technology are the sole Mobile-Technologies Limited property.
 * This computer program is under Mobile-Technologies Limited copyright and cannot be in whole or in part reproduced,
 * sublicensed, leased, sold or used in any form or by any means, including without limitation graphic, electronic,
 * mechanical, photocopying, recording, taping or information storage and retrieval systems without Mobile-Technologies
 * Limited prior written consent. The downloading, exporting or reexporting of this computer program or any related
 * documentation or technology is subject to any export rules, including US regulations.
 * ----------------------------------------------------------------------------
 */

import '../../enums/constraint_type.dart';
import '../../util/utils.dart';
import 'c_abstract.dart';

/// Validates that the string literal is a valid URL/URI.
class CLink extends CAbstract<String> {
  static final ConstraintType TYPE = ConstraintType.LINK;

  CLink() : super(TYPE);

  @override
  String isValid(String value) {
    if (!Utils.isBlank(value)) {
      try {
        // 1. Check for the protocol
        // 2. toURI() does the extra required checking
        // URL(value).toURI();
        Uri.parse(value);
      } catch (e) {
        return getMsgId();
      }
    }

    return null;
  }
}
