/*
 * ----------------------------------------------------------------------------
 * Copyright © 2009 by Mobile-Technologies Limited. All rights reserved. All intellectual property rights in and/or in
 * the computer program and its related documentation and technology are the sole Mobile-Technologies Limited property.
 * This computer program is under Mobile-Technologies Limited copyright and cannot be in whole or in part reproduced,
 * sublicensed, leased, sold or used in any form or by any means, including without limitation graphic, electronic,
 * mechanical, photocopying, recording, taping or information storage and retrieval systems without Mobile-Technologies
 * Limited prior written consent. The downloading, exporting or reexporting of this computer program or any related
 * documentation or technology is subject to any export rules, including US regulations.
 * ----------------------------------------------------------------------------
 */

import '../../enums/constraint_type.dart';
import '../../util/utils.dart';
import 'c_abstract.dart';

class CMandatory extends CAbstract<Object> {
  static final ConstraintType TYPE = ConstraintType.MANDATORY;

  CMandatory() : super(TYPE);

  @override
  String isValid(Object value) {
    bool invalid = value == null ||
        (value is String && Utils.isBlank(value)) ||
        (value is List<Object> && Utils.isBlank(value));
    return invalid ? getMsgId() : null;
  }

  static bool check(Object value) {
    return CAbstract.check(value, CMandatory());
  }
}
