/*
 * ----------------------------------------------------------------------------
 * Copyright © 2009 by Mobile-Technologies Limited. All rights reserved. All intellectual property rights in and/or in
 * the computer program and its related documentation and technology are the sole Mobile-Technologies Limited property.
 * This computer program is under Mobile-Technologies Limited copyright and cannot be in whole or in part reproduced,
 * sublicensed, leased, sold or used in any form or by any means, including without limitation graphic, electronic,
 * mechanical, photocopying, recording, taping or information storage and retrieval systems without Mobile-Technologies
 * Limited prior written consent. The downloading, exporting or reexporting of this computer program or any related
 * documentation or technology is subject to any export rules, including US regulations.
 * ----------------------------------------------------------------------------
 */

import '../../util/utils.dart';
import '../../validation/converter/c_binary.dart';

class CString {
  const CString._();

  static bool checkType(Object object) {
    return object is String;
  }

  static String convert(Object value) {
    if (CBinary.isBinary(value)) {
      return Utils.toUtf8NoErr(value);
    }

    return value is String || Utils.isBlank(value) ? value : value.toString();
  }
}
