/*
 * ----------------------------------------------------------------------------
 * Copyright © 2009 by Mobile-Technologies Limited. All rights reserved. All intellectual property rights in and/or in
 * the computer program and its related documentation and technology are the sole Mobile-Technologies Limited property.
 * This computer program is under Mobile-Technologies Limited copyright and cannot be in whole or in part reproduced,
 * sublicensed, leased, sold or used in any form or by any means, including without limitation graphic, electronic,
 * mechanical, photocopying, recording, taping or information storage and retrieval systems without Mobile-Technologies
 * Limited prior written consent. The downloading, exporting or reexporting of this computer program or any related
 * documentation or technology is subject to any export rules, including US regulations.
 * ----------------------------------------------------------------------------
 */

import 'package:mt_formalyze/com/mt/formalyze/bundle/base_bundle.dart';
import 'package:mt_formalyze/com/mt/formalyze/bundle/custom_bundle.dart';
import 'package:mt_formalyze/com/mt/formalyze/enums/mode.dart';
import 'package:mt_formalyze/com/mt/formalyze/ui/discrete/renderer/aggregate_bundle.dart';
import 'package:mt_formalyze/com/mt/formalyze/util/log/logger.dart';
import 'package:mt_formalyze/com/mt/formalyze/util/utils.dart';

void main() {
  CustomBundle.map = {
    "form.data.fetch.failure": {
      EN: "From custom bundle [EN].",
      AR: "From custom bundle [AR].",
    }
  };

  // language should work case-insensitively
  AggregateBundle bundle =
      AggregateBundle("Ar", CustomBundle.map, BaseBundle.map);
  // key should work case-sensitively
  Logger.debug(bundle.getMsg("FORM.data.fetch.failure"));
  Logger.debug(Utils.format(bundle.getMsg("form.permission.missing"), [Mode.CREATE]));
}
