/*
 * ----------------------------------------------------------------------------
 * Copyright © 2009 by Mobile-Technologies Limited. All rights reserved. All intellectual property rights in and/or in
 * the computer program and its related documentation and technology are the sole Mobile-Technologies Limited property.
 * This computer program is under Mobile-Technologies Limited copyright and cannot be in whole or in part reproduced,
 * sublicensed, leased, sold or used in any form or by any means, including without limitation graphic, electronic,
 * mechanical, photocopying, recording, taping or information storage and retrieval systems without Mobile-Technologies
 * Limited prior written consent. The downloading, exporting or reexporting of this computer program or any related
 * documentation or technology is subject to any export rules, including US regulations.
 * ----------------------------------------------------------------------------
 */

import 'dart:typed_data' show Uint8List;

import 'package:mt_formalyze/com/mt/formalyze/config/config.dart';
import 'package:mt_formalyze/com/mt/formalyze/util/cipher/algorithm.dart';
import 'package:mt_formalyze/com/mt/formalyze/util/cipher/cypher.dart';
import 'package:mt_formalyze/com/mt/formalyze/util/cipher/des.dart';
import 'package:mt_formalyze/com/mt/formalyze/util/io_utils.dart';
import 'package:mt_formalyze/com/mt/formalyze/util/log/logger.dart';
import 'package:mt_formalyze/com/mt/formalyze/util/stop_watch.dart';
import 'package:mt_formalyze/com/mt/formalyze/util/utils.dart';

void main() {
  Config.DEBUG = true;
  const String filePath =
      'D:/DevEnv/workspaceAndroid/mt_formalyze/test/resources/Twinkle.jpg';

  Cypher cypher = Cypher(Algorithm.DES128);
  Logger.debug(Utils.toString_(cypher.decrypt_(cypher.encrypt('Hello World'))));
  cypher.encryptFile(filePath);
  cypher.decryptFile(filePath);

  desTest(filePath); // directly use DES utility
}

void desTest(String filePath) {
  DES des = DES(Utils.toBytes(Algorithm.DES128.key));
  process(filePath, true, des);
  process(filePath, false, des);
}

void process(String filePath, bool encrypt, DES des) {
  Logger.debug("${encrypt ? 'Encrypt' : 'Decrypt'}ing file '$filePath'");
  Uint8List content = IOUtils.readFile(filePath);
  StopWatch stopWatch = StopWatch.start();
  content = encrypt ? des.encrypt(content) : des.decrypt(content);
  StopWatch.stop(stopWatch);
  IOUtils.writeFileNoErr(content, filePath);
}
