/*
 * ----------------------------------------------------------------------------
 * Copyright © 2009 by Mobile-Technologies Limited. All rights reserved. All intellectual property rights in and/or in
 * the computer program and its related documentation and technology are the sole Mobile-Technologies Limited property.
 * This computer program is under Mobile-Technologies Limited copyright and cannot be in whole or in part reproduced,
 * sublicensed, leased, sold or used in any form or by any means, including without limitation graphic, electronic,
 * mechanical, photocopying, recording, taping or information storage and retrieval systems without Mobile-Technologies
 * Limited prior written consent. The downloading, exporting or reexporting of this computer program or any related
 * documentation or technology is subject to any export rules, including US regulations.
 * ----------------------------------------------------------------------------
 */

import 'dart:io';

import 'package:mt_formalyze/com/mt/formalyze/ui/discrete/action/handler/rmi/mpos_http_transport_se.dart';
import 'package:mt_formalyze/com/mt/formalyze/util/log/logger.dart';

Future<void> main() async {
  await startServer();
}

Future<void> startServer() async {
  final HttpServer server =
      await HttpServer.bind(InternetAddress.loopbackIPv4, 4040);

  Logger.debug('Server started: ${server.address} port ${server.port}');

  await for (HttpRequest request in server) {
    switch (request.method) {
      case MposHttpTransportSE.REQ_METHOD_GET:
        handleGet(request);
        break;
      default:
        request.response
          ..write("HTTP method isn't supported")
          ..close();
    }
  }
}

void handleGet(HttpRequest request) {
  request.response
    ..write('MT Flutter App is up and running @${DateTime.now()}')
    ..close();
}
