/*
 * ----------------------------------------------------------------------------
 * Copyright © 2009 by Mobile-Technologies Limited. All rights reserved. All intellectual property rights in and/or in
 * the computer program and its related documentation and technology are the sole Mobile-Technologies Limited property.
 * This computer program is under Mobile-Technologies Limited copyright and cannot be in whole or in part reproduced,
 * sublicensed, leased, sold or used in any form or by any means, including without limitation graphic, electronic,
 * mechanical, photocopying, recording, taping or information storage and retrieval systems without Mobile-Technologies
 * Limited prior written consent. The downloading, exporting or reexporting of this computer program or any related
 * documentation or technology is subject to any export rules, including US regulations.
 * ----------------------------------------------------------------------------
 */

import 'package:mt_formalyze/com/mt/form/bean/register/mpos_info_data.dart';
import 'package:mt_formalyze/com/mt/form/structure/string_object_map.dart';
import 'package:mt_formalyze/com/mt/formalyze/generator/reader/json_reader.dart';
import 'package:mt_formalyze/com/mt/formalyze/structure/i18n/i18n.dart';
import 'package:mt_formalyze/com/mt/formalyze/structure/model/model.dart';
import 'package:mt_formalyze/com/mt/formalyze/structure/ui/ui.dart';
import 'package:mt_formalyze/com/mt/formalyze/util/io_utils.dart';
import 'package:mt_formalyze/com/mt/formalyze/util/log/logger.dart';
import 'package:mt_formalyze/com/mt/formalyze/util/utils.dart';

void main() {
  const String path =
      "D:/DevEnv/workspace/Development/mt-forms/isl_product/iRM3.2/1.24-SNAPSHOT/4";
  JsonReader reader = JsonReader();

  {
    String json =
        Utils.toString__(IOUtils.readFileNoErr("$path/form.model.json"), true);
    // Model model = reader.fromJson(json, Model);
    Model model = reader.readModel(json);
    Logger.debug(model);
  }

  {
    String json =
        Utils.toString__(IOUtils.readFileNoErr("$path/form.ui.json"), true);
    // UI ui = reader.fromJson(json, UI);
    UI ui = reader.readUI(json);
    Logger.debug(ui);
  }

  {
    String json =
        Utils.toString__(IOUtils.readFileNoErr("$path/form.i18n.json"), true);
    // I18n i18n = reader.fromJson(json, I18n);
    I18n i18n = reader.readI18n(json);
    Logger.debug(i18n);
  }

  {
    Logger.debug(reader.toJson(getMposInfoData()));
  }
}

MposInfoData getMposInfoData() {
  MposInfoData mposInfoData = MposInfoData();
  mposInfoData.setImei("000000");
  mposInfoData.setmPosVersionName("mPOS");
  mposInfoData.setmPosVersionCode("1");
  mposInfoData.setCellId("123");
  mposInfoData.setCellLac("456");
  mposInfoData.setCellMcc("789");
  mposInfoData.setCellMnc("012");
  mposInfoData.setAndroidVersion("KitKat");
  mposInfoData.setOfflineLogin(true);
  mposInfoData.setLatitude(123.5);
  mposInfoData.setLongitude(678.9);
  mposInfoData.setExtraInfos(StringObjectMap.fromMap({"a": "A", "b": 2}));
  return mposInfoData;
}
