/*
 * ----------------------------------------------------------------------------
 * Copyright © 2009 by Mobile-Technologies Limited. All rights reserved. All intellectual property rights in and/or in
 * the computer program and its related documentation and technology are the sole Mobile-Technologies Limited property.
 * This computer program is under Mobile-Technologies Limited copyright and cannot be in whole or in part reproduced,
 * sublicensed, leased, sold or used in any form or by any means, including without limitation graphic, electronic,
 * mechanical, photocopying, recording, taping or information storage and retrieval systems without Mobile-Technologies
 * Limited prior written consent. The downloading, exporting or reexporting of this computer program or any related
 * documentation or technology is subject to any export rules, including US regulations.
 * ----------------------------------------------------------------------------
 */

import 'package:mt_formalyze/com/mt/form/bean/mpos/base_mpos_state.dart';
import 'package:mt_formalyze/com/mt/form/bean/register/crm_form_data.dart';
import 'package:mt_formalyze/com/mt/form/bean/register/crm_form_data_metadata.dart';
import 'package:mt_formalyze/com/mt/form/bean/register/mpos_info_data.dart';
import 'package:mt_formalyze/com/mt/form/bean/register/reason.dart';
import 'package:mt_formalyze/com/mt/form/structure/string_object_map.dart';
import 'package:mt_formalyze/com/mt/formalyze/config/config.dart';
import 'package:mt_formalyze/com/mt/formalyze/ui/discrete/action/brmi.dart';
import 'package:mt_formalyze/com/mt/formalyze/ui/discrete/action/handler/rmi/soap_rmi.dart';
import 'package:mt_formalyze/com/mt/formalyze/ui/discrete/action/rmi/soap/soap_builder.dart';
import 'package:mt_formalyze/com/mt/formalyze/util/date_utils.dart';
import 'package:mt_formalyze/com/mt/formalyze/util/log/logger.dart';
import 'package:mt_formalyze/com/mt/formalyze/util/utils.dart';

void main() {
  CrmFormData crmFormData = CrmFormData();
  crmFormData.setSecurityToken(Utils.getUUID());
  crmFormData.setState(BaseMposState.PENDING_MPOS);
  crmFormData.setReasons(<Reason>[
    Reason.full('th', 'countries', 4, 'Wrong city'),
    Reason.full('pk', 'countries', 4, 'Wrong country')
  ]);
  crmFormData.setMap(StringObjectMap.fromMap({
    'name': 'MT',
    'age': 9,
    'subscriberPhoto': Utils.toBytes("Test"),
    'dob': DateUtils.now()
  }));
  crmFormData.setCreatedDateTime(DateUtils.now());
  crmFormData.setmPosInfoData(MposInfoData.full('Initial', 'v1'));

  Map<String, Object> data = {
    CrmFormDataMetaData.instanceId: 800001,
    CrmFormDataMetaData.securityToken:
        'MzcxNTc1NWYzYzJlNGQwY2I5ZTAzMWQ3MjNlY2M3MmU',
    'offlineLoginFlag': false,
    'operationName': "checkStatus",
    "uiXml": Utils.toBytes("Test"),
    SoapRMI.CRM_FORM_DATA: crmFormData
  };

  String soap = SoapBuilder().build('checkStatus', Config.NAMESPACE, data);
  soap = TestRmi('http://localhost:8080/', '', '', 120, '')
      .createEnvelope(soap, data);
  Logger.debug(soap);
}

class TestRmi extends BRMI {
  TestRmi(String endpoint, String certificate, String certificateKey,
      int timeout, String license)
      : super(endpoint, certificate, certificateKey, timeout, license);

  @override
  String getMsg(String msgId, [Object args]) {
    return msgId;
  }
}
